--***********************************************************
--**                    ROBERT JOHNSON                     **
--**       Contextual menu for building when clicking somewhere on the ground       **
--***********************************************************

ZAWISBuildMenu = {};

ZAWISBuildMenu.availableMaterialsList = {};

ZAWISBuildMenu.neededMaterials = {};
ZAWISBuildMenu.neededTools = {};

ZAWISBuildMenu.toolsList = {};
ZAWISBuildMenu.toolsText = {};
ZAWISBuildMenu.recipetext = "";

ZAWISBuildMenu.playerCarpentrySkill = 0;
ZAWISBuildMenu.playermetalworkSkill = 0;

ZAWISBuildMenu.textCarpentryRed 	           = "";
ZAWISBuildMenu.textCarpentryGreen            = "";
ZAWISBuildMenu.textMetalworkRed 	           = "";
ZAWISBuildMenu.textMetalworkGreen            = "";

--ZAWISBuildMenu._name = "";
ZAWISBuildMenu.ODescription = "";
ZAWISBuildMenu.textTooltipHeader 	           = "<RGB:0.596078431372549,0.9843137254901961,0.596078431372549>" .. getText("ContextMenu_MaterialsNeeds") .. " <LINE> ";

ZAWISBuildMenu.skillLevel =
{
	simpleObject		= 1,	-- Basic objects that don't have another category.
	simpleDecoration	= 0,	-- Generally paper stuck to a wall.
	landscaping			= 1,	-- Flower beds.

	lighting			= 4,	-- Lamp posts.

	simpleContainer		= 3,	-- Most wooden containers in the mod.
	complexContainer	= 5,	-- Difficult containers, generally stone and metal.
	advancedContainer	= 7,	-- Bar elements.

	simpleFurniture		= 3,	-- Chairs, small tables, other basic furniture.
	complexFurniture	= 4,	-- Beds, large tables, couches.

	logObject			= 0,	-- The corner for the log wall.
	floorObject			= 1,	-- Floors.
	wallObject			= 2,	-- Walls, fences, and objects that use that template.
	doorObject			= 3,	-- Doors.
	stairsObject		= 6,	-- Stairs.

	stoneArchitecture	= 7,	-- Stone walls/fences.
	metalArchitecture	= 5,	-- Metal walls/fences.
	metalCrafting	    = 1,	-- Metal walls/post and fences.
	WireArchitecture	= 7,	-- Metal wires/fences.
};

ZAWISBuildMenu.mskillLevel =
{
	simpleObject		= 1,	-- Basic objects that don't have another category.
	simpleDecoration	= 0,	-- Generally paper stuck to a wall.
	landscaping			= 1,	-- Flower beds.

	lighting			= 4,	-- Lamp posts.

	simpleContainer		= 3,	-- Most wooden containers in the mod.
	complexContainer	= 5,	-- Difficult containers, generally stone and metal.
	advancedContainer	= 7,	-- Bar elements.

	simpleFurniture		= 3,	-- Chairs, small tables, other basic furniture.
	complexFurniture	= 9,	-- Beds, large tables, couches.

	logObject			= 0,	-- The corner for the log wall.
	floorObject			= 1,	-- Floors.
	wallObject			= 2,	-- Walls, fences, and objects that use that template.
	doorObject			= 3,	-- Doors.
	stairsObject		= 6,	-- Stairs.

	stoneArchitecture	= 7,	-- Stone walls/fences.
	metalArchitecture	= 5,	-- Metal walls/fences.
	metalCrafting	    = 1,	-- Metal walls/post and fences.
	WireArchitecture	= 1,	-- Metal wires/fences.
};

ZAWISBuildMenu.healthLevel =
{
	stoneWall		= 100000,
	metalWall		= 100000,
	wireWall        = 100000,
	metalStairs		= 500,
	woodContainer	= 100,
	stoneContainer	= 200,
	metalContainer	= 400,
	wallDecoration 	= 40,
	chapaWall 	    = 800,
};

ZAWISBuildMenu.doBuildMenu = function(player, context, worldobjects, test, square, subMenu)

	ZAWISBuildMenu.playerCarpentrySkill = getSpecificPlayer(player):getPerkLevel(Perks.Woodwork);
	ZAWISBuildMenu.playermetalworkSkill = getSpecificPlayer(player):getPerkLevel(Perks.MetalWelding);

	ZAWISBuildMenu.textCarpentryRed = " <RGB:1,0,0>" .. getText("IGUI_perks_Carpentry") .. " " .. ZAWISBuildMenu.playerCarpentrySkill .. "/";
	ZAWISBuildMenu.textCarpentryGreen = " <RGB:1,1,1>" .. getText("IGUI_perks_Carpentry") .. " ";

	ZAWISBuildMenu.textMetalworkRed = " <RGB:1,0,0>" .. getText("IGUI_perks_MetalWelding") .. " " .. ZAWISBuildMenu.playermetalworkSkill .. "/";
	ZAWISBuildMenu.textMetalworkGreen = " <RGB:1,1,1>" .. getText("IGUI_perks_MetalWelding") .. " ";
	
	
	ZAWISBuildMenu.buildMaterialsList(player);
	if LGISBuildMenu then
		--nothing
	else
		----------------------------------------          Segundo Tier           ----------------------------------------------
		local _architectureOption = subMenu:addOption(getText("ContextMenu_Arquitecture"), worldobjects, nil);
		local _architectureThirdTierMenu = subMenu:getNew(subMenu);
		context:addSubMenu(_architectureOption, _architectureThirdTierMenu);

		----------------------------------------          Tercer Tier           -----------------------------------------------

		local _wallsOption = _architectureThirdTierMenu:addOption(getText("ContextMenu_Walls"), worldobjects, nil);
		local _wallsSubMenu = _architectureThirdTierMenu:getNew(_architectureThirdTierMenu);

		context:addSubMenu(_wallsOption, _wallsSubMenu);
		ZAWISBuildMenu.wallStylesMenuBuilder(_wallsSubMenu, player, context, worldobjects);
	

		--Puertas--
		local _doorsOption = _architectureThirdTierMenu:addOption(getText("ContextMenu_Doors"), worldobjects, nil);
		local _doorsSubMenu = _architectureThirdTierMenu:getNew(_architectureThirdTierMenu);

		context:addSubMenu(_doorsOption, _doorsSubMenu);
		ZAWISBuildMenu.doorsMenuBuilder(_doorsSubMenu, player, context, worldobjects);
	
		-- vallas --
		local _moreFencesOption = _architectureThirdTierMenu:addOption(getText("ContextMenu_MoreFences"), worldobjects, nil);
		local _moreFencesSubMenu = _architectureThirdTierMenu:getNew(_architectureThirdTierMenu);

		context:addSubMenu(_moreFencesOption, _moreFencesSubMenu);
		ZAWISBuildMenu.moreFencesMenuBuilder(_moreFencesSubMenu, player);
	
		local _moreFencePostsOption = _architectureThirdTierMenu:addOption(getText("ContextMenu_FencesPost"), worldobjects, nil);
		local _moreFencePostsSubMenu = _architectureThirdTierMenu:getNew(_architectureThirdTierMenu);

		context:addSubMenu(_moreFencePostsOption, _moreFencePostsSubMenu);
		ZAWISBuildMenu.moreFencePostsMenuBuilder(_moreFencePostsSubMenu, player);
		
		if LGISBuildMenu then
		
		else
			local _containersOption = subMenu:addOption(getText("ContextMenu_Containers"), worldobjects, nil);
			local _containersThirdTierMenu = subMenu:getNew(subMenu);
			context:addSubMenu(_containersOption, _containersThirdTierMenu);
			ZAWISBuildMenu.cratesMenuBuilder(_containersThirdTierMenu, player);
		end
	end

end

ZAWISBuildMenu.haveAToolToBuildWithWith = function(player)

	--  Check for tools.
	local _inventory = getSpecificPlayer(player):getInventory();
--  local _inventory = getSpecificPlayer(player):getInventory():FindAll();
	ZAWISBuildMenu.toolsList = {};
	ZAWISBuildMenu.toolsList["Hammer"] = _inventory:contains("Hammer") or _inventory:contains("HammerStone");
	ZAWISBuildMenu.toolsList["Screwdriver"] = _inventory:contains("Screwdriver");
	ZAWISBuildMenu.toolsList["HandShovel"] = _inventory:contains("HandShovel");
	ZAWISBuildMenu.toolsList["ZAWMasonryTrowel"] = _inventory:contains("ZAWMasonryTrowel");
	ZAWISBuildMenu.toolsList["BlowTorch"] = _inventory:contains("BlowTorch");
	ZAWISBuildMenu.toolsList["WeldingMask"] = _inventory:contains("WeldingMask");
	ZAWISBuildMenu.toolsList["Paintbrush"] = _inventory:contains("Paintbrush");

	-- JPM: Set the text for later use in making the tooltips.
	ZAWISBuildMenu.toolsText["Hammer"] =  getText("ContextMenu_Keep") .. " " .. getItemText("Hammer"); --.. ", " .. getItemText("Stone_Hammer");
	ZAWISBuildMenu.toolsText["Screwdriver"] = getText("ContextMenu_Keep") .. " " .. getItemText("Screwdriver");
	ZAWISBuildMenu.toolsText["HandShovel"] = getText("ContextMenu_Keep") .. " " .. getItemText("Trowel");
	ZAWISBuildMenu.toolsText["ZAWMasonryTrowel"] = getText("ContextMenu_Keep") .. " " .. getItemText("Masonry_Trowel");
	ZAWISBuildMenu.toolsText["BlowTorch"] = getText("ContextMenu_Keep") .. " " .. getItemText("Blow_Torch");
	ZAWISBuildMenu.toolsText["WeldingMask"] = getText("ContextMenu_Keep") .. " " .. getItemText("Welding_Mask");
	ZAWISBuildMenu.toolsText["Paintbrush"] = getText("ContextMenu_Keep") .. " " .. getItemText("Paint_Brush");


	--   Return true if we found any of the possible tools.
	--
	--       If cheat mode is enabled, then we don't have to worry about the hammer
	--       as the player is always considered to have something to build with.
--	if ZAWISBuildMenu.toolsList["Hammer"] or ZAWISBuildMenu.toolsList["Screwdriver"] or ZAWISBuildMenu.toolsList["HandShovel"] or ZAWISBuildMenu.toolsList["ZAWMasonryTrowel"] or (ZAWISBuildMenu.toolsList["BlowTorch"] and ZAWISBuildMenu.toolsList["WeldingMask"]) or ISBuildMenu.cheat then
	if ZAWISBuildMenu.toolsList["Hammer"] or ISBuildMenu.cheat then
		return true;
	else
		return false;
	end
end

ZAWISBuildMenu.equipToolPrimary = function(object, player, tool)

	--   Do we even have the tool?
	if ZAWISBuildMenu.toolsList[tool] then

		--   Equip the tool in the primary slot.
		ISInventoryPaneContextMenu.equipWeapon(getSpecificPlayer(player):getInventory():getItemFromType(tool), true, false, player);

		--   Stop the hammer from being equipped over this tool.
		object.noNeedHammer = true;
	end
end


ZAWISBuildMenu.equipToolSecondary = function(object, player, tool)

	--   Do we even have the tool?
	if ZAWISBuildMenu.toolsList[tool] then

		--   Equip the tool in the secondary slot.
		ISInventoryPaneContextMenu.equipWeapon(getSpecificPlayer(player):getInventory():getItemFromType(tool), false, false, player);
	end
end

ZAWISBuildMenu.buildMaterialsList = function(player)

	--   Calls up a list of what materials are in the player's square.
	--       Fortunately, there is a function in the base Project Zomboid code to
	--       handle this for us.
	--
	--       This also replaces all previously existing keys from the list so we
	--       don't have to worry about clearing the list first.  (Hopefully the
	--       LUA garbage collection does what it should with the old data.)
	ZAWISBuildMenu.availableMaterialsList = ZAWISBuildMenu.checkMaterialOnGround(getSpecificPlayer(player):getCurrentSquare());

	if ISBuildMenu.cheat then
		return true;
	end
	--   Get a list of items that are currently in the player's inventory.
    local _inventoryList = getSpecificPlayer(player):getInventory():getItems();
	local _size = _inventoryList:size();
	local _currentItemType = "";
	local _currentItem = "";


	--   Loop through the list and count up various item types.
	--       This is adding to the counts generated above from materials on the ground.
	--       The process is basically what buildUtil.checkMaterialOnGround uses.
	for i = 0, _size - 1 do
		_CurrentItem = _inventoryList:get(i);
		_currentItemType = _inventoryList:get(i):getType();

		if ZAWISBuildMenu.availableMaterialsList[_currentItemType] then
			--   Add one to the count of an existing entry.
			--ZAWISBuildMenu.availableMaterialsList[_currentItemType] = ZAWISBuildMenu.availableMaterialsList[_currentItemType] + 1;
			if instanceof(_CurrentItem, "DrainableComboItem") then
                local drainable = getSpecificPlayer(player):getInventory():getItemFromType(_currentItemType);
                local useLeft = 0;
                if drainable then
                    useLeft = math.floor(drainable:getUsedDelta()/drainable:getUseDelta());
                    ZAWISBuildMenu.availableMaterialsList[_currentItemType] = ZAWISBuildMenu.availableMaterialsList[_currentItemType] + useLeft;
                end
            else
				-- Snake:  Add one to the count of an existing entry.
				ZAWISBuildMenu.availableMaterialsList[_currentItemType] = ZAWISBuildMenu.availableMaterialsList[_currentItemType] + 1;
			end
		else
			if instanceof(_CurrentItem, "DrainableComboItem") then
                local drainable = getSpecificPlayer(player):getInventory():getItemFromType(_currentItemType);
                local useLeft = 0;
                if drainable then
                    useLeft = math.floor(drainable:getUsedDelta()/drainable:getUseDelta());
                    ZAWISBuildMenu.availableMaterialsList[_currentItemType] = useLeft;
                end
            else
			-- Snake:  Add a new entry.
				ZAWISBuildMenu.availableMaterialsList[_currentItemType] = 1;
			end
			--   Add a new entry.
			--ZAWISBuildMenu.availableMaterialsList[_currentItemType] = 1;
		end
	end
end

ZAWISBuildMenu.tooltipCheckForMaterial = function(materialRequired, amountNeeded, materialText, tooltip)
	if amountNeeded > 0 then
		local _thisItemCount = 0;

		--  How much of the required material is available?
		if ZAWISBuildMenu.availableMaterialsList[materialRequired] then
			_thisItemCount = ZAWISBuildMenu.availableMaterialsList[materialRequired];
		else
			_thisItemCount = 0;
		end

		--  Do we have enough material?
		if _thisItemCount < amountNeeded then
			tooltip.description = tooltip.description .. " <RGB:1,0,0>" .. materialText .. " " .. _thisItemCount .. "/" .. amountNeeded .. " <LINE>";
			return false;
		else
			tooltip.description = tooltip.description .. " <RGB:1,1,1>" .. materialText .. " " .. _thisItemCount .. "/" .. amountNeeded .. " <LINE>";
			return true;
		end
	end

	return true;
end

ZAWISBuildMenu.tooltipCheckForTool = function(tool, tooltip)
	if ZAWISBuildMenu.toolsList and ZAWISBuildMenu.toolsList[tool] then
		tooltip.description = tooltip.description .. " <RGB:1,1,1>" .. ZAWISBuildMenu.toolsText[tool] .. " <LINE>";
		return true;
	else
		tooltip.description = tooltip.description .. " <RGB:1,0,0>" .. ZAWISBuildMenu.toolsText[tool] .. " <LINE>";
		return false;
	end
end

ZAWISBuildMenu.canBuildObject = function(recipeknown, carpentrySkillRequired, metalworkSkillRequired, option, player)

	--   Create a tooltip and add it to our current menu option.
	local _tooltip = ISToolTip:new();
	_tooltip:initialise();
	_tooltip:setVisible(false);
	option.toolTip = _tooltip;

	--   This will be changed to false if we cannot build.
	local _canBuildResult = true;
	
	if ISBuildMenu.cheat then
		_tooltip.description = "<RGB:1,1,0>" .. ZAWISBuildMenu.ODescription;
		return _tooltip;
	end	
	if recipeknown ~= nil then
		local recipes = getSpecificPlayer(player):getKnownRecipes();
		if recipeknown ~= "NONE" then
			if not recipes:contains(recipeknown) then
				_canBuildResult = false;
			else
				-- Snake:  This will be changed to false if we cannot build.
				_canBuildResult = true;
			end
		else
			_canBuildResult = true;
		end
		if recipes:contains(recipeknown) or recipeknown == "NONE" then
		--_tooltip:setName(ZAWISBuildMenu._name);
		--   Start with the default header.
			_tooltip.description = "<RGB:1,1,0>" .. ZAWISBuildMenu.ODescription .. "<LINE> <LINE>" .. ZAWISBuildMenu.textTooltipHeader;

		
			--   Loop through the materials needed for this tooltip and let each one
			--       be tested and the tooltip updated based on if there is enough or not.
			--
			--       From my web research, LUA will handle things fine if the neededMaterials
			--       table is currently empty.  LUA skips the do-end block of code.
			--
			--       If the necessary entries for "Material", "Amount", and "Text" are not
			--       provided, that line of the tooltip is not built out and the object will
			--       not be available for building.
			local _currentResult = true;

			for _, _currentMaterial in pairs(ZAWISBuildMenu.neededMaterials) do
				if _currentMaterial["Material"] and _currentMaterial["Amount"] and _currentMaterial["Text"] then
					_currentResult = ZAWISBuildMenu.tooltipCheckForMaterial(_currentMaterial["Material"], _currentMaterial["Amount"], _currentMaterial["Text"], _tooltip);
				else
					_tooltip.description = _tooltip.description .. " <RGB:1,0,0>" .. getText("Tooltip_canterror") .. "<LINE>";
					_canBuildResult = false;
				end

				if not _currentResult then
					_canBuildResult = false;
				end
			end

			_tooltip.description = _tooltip.description .. " <LINE> <RGB:0.596078431372549,0.9843137254901961,0.596078431372549>" .. getText("ContextMenu_ToolsRequire") .. " <LINE>";

			--   Make sure we have the required tools.
			for _, _currentTool in pairs(ZAWISBuildMenu.neededTools) do
				_currentResult = ZAWISBuildMenu.tooltipCheckForTool(_currentTool, _tooltip);

				if not _currentResult then
					_canBuildResult = false;
				end
			end


			if carpentrySkillRequired > 0 or metalworkSkillRequired > 0 then
				_tooltip.description = _tooltip.description .. " <LINE> <RGB:0.596078431372549,0.9843137254901961,0.596078431372549>" .. getText("ContextMenu_SkillRequire") .. " <LINE>";
			end
			--   Check the required carpentry skill.
			if carpentrySkillRequired > 0 then
				if ZAWISBuildMenu.playerCarpentrySkill < carpentrySkillRequired then
					_tooltip.description = _tooltip.description .. ZAWISBuildMenu.textCarpentryRed;
					_canBuildResult = false;
				else
					_tooltip.description = _tooltip.description .. ZAWISBuildMenu.textCarpentryGreen;
				end

				_tooltip.description = _tooltip.description .. carpentrySkillRequired .. " <LINE>";
			end

			if metalworkSkillRequired > 0 then
				if ZAWISBuildMenu.playermetalworkSkill < metalworkSkillRequired then
					_tooltip.description = _tooltip.description .. ZAWISBuildMenu.textMetalworkRed;
					_canBuildResult = false;
				else
					_tooltip.description = _tooltip.description .. ZAWISBuildMenu.textMetalworkGreen;
				end

				_tooltip.description = _tooltip.description .. metalworkSkillRequired .. " <LINE>";
			end
			if recipeknown ~= "NONE" then
				ZAWISBuildMenu.recipetext = getText("Tooltip_" .. recipeknown)
				if not recipes:contains(recipeknown) then
					tooltip.description = tooltip.description .. " <LINE> <LINE>" .. " <RGB:1,1,1>" .. getText("Tooltip_needknownrecipe") .. " " .. " <RGB:1,0,0>" .. ZAWISBuildMenu.recipetext;
					_canBuildResult = false;
				else
					tooltip.description = tooltip.description .. " <LINE>" .. " <RGB:1,1,1>" .. getText("Tooltip_needknownrecipe") .. " " .. " <RGB:0,1,0>" .. ZAWISBuildMenu.recipetext .. getText("Tooltip_alreadyknownrecipe");
				end
			end
		end

	end
	--   If any item failed to count up, of if the player does not have a high
	--       enough carpentry skill, then we don't want this menu tooltip to be active.
	--
	--       If cheat mode is enabled, then we don't have to worry about materials
	--       or skill as the player is always considered to be able to build.
	if not _canBuildResult and not ISBuildMenu.cheat then
		option.onSelect = nil;
		option.notAvailable = true;
	end


	return _tooltip;
end

function ZAWISBuildMenu.checkMaterialOnGround(squareToCheck)
	local result = {};
	for x=squareToCheck:getX()-1,squareToCheck:getX()+1 do
		for y=squareToCheck:getY()-1,squareToCheck:getY()+1 do
			local square = getCell():getGridSquare(x,y,squareToCheck:getZ());
			local wobs = square and square:getWorldObjects() or nil

			if wobs ~= nil then
				for i = 0, wobs:size()-1 do
					local o = wobs:get(i);
					if instanceof(o, "IsoWorldInventoryObject") then
						local item = o:getItem()
						if instanceof(item, "InventoryContainer") and not item:getInventory():getItems():isEmpty() then
							-- ignore non-empty containers
						elseif result[item:getType()] then
							if instanceof(item, "DrainableComboItem") then
								--local drainable = o:getContainer():getItemFromType(item:getType());
								--local useLeft = 0;
								--if drainable then
									local useLeft = math.floor(item:getUsedDelta()/item:getUseDelta());
									result[item:getType()] = result[item:getType()] + useLeft;
								--end
							else
								result[item:getType()] = result[item:getType()] + 1;
							end
						else
							if instanceof(item, "DrainableComboItem") then
								--local drainable = o:getContainer():getItemFromType(item:getType());
								--local useLeft = 0;
								--if drainable then
									local useLeft = math.floor(item:getUsedDelta()/item:getUseDelta());
									result[item:getType()] = useLeft;
								--end
							else
								result[item:getType()] = 1;
							end
						end
					end
				end
			end
		end
	end
	return result;
end

ZAWISBuildMenu.wallStylesMenuBuilder = function (subMenu, player, context, worldobjects)

	--   Create the styles to be listed under the Walls submenu.  The table will be
	--       used so that each style has access to its particular submenu under Walls.
	local _stylesOptions = {};
	local _stylesSubMenus = {};
	local _styleList;
	if LGISBuildMenu then
		_styleList = {
		getText("ContextMenu_WhiteWood"),
		getText("ContextMenu_RedBarnWood"),
		getText("ContextMenu_GrayCinderBlock"),
		getText("ContextMenu_WhiteCinderBlock"),
		getText("ContextMenu_BrownCinderBlock"),
		--getText("ContextMenu_RedBrick"),
		--getText("ContextMenu_LOrangeBrick"),
		--getText("ContextMenu_OrangeBrick"),
		--getText("ContextMenu_DRedBrick"),
		};	
	else
		_styleList = {
		getText("ContextMenu_AdvancedFrames"),
		getText("ContextMenu_WhiteWood"),
		getText("ContextMenu_RedBarnWood"),
		getText("ContextMenu_GrayCinderBlock"),
		getText("ContextMenu_WhiteCinderBlock"),
		getText("ContextMenu_BrownCinderBlock"),
		--getText("ContextMenu_RedBrick"),
		--getText("ContextMenu_LOrangeBrick"),
		--getText("ContextMenu_OrangeBrick"),
		--getText("ContextMenu_DRedBrick"),
		};
	end

	for _, _style in pairs(_styleList) do
		_stylesOptions[_style] = subMenu:addOption(_style, worldobjects, nil);
		_stylesSubMenus[_style] = subMenu:getNew(subMenu);
		context:addSubMenu(_stylesOptions[_style], _stylesSubMenus[_style]);
	end

	--   Build the individual submenus.  Each of these functions will fill in their
	--       specific world object type under the correct sytle.  So, under an entry listed
	--       in _styleList, you will have a wall, a pillar, a door frame, et cetera.
	--
	--       Some styles lack matching fence styles, so no fence or fence post will be added
	--       to that style's submenu.
	ZAWISBuildMenu.wallsMenuBuilder(_stylesSubMenus, player);
	ZAWISBuildMenu.pillarsMenuBuilder(_stylesSubMenus, player);
	ZAWISBuildMenu.doorFramesMenuBuilder(_stylesSubMenus, player);
	if LGISBuildMenu then

	else
		ZAWISBuildMenu.windowFramesMenuBuilder(_stylesSubMenus, player);
	end
	--ZAWISBuildMenu.fencesMenuBuilder(_stylesSubMenus, player);
	--ZAWISBuildMenu.fencePostsMenuBuilder(_stylesSubMenus, player);
end

ZAWISBuildMenu.wallsMenuBuilder = function(subMenu, player)
	local _sprite = nil;
	local _option = nil;
	local _tooltip = nil;
	local _name = "";
	local _choice = "";
	--ZAWISBuildMenu._name = _name;

	if LGISBuildMenu then
	
	else
		--  Setting the materials once for the following objects as they all use
		--      the same materials list to build with.

		----------------------------------------------------------------------------------
		--
		-- Advanced Metal Frame
		--

		ZAWISBuildMenu.neededMaterials =
		{
			{
				Material = "Screws", Amount = 10, Text = getItemText("Screws"),
			},

			{
				Material = "MetalPipe", Amount = 4, Text = getItemText("Metal_Pipe"),
			},

			{
				Material = "Wire", Amount = 1, Text = getItemText("Wire") .. " " .. getText("Tooltip_Uses"),
			},
		};

		ZAWISBuildMenu.neededTools = { "Hammer",};
		ZAWISBuildMenu.ODescription = getText("Tooltip_craft_AdvancedMetalWallFramedesc");

		_sprite = {};
		_sprite.sprite = "walls_exterior_zaw_01_0";
		_sprite.northSprite = "walls_exterior_zaw_01_1";
		_sprite.corner = "walls_exterior_zaw_01_2";
		_choice = 3;
		_name = getText("ContextMenu_AdvancedMetalWallFrame");
		_option = subMenu[getText("ContextMenu_AdvancedFrames")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenWall, _sprite, player, _name, _choice);
		
		_tooltip = ZAWISBuildMenu.canBuildObject("Advanced metal frames", 8, 2, _option, player);
		_tooltip:setName(_name);

		_tooltip:setTexture(_sprite.sprite);
	end

	----------------------------------------------------------------------------------
	--
	-- Red Barnwood Wall
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 3, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 3, Text = getItemText("Nails"),
		},

		{
			Material = "PaintRed", Amount = 1, Text = getItemText("Red_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = { "Hammer", "Paintbrush",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_RedWallDesc");

	_sprite = {};
	_sprite.sprite = "walls_exterior_wooden_01_0";
	_sprite.northSprite = "walls_exterior_wooden_01_1";
	_sprite.corner = "walls_exterior_wooden_01_3";
	_choice = 1;
	_name = getText("ContextMenu_Red_BarnWood_Wall");
	_option = subMenu[getText("ContextMenu_RedBarnWood")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenWall, _sprite, player, _name, _choice);
	
	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", ZAWISBuildMenu.skillLevel.wallObject, 0, _option, player);
	_tooltip:setName(_name);

	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- White Wood Wall
	--
	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 3, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 3, Text = getItemText("Nails"),
		},

		{
			Material = "PaintWhite", Amount = 1, Text = getItemText("White_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};
	
	ZAWISBuildMenu.ODescription = getText("ContextMenu_WhiteWallDesc");

	_sprite = {};
	_sprite.sprite = "walls_exterior_wooden_02_0";
	_sprite.northSprite = "walls_exterior_wooden_02_1";
	_sprite.corner = "walls_exterior_wooden_02_3";
	_choice = 2;
	_name = getText("ContextMenu_White_Wood_Wall");

	_option = subMenu[getText("ContextMenu_WhiteWood")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenWall, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", ZAWISBuildMenu.skillLevel.wallObject, 0, _option, player);
	_tooltip:setName(_name);

	_tooltip:setTexture(_sprite.sprite);

	---------------------------------------------------------------------------------


	----------------------------------------------------------------------------------
	--
	--  Brown Cinder Block Wall
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "ZAWConcreteBrick", Amount = 10, Text = getItemText("Concrete_Brick"),
		},

		{
			Material = "BucketConcreteFull", Amount = 1, Text = getItemText("Bucket_of_Concrete") .. " " .. getText("Tooltip_Uses"),
		},
	
		{
			Material = "PaintBrown", Amount = 1, Text = getItemText("Brown_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = { "ZAWMasonryTrowel", "Paintbrush", };
	
	ZAWISBuildMenu.ODescription = getText("ContextMenu_CinderBlockWallDesc");

	_sprite = {};
	_sprite.sprite = "walls_commercial_03_0";
	_sprite.northSprite = "walls_commercial_03_1";
	_sprite.corner = "walls_commercial_03_3";
	_choice = 1;
	_name = getText("ContextMenu_Brown_Cinder_Block_Wall");

	_option = subMenu[getText("ContextMenu_BrownCinderBlock")]:addOption(_name, nil, ZAWISBuildMenu.onBuildStoneWall, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 7, 0, _option, player);
	_tooltip:setName(_name);

	_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	--  Gray Cinder Block Wall
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "ZAWConcreteBrick", Amount = 10, Text = getItemText("Concrete_Brick"),
		},

		{
			Material = "BucketConcreteFull", Amount = 1, Text = getItemText("Bucket_of_Concrete") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = {"ZAWMasonryTrowel",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_GrayCinderBlockWallDesc");

	_sprite = {};
	_sprite.sprite = "walls_commercial_03_32";
	_sprite.northSprite = "walls_commercial_03_33";
	_sprite.corner = "walls_commercial_03_35";
	_choice = 2;
	_name = getText("ContextMenu_Gray_Cinder_Block_Wall");

	_option = subMenu[getText("ContextMenu_GrayCinderBlock")]:addOption(_name, nil, ZAWISBuildMenu.onBuildStoneWall, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 7, 0, _option, player);
	_tooltip:setName(_name);

	_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	--  White Cinder Block Wall
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "ZAWConcreteBrick", Amount = 10, Text = getItemText("Concrete_Brick"),
		},

		{
			Material = "BucketConcreteFull", Amount = 1, Text = getItemText("Bucket_of_Concrete") .. " " .. getText("Tooltip_Uses"),
		},
	
		{
			Material = "PaintWhite", Amount = 1, Text = getItemText("White_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = { "ZAWMasonryTrowel", "Paintbrush", };
	ZAWISBuildMenu.ODescription = getText("ContextMenu_WhiteCinderBlockWallDesc");

	_sprite = {};
	_sprite.sprite = "walls_commercial_01_48";
	_sprite.northSprite = "walls_commercial_01_49";
	_sprite.corner = "walls_commercial_01_51";
	_choice = 3;
	_name = getText("ContextMenu_White_Cinder_Block_Wall");

	_option = subMenu[getText("ContextMenu_WhiteCinderBlock")]:addOption(_name, nil, ZAWISBuildMenu.onBuildStoneWall, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 7, 0, _option, player);
	_tooltip:setName(_name);

	_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	--  Red Brick Wall
	--

--	ZAWISBuildMenu.neededMaterials =
--	{
--		{
--			Material = "ZAWBrick", Amount = 10, Text = getItemText("Brick"),
--		},
--
--		{
--			Material = "BucketConcreteFull", Amount = 2, Text = getItemText("Bucket_of_Concrete") .. " " .. getText("Tooltip_Uses"),
--		},
--
--	};
	
--	ZAWISBuildMenu.neededTools = { "ZAWMasonryTrowel", };
--	ZAWISBuildMenu.ODescription = getText("ContextMenu_RedBrickWallDesc");

--	_sprite = {};
--	_sprite.sprite = "walls_exterior_house_01_4";
--	_sprite.northSprite = "walls_exterior_house_01_5";
--	_sprite.corner = "walls_exterior_house_01_7";
--	_choice = 4;
--	_name = getText("ContextMenu_Red_Brick_Wall");

--	_option = subMenu[getText("ContextMenu_RedBrick")]:addOption(_name, nil, ZAWISBuildMenu.onBuildStoneWall, _sprite, player, _name, _choice);

--	_tooltip = ZAWISBuildMenu.canBuildObject(8, 0, _option, player);
--	_tooltip:setName(_name);

--	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	--  Light Orange Brick Wall
	--
--	ZAWISBuildMenu.ODescription = getText("ContextMenu_RedBrickWallDesc");
--	_sprite = {};
--	_sprite.sprite = "walls_exterior_house_02_36";
--	_sprite.northSprite = "walls_exterior_house_02_37";
--	_sprite.corner = "walls_exterior_house_02_38";
--	_choice = 4;
--	_name = getText("ContextMenu_LOrange_Brick_Wall");

--	_option = subMenu[getText("ContextMenu_LOrangeBrick")]:addOption(_name, nil, ZAWISBuildMenu.onBuildStoneWall, _sprite, player, _name, _choice);

--	_tooltip = ZAWISBuildMenu.canBuildObject(8, 0, _option, player);
--	_tooltip:setName(_name);


--	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	--  Orange Brick Wall
	--
--	ZAWISBuildMenu.ODescription = getText("ContextMenu_RedBrickWallDesc");
--	_sprite = {};
--	_sprite.sprite = "walls_exterior_house_01_16";
--	_sprite.northSprite = "walls_exterior_house_01_17";
--	_sprite.corner = "walls_exterior_house_01_18";
--	_choice = 4;
--	_name = getText("ContextMenu_Orange_Brick_Wall");
	
--	_option = subMenu[getText("ContextMenu_OrangeBrick")]:addOption(_name, nil, ZAWISBuildMenu.onBuildStoneWall, _sprite, player, _name, _choice);

--	_tooltip = ZAWISBuildMenu.canBuildObject(8, 0, _option, player);
--	_tooltip:setName(_name);

--	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	--  Dark Red Brick Wall
	--
--	ZAWISBuildMenu.ODescription = getText("ContextMenu_RedBrickWallDesc");
--	_sprite = {};
--	_sprite.sprite = "walls_exterior_house_01_52";
--	_sprite.northSprite = "walls_exterior_house_01_53";
--	_sprite.corner = "walls_exterior_house_01_54";
--	_choice = 4;
--	_name = getText("ContextMenu_Dark_Red_Brick_Wall");

--	_option = subMenu[getText("ContextMenu_DRedBrick")]:addOption(_name, nil, ZAWISBuildMenu.onBuildStoneWall, _sprite, player, _name, _choice);

--	_tooltip = ZAWISBuildMenu.canBuildObject(8, 0, _option, player);
--	_tooltip:setName(_name);

--	_tooltip:setTexture(_sprite.sprite);

------------------------------------------------------------------------------------------------
end

ZAWISBuildMenu.onBuildWoodenWall = function(ignoreThisArgument, sprite, player, name, choice)
	local _wall = ISWoodenWall:new(sprite.sprite, sprite.northSprite, sprite.corner);

	--_wall.canBePlastered = ZAWISBuildMenu.playerCanPlaster;
	_wall.canBarricade = false;
    --_wall.modData["wallType"] = "wall";
    _wall.player = player;
	if choice == 3 then
		_wall.name = "NewMetalWallFrame";
	else
		_wall.name = name;
	end

	_wall.modData["xp:Woodwork"] = 5;
	if choice == 1 then
		_wall.modData["need:Base.Plank"] = "3";
		_wall.modData["need:Base.Nails"] = "3";
		_wall.modData["use:Base.PaintRed"] = "1";
	elseif choice == 2 then
		_wall.modData["need:Base.Plank"] = "3";
		_wall.modData["need:Base.Nails"] = "3";
		_wall.modData["use:Base.PaintWhite"] = "1";
	elseif choice == 3 then
		_wall.modData["need:Base.Screws"] = "10";
		_wall.modData["need:Base.MetalPipe"] = "4";
		_wall.modData["use:Base.Wire"] = "1";
	else
	end
	getCell():setDrag(_wall, player);
end

ZAWISBuildMenu.onBuildStoneWall = function(ignoreThisArgument, sprite, player, name, choice)
	local _wall = ISWoodenWall:new(sprite.sprite, sprite.northSprite, sprite.corner);

	_wall.canBarricade = false;
    _wall.modData["wallType"] = "wall";
    _wall.player = player;
	_wall.name = name;
	_wall.isDestroyed = false;
	_wall.isThumpable = false;
	
	--  Materials required to build the object.  These might get returned on destruction.
	_wall.modData["xp:Woodwork"] = 8;
	if choice == 1 then
		_wall.modData["use:Base.BucketConcreteFull"] = "1";
		_wall.modData["need:Base.ZAWConcreteBrick"] = "10";
		_wall.modData["use:Base.PaintBrown"] = "1";
	elseif choice == 2 then
		_wall.modData["use:Base.BucketConcreteFull"] = "1";
		_wall.modData["need:Base.ZAWConcreteBrick"] = "10";
	elseif choice == 3 then
		_wall.modData["use:Base.BucketConcreteFull"] = "1";
		_wall.modData["need:Base.ZAWConcreteBrick"] = "10";
		_wall.modData["use:Base.PaintWhite"] = "1";
	elseif choice == 4 then
		_wall.modData["use:Base.BucketConcreteFull"] = "2";
		_wall.modData["need:Base.ZAWBrick"] = "10";
	else
	end

	--  This violates a few best practices for coding, but it allows the health
	--      to be set without creating a new file to inherit.
	function _wall:getHealth()
		return ZAWISBuildMenu.healthLevel.stoneWall + buildUtil.getWoodHealth(self);
	end
	
	ZAWISBuildMenu.equipToolPrimary(_wall, player, "ZAWMasonryTrowel");

	getCell():setDrag(_wall, player);
end

ZAWISBuildMenu.doorsMenuBuilder = function(subMenu, player, context, worldobjects)
	--   Add the Architecture -> Doors -> Wooden Doors submenu.
	local _woodenDoorsOption = subMenu:addOption(getText("ContextMenu_Wooden_Doors"), worldobjects, nil);
	local _woodenDoorsSubMenu = subMenu:getNew(subMenu);

	context:addSubMenu(_woodenDoorsOption, _woodenDoorsSubMenu);
	ZAWISBuildMenu.woodenDoorsMenuBuilder(_woodenDoorsSubMenu, player);

	--   Add the Architecture -> Doors -> Windows Doors submenu.
	local _windowsDoorsOption = subMenu:addOption(getText("ContextMenu_Windows_Wooden_Doors"), worldobjects, nil);
	local _windowsDoorsSubMenu = subMenu:getNew(subMenu);

	context:addSubMenu(_windowsDoorsOption, _windowsDoorsSubMenu);
	ZAWISBuildMenu.windowsDoorsMenuBuilder(_windowsDoorsSubMenu, player);

	--   Add the Architecture -> Doors -> Panel Doors submenu.
--	local _panelDoorsOption = subMenu:addOption(getText("ContextMenu_Panel_Doors"), worldobjects, nil);
	--local _panelDoorsSubMenu = subMenu:getNew(subMenu);

	--context:addSubMenu(_panelDoorsOption, _panelDoorsSubMenu);
	--ZAWISBuildMenu.panelDoorsMenuBuilder(_panelDoorsSubMenu, player);

	--   Add the Architecture -> Doors -> Industrial Doors submenu.
--	local _industrialDoorsOption = subMenu:addOption(getText("ContextMenu_Industrial_Doors"), worldobjects, nil);
	--local _industrialDoorsSubMenu = subMenu:getNew(subMenu);

	--context:addSubMenu(_industrialDoorsOption, _industrialDoorsSubMenu);
	--ZAWISBuildMenu.industrialDoorsMenuBuilder(_industrialDoorsSubMenu, player);

	--   Add the Architecture -> Doors -> Exterior Doors submenu.
--	local _exteriorDoorsOption = subMenu:addOption(getText("ContextMenu_Exterior_Doors"), worldobjects, nil);
	--local _exteriorDoorsSubMenu = subMenu:getNew(subMenu);

	--context:addSubMenu(_exteriorDoorsOption, _exteriorDoorsSubMenu);
	--ZAWISBuildMenu.exteriorDoorsMenuBuilder(_exteriorDoorsSubMenu, player);

	--   Add the Architecture -> Doors -> Other Doors submenu.
--	local _otherDoorsOption = subMenu:addOption(getText("ContextMenu_Other_Doors"), worldobjects, nil);
	--local _otherDoorsSubMenu = subMenu:getNew(subMenu);

	--context:addSubMenu(_otherDoorsOption, _otherDoorsSubMenu);
	--ZAWISBuildMenu.otherDoorsMenuBuilder(_otherDoorsSubMenu, player);
end

ZAWISBuildMenu.woodenDoorsMenuBuilder = function(subMenu, player)
	local _sprite = nil;
	local _option = nil;
	local _tooltip = nil;
	local _name = "";
	local _choice = "";
	--ZAWISBuildMenu._name = _name;


	-- JPM: Setting the materials once for the following objects as they all use
	--      the same materials list to build with.
	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 4, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 4, Text = getItemText("Nails"),
		},

		{
			Material = "Doorknob", Amount = 1, Text = getItemText("Doorknob"),
		},

		{
			Material = "Hinge", Amount = 2, Text = getItemText("Door_Hinge"),
		},

		{
			Material = "PaintLightBlue", Amount = 1, Text = getItemText("Light_Blue_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = { "Hammer", "Paintbrush" };
	ZAWISBuildMenu.ODescription = getText("ContextMenu_LightBlueWoodenDoor");

	----------------------------------------------------------------------------------
	--
	-- JPM:  Blue Wooden Door
	--
	_sprite = {};
	_sprite.sprite = "fixtures_doors_02_0";
	_sprite.northSprite = "fixtures_doors_02_1";
	_sprite.openSprite = "fixtures_doors_02_2";
	_sprite.openNorthSprite = "fixtures_doors_02_3";
	_choice = 1;
	_name = getText("ContextMenu_Blue_Wooden_Door");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoor, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 6, 0, _option, player);
	_tooltip:setName(_name);
	_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	-- JPM:  Brown Wooden Door
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 4, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 4, Text = getItemText("Nails"),
		},

		{
			Material = "Doorknob", Amount = 1, Text = getItemText("Doorknob"),
		},

		{
			Material = "Hinge", Amount = 2, Text = getItemText("Door_Hinge"),
		},

	};

	ZAWISBuildMenu.neededTools = {"Hammer"};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_BrownWoodenDoorDesc");
	_sprite = {};
	_sprite.sprite = "fixtures_doors_01_4";
	_sprite.northSprite = "fixtures_doors_01_5";
	_sprite.openSprite = "fixtures_doors_01_6";
	_sprite.openNorthSprite = "fixtures_doors_01_7";
	_choice = 2;
	_name = getText("ContextMenu_Brown_Wooden_Door");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoor, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 6, 0, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_BrownWoodenDoorDesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	-- JPM:  Dark Brown Wooden Door
	--
	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 4, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 4, Text = getItemText("Nails"),
		},

		{
			Material = "Doorknob", Amount = 1, Text = getItemText("Doorknob"),
		},

		{
			Material = "Hinge", Amount = 2, Text = getItemText("Door_Hinge"),
		},

		{
			Material = "PaintBrown", Amount = 1, Text = getItemText("Brown_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = { "Hammer", "Paintbrush" };
	ZAWISBuildMenu.ODescription = getText("ContextMenu_DarkBrownWoodenDoorDesc");
	_sprite = {};
	_sprite.sprite = "fixtures_doors_01_12";
	_sprite.northSprite = "fixtures_doors_01_13";
	_sprite.openSprite = "fixtures_doors_01_14";
	_sprite.openNorthSprite = "fixtures_doors_01_15";
	_choice = 3;
	_name = getText("ContextMenu_Dark_Brown_Wooden_Door");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoor, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 6, 0, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_DarkBrownWoodenDoorDesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	-- JPM:  Fancy Brown Door
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 4, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 4, Text = getItemText("Nails"),
		},

		{
			Material = "Doorknob", Amount = 1, Text = getItemText("Doorknob"),
		},

		{
			Material = "Hinge", Amount = 2, Text = getItemText("Door_Hinge"),
		},

	};

	ZAWISBuildMenu.neededTools = {"Hammer"};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_FancyBrownDoorDesc");
	_sprite = {};
	_sprite.sprite = "location_community_church_small_01_64";
	_sprite.northSprite = "location_community_church_small_01_65";
	_sprite.openSprite = "location_community_church_small_01_66";
	_sprite.openNorthSprite = "location_community_church_small_01_67";

	_choice = 4;
	_name = getText("ContextMenu_Fancy_Brown_Door");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoor, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 6, 0, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_FancyBrownDoorDesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	-- JPM:  White Wooden Door
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 4, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 4, Text = getItemText("Nails"),
		},

		{
			Material = "Doorknob", Amount = 1, Text = getItemText("Doorknob"),
		},

		{
			Material = "Hinge", Amount = 2, Text = getItemText("Door_Hinge"),
		},

		{
			Material = "PaintWhite", Amount = 1, Text = getItemText("White_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = { "Hammer", "Paintbrush" };
	ZAWISBuildMenu.ODescription = getText("ContextMenu_WhiteWoodenDoorDesc");
	_sprite = {};
	_sprite.sprite = "fixtures_doors_01_0";
	_sprite.northSprite = "fixtures_doors_01_1";
	_sprite.openSprite = "fixtures_doors_01_2";
	_sprite.openNorthSprite = "fixtures_doors_01_3";

	_choice = 5;
	_name = getText("ContextMenu_White_Wooden_Door");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoor, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 6, 0, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_WhiteWoodenDoorDesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);
end

ZAWISBuildMenu.windowsDoorsMenuBuilder = function(subMenu, player)
	local _sprite = nil;
	local _option = nil;
	local _tooltip = nil;
	local _name = "";
	local _choice = "";
	--ZAWISBuildMenu._name = _name;
	----------------------------------------------------------------------------------
	--
	-- JPM:  Brown Wooden Door Window
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 4, Text = getItemText("Plank"),
		},

		{
			Material = "ZAWGlassPanel", Amount = 1, Text = getItemText("Glass_Panel"),
		},

		{
			Material = "Nails", Amount = 4, Text = getItemText("Nails"),
		},

		{
			Material = "Doorknob", Amount = 1, Text = getItemText("Doorknob"),
		},

		{
			Material = "Hinge", Amount = 2, Text = getItemText("Door_Hinge"),
		},

	};

	ZAWISBuildMenu.neededTools = { "Hammer"};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_BrownWoodenDoorWindowDesc");

	_sprite = {};
	_sprite.sprite = "fixtures_doors_02_4";
	_sprite.northSprite = "fixtures_doors_02_5";
	_sprite.openSprite = "fixtures_doors_02_6";
	_sprite.openNorthSprite = "fixtures_doors_02_7";
	_choice = 6;
	_name = getText("ContextMenu_Brown_Wooden_Door_Window");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoor, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 7, 0, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_BrownWoodenDoorWindowDesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  White Wooden Door Window
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 4, Text = getItemText("Plank"),
		},

		{
			Material = "ZAWGlassPanel", Amount = 1, Text = getItemText("Glass_Panel"),
		},

		{
			Material = "Nails", Amount = 4, Text = getItemText("Nails"),
		},

		{
			Material = "Doorknob", Amount = 1, Text = getItemText("Doorknob"),
		},

		{
			Material = "Hinge", Amount = 2, Text = getItemText("Door_Hinge"),
		},

		{
			Material = "PaintWhite", Amount = 1, Text = getItemText("White_Paint") .. " " .. getText("Tooltip_Uses"),
		},

	};

	ZAWISBuildMenu.neededTools = { "Hammer", "Paintbrush"};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_WhiteWoodenDoorWindowDesc");

	_sprite = {};
	_sprite.sprite = "fixtures_doors_01_44";
	_sprite.northSprite = "fixtures_doors_01_45";
	_sprite.openSprite = "fixtures_doors_01_46";
	_sprite.openNorthSprite = "fixtures_doors_01_47";
	_choice = 7;
	_name = getText("ContextMenu_White_Wooden_Door_Window");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoor, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 7, 0, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_WhiteWoodenDoorWindowDesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);
	
	----------------------------------------------------------------------------------
	--
	-- JPM:  Brown window panel door
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 2, Text = getItemText("Plank"),
		},

		{
			Material = "ZAWGlassPanel", Amount = 2, Text = getItemText("Glass_Panel"),
		},

		{
			Material = "Nails", Amount = 4, Text = getItemText("Nails"),
		},

		{
			Material = "Doorknob", Amount = 1, Text = getItemText("Doorknob"),
		},

		{
			Material = "Hinge", Amount = 2, Text = getItemText("Door_Hinge"),
		},

	};

	ZAWISBuildMenu.neededTools = { "Hammer",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_BrownWoodenDoorLWindowDesc");
	_sprite = {};
	_sprite.sprite = "fixtures_doors_01_36";
	_sprite.northSprite = "fixtures_doors_01_37";
	_sprite.openSprite = "fixtures_doors_01_38";
	_sprite.openNorthSprite = "fixtures_doors_01_39";
	_choice = 8;
	_name = getText("ContextMenu_WindowPanel_BrownDoor");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoor, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 7, 0, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_BrownWoodenDoorLWindowDesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  Black window panel door
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 2, Text = getItemText("Plank"),
		},

		{
			Material = "ZAWGlassPanel", Amount = 2, Text = getItemText("Glass_Panel"),
		},

		{
			Material = "Nails", Amount = 4, Text = getItemText("Nails"),
		},

		{
			Material = "Doorknob", Amount = 1, Text = getItemText("Doorknob"),
		},

		{
			Material = "Hinge", Amount = 2, Text = getItemText("Door_Hinge"),
		},

		{
			Material = "PaintBlack", Amount = 1, Text = getItemText("Black_Paint") .. " " .. getText("Tooltip_Uses"),
		},

	};

	ZAWISBuildMenu.neededTools = { "Hammer", "Paintbrush",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_BlackWoodenDoorLWindowDesc");

	_sprite = {};
	_sprite.sprite = "fixtures_doors_01_40";
	_sprite.northSprite = "fixtures_doors_01_41";
	_sprite.openSprite = "fixtures_doors_01_42";
	_sprite.openNorthSprite = "fixtures_doors_01_43";
	_choice = 9;
	_name = getText("ContextMenu_WindowPanel_BlackDoor");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoor, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 7, 0, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_BlackWoodenDoorLWindowDesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  Black window panel door
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "SheetMetal", Amount = 2, Text = getItemText("Metal_Sheet"),
		},

		{
			Material = "ZAWGlassPanel", Amount = 2, Text = getItemText("Glass_Panel"),
		},

		{
			Material = "Screws", Amount = 10, Text = getItemText("Screws"),
		},

		{
			Material = "Doorknob", Amount = 1, Text = getItemText("Doorknob"),
		},

		{
			Material = "Hinge", Amount = 2, Text = getItemText("Door_Hinge"),
		},

		{
			Material = "Woodglue", Amount = 2, Text = getItemText("Wood_Glue"),
		},

		{
			Material = "PaintBlack", Amount = 1, Text = getItemText("Black_Paint") .. " " .. getText("Tooltip_Uses"),
		},

	};

	ZAWISBuildMenu.neededTools = { "Hammer", "Screwdriver", "Paintbrush",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_BlackMetalDoorLWindowDesc");
	_sprite = {};
	_sprite.sprite = "fixtures_doors_01_48";
	_sprite.northSprite = "fixtures_doors_01_49";
	_sprite.openSprite = "fixtures_doors_01_50";
	_sprite.openNorthSprite = "fixtures_doors_01_51";
	_choice = 10;
	_name = getText("ContextMenu_WindowPanel_BlackMetalDoor");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoor, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 7, 0, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_BlackMetalDoorLWindowDesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);
end

ZAWISBuildMenu.pillarsMenuBuilder = function(subMenu, player)
	local _sprite = nil;
	local _option = nil;
	local _tooltip = nil;
	local _name = "";
	local _choice = "";

	----------------------------------------------------------------------------------
	--
	-- JPM:  Red Barnwood Pillar
	--
	-- JPM: Setting the materials once for the following objects as they all use
	--      the same materials list to build with.
	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 2, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 3, Text = getItemText("Nails"),
		},
		
		{
			Material = "PaintRed", Amount = 1, Text = getItemText("Red_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = { "Hammer", "Paintbrush",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_RedPillarDesc");

	_sprite = {};
	_sprite.sprite = "walls_exterior_wooden_01_3";
	_sprite.northSprite = "walls_exterior_wooden_01_3";
	_choice = 1;
	_name = getText("ContextMenu_Red_BarnWood_Pillar");
	_option = subMenu[getText("ContextMenu_RedBarnWood")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenPillar, _sprite, player, _name, _choice);
	
	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", ZAWISBuildMenu.skillLevel.wallObject, 0, _option, player);
	_tooltip:setName(_name);

	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  White Wood Pillar
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 2, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 3, Text = getItemText("Nails"),
		},

		{
			Material = "PaintWhite", Amount = 1, Text = getItemText("White_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};
	ZAWISBuildMenu.neededTools = { "Hammer", "Paintbrush",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_WhitePillarDesc");

	_sprite = {};
	_sprite.sprite = "walls_exterior_wooden_02_3";
	_sprite.northSprite = "walls_exterior_wooden_02_3";
	_choice = 2;
	_name = getText("ContextMenu_White_Wood_Pillar");
	_option = subMenu[getText("ContextMenu_WhiteWood")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenPillar, _sprite, player, _name, _choice);
	
	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", ZAWISBuildMenu.skillLevel.wallObject, 0, _option, player);
	_tooltip:setName(_name);

	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  Brown Cinder Block Pillar
	--
	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "ZAWConcreteBrick", Amount = 5, Text = getItemText("Concrete_Brick"),
		},

		{
			Material = "BucketConcreteFull", Amount = 1, Text = getItemText("Bucket_of_Concrete") .. " " .. getText("Tooltip_Uses"),
		},
	
		{
			Material = "PaintBrown", Amount = 1, Text = getItemText("Brown_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = { "ZAWMasonryTrowel", "Paintbrush", };
	
	ZAWISBuildMenu.ODescription = getText("ContextMenu_CinderBrownPillarDesc");

	_sprite = {};
	_sprite.sprite = "walls_commercial_03_3";
	_sprite.northSprite = "walls_commercial_03_3";
	_choice = 3;
	_name = getText("ContextMenu_Brown_Cinder_Block_Pillar");
	_option = subMenu[getText("ContextMenu_BrownCinderBlock")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenPillar, _sprite, player, _name, _choice);
	
	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 7, 0, _option, player);
	_tooltip:setName(_name);

	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  Gray Cinder Block Pillar
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "ZAWConcreteBrick", Amount = 5, Text = getItemText("Concrete_Brick"),
		},

		{
			Material = "BucketConcreteFull", Amount = 1, Text = getItemText("Bucket_of_Concrete") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = {"ZAWMasonryTrowel",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_CinderGrayPillarDesc");

	_sprite = {};
	_sprite.sprite = "walls_commercial_03_35";
	_sprite.northSprite = "walls_commercial_03_35";
	_choice = 4;
	_name = getText("ContextMenu_Gray_Cinder_Block_Pillar");
	_option = subMenu[getText("ContextMenu_GrayCinderBlock")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenPillar, _sprite, player, _name, _choice);
	
	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 7, 0, _option, player);
	_tooltip:setName(_name);

	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  White Cinder Block Pillar
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "ZAWConcreteBrick", Amount = 5, Text = getItemText("Concrete_Brick"),
		},

		{
			Material = "BucketConcreteFull", Amount = 1, Text = getItemText("Bucket_of_Concrete") .. " " .. getText("Tooltip_Uses"),
		},
	
		{
			Material = "PaintWhite", Amount = 1, Text = getItemText("White_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = { "ZAWMasonryTrowel", "Paintbrush", };
	ZAWISBuildMenu.ODescription = getText("ContextMenu_CinderWhitePillarDesc");

	_sprite = {};
	_sprite.sprite = "walls_commercial_01_51";
	_sprite.northSprite = "walls_commercial_01_51";
	_choice = 5;
	_name = getText("ContextMenu_White_Cinder_Block_Pillar");
	_option = subMenu[getText("ContextMenu_WhiteCinderBlock")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenPillar, _sprite, player, _name, _choice);
	
	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 7, 0, _option, player);
	_tooltip:setName(_name);

	_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	-- JPM:  Red Brick Pillar
	--

--	ZAWISBuildMenu.neededMaterials =
--	{
--		{
--			Material = "ZAWBrick", Amount = 5, Text = getItemText("Brick"),
--		},
--
--		{
--			Material = "BucketConcreteFull", Amount = 1, Text = getItemText("Bucket_of_Concrete") .. " " .. getText("Tooltip_Uses"),
--		},
--
--	};
	
--	ZAWISBuildMenu.neededTools = { "ZAWMasonryTrowel", };
--	ZAWISBuildMenu.ODescription = getText("ContextMenu_BrickPillarDesc");

--	_sprite = {};
--	_sprite.sprite = "walls_exterior_house_01_7";
--	_sprite.northSprite = "walls_exterior_house_01_7";
--	_choice = 6;
--	_name = getText("ContextMenu_Red_Brick_Pillar");
--	_option = subMenu[getText("ContextMenu_RedBrick")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenPillar, _sprite, player, _name, _choice);
	
--	_tooltip = ZAWISBuildMenu.canBuildObject(8, 0, _option, player);
--	_tooltip:setName(_name);

--	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  Light Orange Brick Pillar
	--

--	ZAWISBuildMenu.ODescription = getText("ContextMenu_BrickPillarDesc");
--	_sprite = {};
--	_sprite.sprite = "walls_exterior_house_02_39";
--	_sprite.northSprite = "walls_exterior_house_02_39";
--	_choice = 7;
--	_name = getText("ContextMenu_LOrange_Brick_Pillar");
--	_option = subMenu[getText("ContextMenu_LOrangeBrick")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenPillar, _sprite, player, _name, _choice);
	
--	_tooltip = ZAWISBuildMenu.canBuildObject(8, 0, _option, player);
--	_tooltip:setName(_name);

--	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  Orange Brick Pillar
	--
--	ZAWISBuildMenu.ODescription = getText("ContextMenu_BrickPillarDesc");

--	_sprite = {};
--	_sprite.sprite = "walls_exterior_house_01_19";
--	_sprite.northSprite = "walls_exterior_house_01_19";
--	_choice = 8;
--	_name = getText("ContextMenu_Orange_Brick_Pillar");
--	_option = subMenu[getText("ContextMenu_OrangeBrick")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenPillar, _sprite, player, _name, _choice);
	
--	_tooltip = ZAWISBuildMenu.canBuildObject(8, 0, _option, player);
--	_tooltip:setName(_name);

--	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  Dark Red Brick Pillar
	--
	
--	ZAWISBuildMenu.ODescription = getText("ContextMenu_BrickPillarDesc");

--	_sprite = {};
--	_sprite.sprite = "walls_exterior_house_01_55";
--	_sprite.northSprite = "walls_exterior_house_01_55";
--	_choice = 9;
--	_name = getText("ContextMenu_Dark_Red_Brick_Pillar");
--	_option = subMenu[getText("ContextMenu_DRedBrick")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenPillar, _sprite, player, _name, _choice);
	
--	_tooltip = ZAWISBuildMenu.canBuildObject(8, 0, _option, player);
--	_tooltip:setName(_name);

--	_tooltip:setTexture(_sprite.sprite);
end

ZAWISBuildMenu.onBuildWoodenPillar = function(ignoreThisArgument, sprite, player, name, choice)
	local _pillar = ISWoodenWall:new(sprite.sprite, sprite.northSprite, nil);

	_pillar.canPassThrough = true;
	_pillar.canBarricade = false;
    _pillar.player = player;
	_pillar.name = name;
	_pillar.modData["xp:Woodwork"] = 3;
	
	-- JPM: Materials required to build the object.  These might get returned on destruction.
	if choice == 1 then
		_pillar.modData["need:Base.Plank"] = "2";
		_pillar.modData["need:Base.Nails"] = "3";
		_pillar.modData["use:Base.PaintRed"] = "1";
	elseif choice == 2 then
		_pillar.modData["need:Base.Plank"] = "2";
		_pillar.modData["need:Base.Nails"] = "3";
		_pillar.modData["use:Base.PaintWhite"] = "1";
	elseif choice == 3 then
		_pillar.modData["need:Base.ZAWConcreteBrick"] = "5";
		_pillar.modData["use:Base.BucketConcreteFull"] = "1";
		_pillar.modData["use:Base.PaintBrown"] = "1";
	elseif choice == 4 then
		_pillar.modData["need:Base.ZAWConcreteBrick"] = "5";
		_pillar.modData["use:Base.BucketConcreteFull"] = "1";
	elseif choice == 5 then
		_pillar.modData["need:Base.ZAWConcreteBrick"] = "5";
		_pillar.modData["use:Base.BucketConcreteFull"] = "1";
		_pillar.modData["use:Base.PaintWhite"] = "1";
	elseif choice == 6 or choice == 7 or choice == 8 or choice == 9 then
		_pillar.modData["need:Base.ZAWBrick"] = "5";
		_pillar.modData["use:Base.BucketConcreteFull"] = "1";
	end

--  This violates a few best practices for coding, but it allows the health
	--      to be set without creating a new file to inherit.
	
	function _pillar:getHealth()
		if choice == 6 or choice == 7 or choice == 8 or choice == 9 then
			return ZAWISBuildMenu.healthLevel.stoneWall + buildUtil.getWoodHealth(self);
		end
	end
	getCell():setDrag(_pillar, player);
end

ZAWISBuildMenu.doorFramesMenuBuilder = function(subMenu, player)
	local _sprite = nil;
	local _option = nil;
	local _tooltip = nil;
	local _name = "";
	local _choice = "";

	if LGISBuildMenu then
	else
		-- JPM: Setting the materials once for the following objects as they all use
		--      the same materials list to build with.

		ZAWISBuildMenu.neededMaterials =
		{
			{
				Material = "Screws", Amount = 10, Text = getItemText("Screws"),
			},

			{
				Material = "MetalPipe", Amount = 5, Text = getItemText("Metal_Pipe"),
			},

		};

		ZAWISBuildMenu.neededTools = { "Hammer",};
		ZAWISBuildMenu.ODescription = getText("Tooltip_craft_AdvancedMetalDoorFramedesc");

		----------------------------------------------------------------------------------
		--
		-- Advanced Metal Door Frame
		--

		_sprite = {};
		_sprite.sprite = "walls_exterior_zaw_01_55";
		_sprite.northSprite = "walls_exterior_zaw_01_56";
		_choice = 10;
		_name = getText("ContextMenu_AdvancedMetalDoorFrame");
		_option = subMenu[getText("ContextMenu_AdvancedFrames")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoorFrame, _sprite, player, _name, _choice);
		
		_tooltip = ZAWISBuildMenu.canBuildObject("Advanced metal frames", 8, 2, _option, player);
		_tooltip:setName(_name);

		_tooltip:setTexture(_sprite.sprite);
	end
	
	----------------------------------------------------------------------------------
	--
	-- Red Barn Wood Door Frame
	--
	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 4, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 4, Text = getItemText("Nails"),
		},

		{
			Material = "PaintRed", Amount = 1, Text = getItemText("Red_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = { "Hammer", "Paintbrush",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_RedBarnWoodDoorFrameDesc");

	----------------------------------------------------------------------------------
	--
	-- JPM:  Red Barnwood Door Frame
	--

	_sprite = {};
	_sprite.sprite = "walls_exterior_wooden_01_10";
	_sprite.northSprite = "walls_exterior_wooden_01_11";
	_sprite.corner = "walls_exterior_wooden_01_3";
	_choice = 1;
	_name = getText("ContextMenu_Red_BarnWood_Door_Frame");
	_option = subMenu[getText("ContextMenu_RedBarnWood")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoorFrame, _sprite, player, _name, _choice);
	
	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", ZAWISBuildMenu.skillLevel.wallObject, 0, _option, player);
	_tooltip:setName(_name);

	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM: White Wood Door Frame
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 4, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 4, Text = getItemText("Nails"),
		},

		{
			Material = "PaintWhite", Amount = 1, Text = getItemText("White_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};
	
	ZAWISBuildMenu.ODescription = getText("ContextMenu_WhiteWoodDoorFrameDesc");


	_sprite = {};
	_sprite.sprite = "walls_exterior_wooden_02_10";
	_sprite.northSprite = "walls_exterior_wooden_02_11";
	_sprite.corner = "walls_exterior_wooden_02_3";
	_choice = 2;
	_name = getText("ContextMenu_White_Wood_Door_Frame");
	_option = subMenu[getText("ContextMenu_WhiteWood")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoorFrame, _sprite, player, _name, _choice);
	
	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", ZAWISBuildMenu.skillLevel.wallObject, 0, _option, player);
	_tooltip:setName(_name);

	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  Brown Cinder Block Door Frame
	--
	-- JPM: Setting the materials once for the following objects as they all use
	--      the same materials list to build with.
	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "ZAWConcreteBrick", Amount = 12, Text = getItemText("Concrete_Brick"),
		},

		{
			Material = "BucketConcreteFull", Amount = 2, Text = getItemText("Bucket_of_Concrete") .. " " .. getText("Tooltip_Uses"),
		},
	
		{
			Material = "PaintBrown", Amount = 1, Text = getItemText("Brown_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = { "ZAWMasonryTrowel", "Paintbrush", };
	
	ZAWISBuildMenu.ODescription = getText("ContextMenu_CinderBlockDoorFrameDesc");

	_sprite = {};
	_sprite.sprite = "walls_commercial_03_10";
	_sprite.northSprite = "walls_commercial_03_11";
	_sprite.corner = "walls_commercial_03_3";
	_choice = 3;
	_name = getText("ContextMenu_Brown_Cinder_Block_Door_Frame");
	_option = subMenu[getText("ContextMenu_BrownCinderBlock")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoorFrame, _sprite, player, _name, _choice);
	
	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 7, 0, _option, player);
	_tooltip:setName(_name);

	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  Gray Cinder Block Door Frame
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "ZAWConcreteBrick", Amount = 12, Text = getItemText("Concrete_Brick"),
		},

		{
			Material = "BucketConcreteFull", Amount = 2, Text = getItemText("Bucket_of_Concrete") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = {"ZAWMasonryTrowel",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_CinderBlockDoorFrameDesc");

	_sprite = {};
	_sprite.sprite = "walls_commercial_03_42";
	_sprite.northSprite = "walls_commercial_03_43";
	_sprite.corner = "walls_commercial_03_35";
	_choice = 4;
	_name = getText("ContextMenu_Gray_Cinder_Block_Door_Frame");
	_option = subMenu[getText("ContextMenu_GrayCinderBlock")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoorFrame, _sprite, player, _name, _choice);
	
	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 7, 0, _option, player);
	_tooltip:setName(_name);

	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  White Cinder Block Door Frame
	--
	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "ZAWConcreteBrick", Amount = 12, Text = getItemText("Concrete_Brick"),
		},

		{
			Material = "BucketConcreteFull", Amount = 2, Text = getItemText("Bucket_of_Concrete") .. " " .. getText("Tooltip_Uses"),
		},
	
		{
			Material = "PaintWhite", Amount = 1, Text = getItemText("White_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = { "ZAWMasonryTrowel", "Paintbrush", };
	ZAWISBuildMenu.ODescription = getText("ContextMenu_CinderBlockDoorFrameDesc");

	_sprite = {};
	_sprite.sprite = "walls_commercial_01_58";
	_sprite.northSprite = "walls_commercial_01_59";
	_sprite.corner = "walls_commercial_01_51";
	_choice = 5;
	_name = getText("ContextMenu_White_Cinder_Block_Door_Frame");
	_option = subMenu[getText("ContextMenu_WhiteCinderBlock")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoorFrame, _sprite, player, _name, _choice);
	
	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 7, 0, _option, player);
	_tooltip:setName(_name);

	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  Red Brick Door Frame
	--
--	ZAWISBuildMenu.neededMaterials =
--	{
--		{
--			Material = "ZAWBrick", Amount = 12, Text = getItemText("Brick"),
--		},
--
--		{
--			Material = "BucketConcreteFull", Amount = 2, Text = getItemText("Bucket_of_Concrete") .. " " .. getText("Tooltip_Uses"),
--		},
--
--	};
	
--	ZAWISBuildMenu.neededTools = { "ZAWMasonryTrowel", };
--	ZAWISBuildMenu.ODescription = getText("ContextMenu_RedBrickDoorFrameDesc");

--	_sprite = {};
--	_sprite.sprite = "walls_exterior_house_01_14";
--	_sprite.northSprite = "walls_exterior_house_01_15";
--	_sprite.corner = "walls_exterior_house_01_7";
--	_choice = 6;
--	_name = getText("ContextMenu_Red_Brick_Door_Frame");
--	_option = subMenu[getText("ContextMenu_RedBrick")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoorFrame, _sprite, player, _name, _choice);
	
--	_tooltip = ZAWISBuildMenu.canBuildObject(8, 0, _option, player);
--	_tooltip:setName(_name);

--	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  Light Orange Brick Door Frame
	--
--	ZAWISBuildMenu.ODescription = getText("ContextMenu_RedBrickDoorFrameDesc");
--	_sprite = {};
--	_sprite.sprite = "walls_exterior_house_02_46";
--	_sprite.northSprite = "walls_exterior_house_02_47";
--	_sprite.corner = "walls_exterior_house_02_38";
--	_choice = 7;
--	_name = getText("ContextMenu_LOrange_Brick_Door_Frame");
--	_option = subMenu[getText("ContextMenu_LOrangeBrick")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoorFrame, _sprite, player, _name, _choice);
	
--	_tooltip = ZAWISBuildMenu.canBuildObject(8, 0, _option, player);
--	_tooltip:setName(_name);

--	_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	-- JPM:  Orange Brick Door Frame
	--
--	ZAWISBuildMenu.ODescription = getText("ContextMenu_RedBrickDoorFrameDesc");
--	_sprite = {};
--	_sprite.sprite = "walls_exterior_house_01_26";
--	_sprite.northSprite = "walls_exterior_house_01_27";
--	_sprite.corner = "walls_exterior_house_01_18";
--	_choice = 8;
--	_name = getText("ContextMenu_Orange_Brick_Door_Frame");
--	_option = subMenu[getText("ContextMenu_OrangeBrick")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoorFrame, _sprite, player, _name, _choice);
	
--	_tooltip = ZAWISBuildMenu.canBuildObject(8, 0, _option, player);
--	_tooltip:setName(_name);

--	_tooltip:setTexture(_sprite.sprite);
	----------------------------------------------------------------------------------
	--
	-- JPM:  Dark Red Brick Door Frame
	--
--	ZAWISBuildMenu.ODescription = getText("ContextMenu_RedBrickDoorFrameDesc");
--	_sprite = {};
--	_sprite.sprite = "walls_exterior_house_01_62";
--	_sprite.northSprite = "walls_exterior_house_01_63";
--	_sprite.corner = "walls_exterior_house_01_54";
--	_choice = 9;
--	_name = getText("ContextMenu_Dark_Red_Brick_Door_Frame");
--	_option = subMenu[getText("ContextMenu_DRedBrick")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenDoorFrame, _sprite, player, _name, _choice);
	
--	_tooltip = ZAWISBuildMenu.canBuildObject(8, 0, _option, player);
--	_tooltip:setName(_name);

--	_tooltip:setTexture(_sprite.sprite);
end

ZAWISBuildMenu.onBuildWoodenDoorFrame = function(ignoreThisArgument, sprite, player, name, choice)
	local _doorFrame = ISWoodenDoorFrame:new(sprite.sprite, sprite.northSprite, sprite.corner);

	--_doorFrame.canBarricade = false
	--_doorFrame.modData["wallType"] = "doorframe";
    _doorFrame.player = player;
	if choice == 10 then
		_doorFrame.name = "AdvancedMetalDoorFrame";
	else
		_doorFrame.name = name;
	end
	_doorFrame.modData["wallType"] = "doorframe";
	_doorFrame.modData["xp:Woodwork"] = 5;
	-- JPM: Materials required to build the object.  These might get returned on destruction.
	if choice == 1 then
		_doorFrame.modData["need:Base.Plank"] = "4";
		_doorFrame.modData["need:Base.Nails"] = "4";
		_doorFrame.modData["use:Base.PaintRed"] = "1";
		_doorFrame.health = 50;
	elseif choice == 2 then
		_doorFrame.modData["need:Base.Plank"] = "4";
		_doorFrame.modData["need:Base.Nails"] = "4";
		_doorFrame.modData["use:Base.PaintWhite"] = "1";
		_doorFrame.health = 50;
	elseif choice == 3 then
		_doorFrame.modData["need:Base.ZAWConcreteBrick"] = "12";
		_doorFrame.modData["use:Base.BucketConcreteFull"] = "2";
		_doorFrame.modData["use:Base.PaintBrown"] = "1";
		_doorFrame.health = 100000;
	elseif choice == 4 then
		_doorFrame.modData["need:Base.ZAWConcreteBrick"] = "12";
		_doorFrame.modData["use:Base.BucketConcreteFull"] = "2";
		_doorFrame.health = 100000;
	elseif choice == 5 then
		_doorFrame.modData["need:Base.ZAWConcreteBrick"] = "12";
		_doorFrame.modData["need:Base.BucketConcreteFull"] = "2";
		_doorFrame.modData["use:Base.PaintWhite"] = "1";
		_doorFrame.health = 100000;
	elseif choice == 6 or choice == 7 or choice == 8 or choice == 9 then
		_doorFrame.modData["need:Base.ZAWBrick"] = "12";
		_doorFrame.modData["use:Base.BucketConcreteFull"] = "2";
		_doorFrame.health = 100000;
	elseif choice == 10 then
		_doorFrame.modData["need:Base.Screws"] = "10";
		_doorFrame.modData["need:Base.MetalPipe"] = "5";
	else
	end
	getCell():setDrag(_doorFrame, player);
end

ZAWISBuildMenu.onBuildWoodenDoor = function(ignoreThisArgument, sprite, player, name, choice)
	local _door = ISWoodenDoor:new(sprite.sprite, sprite.northSprite, sprite.openSprite, sprite.openNorthSprite);

    _door.player = player;
	_door.name = name;
	
	_door.modData["xp:Woodwork"] = 5;
	-- JPM: Materials required to build the object.  These might get returned on destruction.
	if choice == 1 then
		_door.modData["need:Base.Plank"] = "4";
		_door.modData["need:Base.Nails"] = "4";
		_door.modData["need:Base.Hinge"] = "2";
		_door.modData["need:Base.Doorknob"] = "1";
		_door.modData["use:Base.PaintLightBlue"] = "1";
	elseif choice == 2 then
		_door.modData["need:Base.Plank"] = "4";
		_door.modData["need:Base.Nails"] = "4";
		_door.modData["need:Base.Hinge"] = "2";
		_door.modData["need:Base.Doorknob"] = "1";
	elseif choice == 3 then
		_door.modData["need:Base.Plank"] = "4";
		_door.modData["need:Base.Nails"] = "4";
		_door.modData["need:Base.Hinge"] = "2";
		_door.modData["need:Base.Doorknob"] = "1";
		_door.modData["use:Base.PaintBrown"] = "1";
	elseif choice == 4 then
		_door.modData["need:Base.Plank"] = "4";
		_door.modData["need:Base.Nails"] = "4";
		_door.modData["need:Base.Hinge"] = "2";
		_door.modData["need:Base.Doorknob"] = "1";
	elseif choice == 5 then
		_door.modData["need:Base.Plank"] = "4";
		_door.modData["need:Base.Nails"] = "4";
		_door.modData["need:Base.Hinge"] = "2";
		_door.modData["need:Base.Doorknob"] = "1";
		_door.modData["use:Base.PaintWhite"] = "1";
	elseif choice == 6 then
		_door.modData["need:Base.Plank"] = "4";
		_door.modData["need:Base.ZAWGlassPanel"] = "1";
		_door.modData["need:Base.Nails"] = "4";
		_door.modData["need:Base.Hinge"] = "2";
		_door.modData["need:Base.Doorknob"] = "1";
	elseif choice == 7 then
		_door.modData["need:Base.Plank"] = "4";
		_door.modData["need:Base.ZAWGlassPanel"] = "1";
		_door.modData["need:Base.Nails"] = "4";
		_door.modData["need:Base.Hinge"] = "2";
		_door.modData["need:Base.Doorknob"] = "1";
		_door.modData["use:Base.PaintWhite"] = "1";
	elseif choice == 8 then
		_door.modData["need:Base.Plank"] = "2";
		_door.modData["need:Base.ZAWGlassPanel"] = "2";
		_door.modData["need:Base.Nails"] = "4";
		_door.modData["need:Base.Hinge"] = "2";
		_door.modData["need:Base.Doorknob"] = "1";
	elseif choice == 9 then
		_door.modData["need:Base.Plank"] = "2";
		_door.modData["need:Base.ZAWGlassPanel"] = "2";
		_door.modData["need:Base.Nails"] = "4";
		_door.modData["need:Base.Hinge"] = "2";
		_door.modData["need:Base.Doorknob"] = "1";
		_door.modData["use:Base.PaintBlack"] = "1";
	elseif choice == 10 then
		_door.modData["need:Base.SheetMetal"] = "2";
		_door.modData["need:Base.ZAWGlassPanel"] = "2";
		_door.modData["need:Base.Screws"] = "10";
		_door.modData["need:Base.Hinge"] = "2";
		_door.modData["need:Base.Doorknob"] = "1";
		_door.modData["use:Base.Woodglue"] = "2";
		_door.modData["use:Base.PaintBlack"] = "1";
	else
	end

	getCell():setDrag(_door, player);
end

ZAWISBuildMenu.moreFencesMenuBuilder = function(subMenu, player)
	local _sprite = nil;
	local _option = nil;
	local _tooltip = nil;
	local _name = "";
	local _choice = "";
	--ZAWISBuildMenu._name = _name;


	--  The materials for wooden fences.
	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 2, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 4, Text = getItemText("Nails"),
		},

		{
			Material = "PaintWhite", Amount = 1, Text = getItemText("White_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = { "Hammer", "Paintbrush", };
	ZAWISBuildMenu.ODescription = getText("ContextMenu_WhitePicketFenceDesc");

	----------------------------------------------------------------------------------
	--
	--   White Picket Fence
	--
	_sprite = {};
	_sprite.sprite = "fencing_01_4";
	_sprite.northSprite = "fencing_01_5";
	_sprite.corner = "fencing_01_7";
	_choice = 1;
	_name = getText("ContextMenu_White_Picket_Fence");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenFence, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 2, 0, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_WhitePicketFenceDesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	--   Brown Stair Fence
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 2, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 4, Text = getItemText("Nails"),
		},
	};
	
	ZAWISBuildMenu.neededTools = { "Hammer",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_BrownPicketFenceDesc");

	_sprite = {};
	_sprite.sprite = "fixtures_railings_01_24";
	_sprite.northSprite = "fixtures_railings_01_25";
	_sprite.corner = "fixtures_railings_01_26";
	_choice = 2;
	_name = getText("ContextMenu_Brown_Stair_Fence");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenFence, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 2, 0, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_BrownPicketFenceDesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	--   Brown Stair Fence 2
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 2, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 4, Text = getItemText("Nails"),
		},

		{
			Material = "PaintBlack", Amount = 1, Text = getItemText("Black_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};
	
	ZAWISBuildMenu.neededTools = { "Hammer", "Paintbrush",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_Brown_Stair_FenceDesc");
	_sprite = {};
	_sprite.sprite = "fixtures_railings_01_28";
	_sprite.northSprite = "fixtures_railings_01_29";
	_sprite.corner = "fixtures_railings_01_30";
	_choice = 3;
	_name = getText("ContextMenu_Brown_Stair_Fence_2");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenFence, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 2, 0, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_Brown_Stair_FenceDesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);



	----------------------------------------------------------------------------------
	--
	--   Beige Fence With Rail
	--
	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 2, Text = getItemText("Plank"),
		},

		{
			Material = "Screws", Amount = 4, Text = getItemText("Screws"),
		},

		{
			Material = "ZAWBlackRailing", Amount = 1, Text = getItemText("Black_Railing"),
		},

		{
			Material = "BucketPlasterFull", Amount = 1, Text = getItemText("Bucket_of_Plaster") .. " " .. getText("Tooltip_Uses"),
		},
	};
	
	ZAWISBuildMenu.neededTools = { "Hammer", "Screwdriver",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_BeigeFenceWithRailDesc");
	_sprite = {};
	_sprite.sprite = "fixtures_railings_01_112";
	_sprite.northSprite = "fixtures_railings_01_113";
	_sprite.corner = "fixtures_railings_01_115";
	_choice = 4;
	_name = getText("ContextMenu_Beige_Fence_With_Rail");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenFence, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 2, 1, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_BeigeFenceWithRailDesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	--   Gray Fence With Rail
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 2, Text = getItemText("Plank"),
		},

		{
			Material = "Screws", Amount = 4, Text = getItemText("Screws"),
		},

		{
			Material = "ZAWBlackRailing", Amount = 1, Text = getItemText("Black_Railing"),
		},

		{
			Material = "BucketPlasterFull", Amount = 1, Text = getItemText("Bucket_of_Plaster") .. " " .. getText("Tooltip_Uses"),
		},

		{
			Material = "PaintGrey", Amount = 1, Text = getItemText("Grey_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};
	
	ZAWISBuildMenu.neededTools = { "Hammer", "Screwdriver", "Paintbrush", "ZAWMasonryTrowel",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_GrayFenceWithRailDesc");
	_sprite = {};
	_sprite.sprite = "fixtures_railings_01_116";
	_sprite.northSprite = "fixtures_railings_01_117";
	_sprite.corner = "fixtures_railings_01_119";
	_choice = 5;
	_name = getText("ContextMenu_Gray_Fence_With_Rail");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenFence, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 2, 1, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_GrayFenceWithRailDesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	-- Snake:  Valla con vidrio
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 2, Text = getItemText("Plank"),
		},

		{
			Material = "Screws", Amount = 4, Text = getItemText("Screws"),
		},

		{
			Material = "ZAWBlackRailing", Amount = 1, Text = getItemText("Black_Railing"),
		},

		{
			Material = "ZAWGlassPanel", Amount = 1, Text = getItemText("Glass_Panel"),
		},

		{
			Material = "BucketPlasterFull", Amount = 1, Text = getItemText("Bucket_of_Plaster") .. " " .. getText("Tooltip_Uses"),
		},

	};
	
	ZAWISBuildMenu.neededTools = { "Hammer", "Screwdriver", "ZAWMasonryTrowel",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_FenceWithGlass");
	_sprite = {};
	_sprite.sprite = "location_shop_mall_01_24";
	_sprite.northSprite = "location_shop_mall_01_25";
	_sprite.corner = "location_shop_mall_01_26";
	_choice = 6;
	_name = getText("ContextMenu_Fence_With_Glass");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenFence, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 2, 1, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_FenceWithGlass") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	-- Snake:  Valla con vidrio de comercio
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "ZAWBlackFrame", Amount = 1, Text = getItemText("Black_Metal_Frame"),
		},

		{
			Material = "ZAWGlassPanel", Amount = 1, Text = getItemText("Glass_Panel"),
		},

		{
			Material = "Screws", Amount = 10, Text = getItemText("Screws"),
		},
	};

	ZAWISBuildMenu.neededTools = { "Hammer", "Screwdriver", };
	ZAWISBuildMenu.ODescription = getText("ContextMenu_CommercialFenceWithGlassDesc");
	_sprite = {};
	_sprite.sprite = "walls_commercial_01_28";
	_sprite.northSprite = "walls_commercial_01_29";
	_sprite.corner = "walls_commercial_01_30";
	_choice = 7;
	_name = getText("ContextMenu_Commercial_Fence_With_Glass");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenFence, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 2, 1, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("ContextMenu_CommercialFenceWithGlassDesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	-- Snake:  Valla de piedra oscura lujosa
	--
--	_sprite = {};
--	_sprite.sprite = "walls_commercial_03_12";
--	_sprite.northSprite = "walls_commercial_03_13";
--	_sprite.corner = "walls_commercial_03_14";

--	_name = getText("ContextMenu_Luxury_Stone_Fence");

--	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenFence, _sprite, player);

--	_tooltip = ZAWISBuildMenu.canBuildObject(ZAWISBuildMenu.skillLevel.wallObject, _option, player);
--	_tooltip:setName(_name);
--	_tooltip.description = "<RGB:1,1,0>" .. getText("Tooltip_LuxuryStoneFence") .. _tooltip.description;
--	_tooltip:setTexture(_sprite.sprite);


	--  The materials for metal fences.
--	ZAWISBuildMenu.neededMaterials =
--	{
--		{
--			Material = "SheetMetal", Amount = 2, Text = getItemText("Metal_Sheet"),
--		},
--
--		{
--			Material = "Screws", Amount = 3, Text = getItemText("Screws"),
--		},
--	};

--	ZAWISBuildMenu.neededTools = { "Screwdriver", };



	----------------------------------------------------------------------------------
	--
	--   Green Metal Fence
	--
--	_sprite = {};
--	_sprite.sprite = "industry_railroad_05_40";
--	_sprite.northSprite = "industry_railroad_05_41";
--	_sprite.corner = "industry_railroad_05_43";

--	_name = getText("ContextMenu_Green_Metal_Fence");

--	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildMetalFence, _sprite, player);

--	_tooltip = ZAWISBuildMenu.canBuildObject(ZAWISBuildMenu.skillLevel.metalArchitecture, _option, player);
--	_tooltip:setName(_name);
--	_tooltip.description = "<RGB:1,1,0>" .. getText("Tooltip_GreenMetalFence") .. _tooltip.description;
--	_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	--   Red Metal Fence
	--
--	_sprite = {};
--	_sprite.sprite = "industry_bunker_01_24";
--	_sprite.northSprite = "industry_bunker_01_25";
--	_sprite.corner = "industry_bunker_01_27";

--	_name = getText("ContextMenu_Red_Metal_Fence");

--	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildMetalFence, _sprite, player);

--	_tooltip = ZAWISBuildMenu.canBuildObject(ZAWISBuildMenu.skillLevel.metalArchitecture, _option, player);
--	_tooltip:setName(_name);
--	_tooltip.description = "<RGB:1,1,0>" .. getText("Tooltip_RedMetalFence") .. _tooltip.description;
--	_tooltip:setTexture(_sprite.sprite);



	--  The materials for stone fences.
--	ZAWISBuildMenu.neededMaterials =
--	{
--		{
--			Material = "ZAWBrick", Amount = 4, Text = getItemText("Ladrillo"),
--		},

--		{
--			Material = "ZAWClay", Amount = 3, Text = getItemText("Arcilla"),
--		},
--	};

--	ZAWISBuildMenu.neededTools = { "ZAWMasonryTrowel", };


	----------------------------------------------------------------------------------
	--
	--   Rough Brick Fence
	--
--	_sprite = {};
--	_sprite.sprite = "construction_01_0";
--	_sprite.northSprite = "construction_01_1";
--	_sprite.corner = "construction_01_3";

--	_name = getText("ContextMenu_Rough_Brick_Fence");

--	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildStoneFence, _sprite, player);

--	_tooltip = ZAWISBuildMenu.canBuildObject(ZAWISBuildMenu.skillLevel.stoneArchitecture, _option, player);
--	_tooltip:setName(_name);
--	_tooltip.description = "<RGB:1,1,0>" .. getText("Tooltip_RoughBrickFence") .. _tooltip.description;
--	_tooltip:setTexture(_sprite.sprite);

end

ZAWISBuildMenu.onBuildWoodenFence = function(ignoreThisArgument, sprite, player, name, choice)
	local _fence = ISWoodenWall:new(sprite.sprite, sprite.northSprite, sprite.corner);

	_fence.CanPassThrough = false;
	_fence.hoppable = true;
	_fence.isThumpable = true;
	_fence.canBarricade = false;
	_fence.canBeAlwaysPlaced = true;
    _fence.player = player;
	_fence.name = name;

	--  Materials required to build the object.  These might get returned on destruction.
	_fence.modData["xp:Woodwork"] = 5;
	if choice == 1 then
		_fence.modData["need:Base.Plank"] = "2";
		_fence.modData["need:Base.Nails"] = "4";
		_fence.modData["use:Base.PaintWhite"] = "1";
	elseif choice == 2 then
		_fence.modData["need:Base.Plank"] = "2";
		_fence.modData["need:Base.Nails"] = "4";
	elseif choice == 3 then
		_fence.modData["need:Base.Plank"] = "2";
		_fence.modData["need:Base.Nails"] = "4";
		_fence.modData["use:Base.PaintBlack"] = "1";
	elseif choice == 4 then
		_fence.modData["need:Base.Plank"] = "2";
		_fence.modData["need:Base.Screws"] = "4";
		_fence.modData["need:Base.ZAWBlackRailing"] = "1";
		_fence.modData["use:Base.BucketPlasterFull"] = "1";
	elseif choice == 5 then
		_fence.modData["need:Base.Plank"] = "2";
		_fence.modData["need:Base.Screws"] = "4";
		_fence.modData["need:Base.ZAWBlackRailing"] = "1";
		_fence.modData["use:Base.BucketPlasterFull"] = "1";
		_fence.modData["use:Base.PaintGrey"] = "1";
	elseif choice == 6 then
		_fence.modData["need:Base.Plank"] = "2";
		_fence.modData["need:Base.Screws"] = "4";
		_fence.modData["need:Base.ZAWBlackRailing"] = "1";
		_fence.modData["need:Base.ZAWGlassPanel"] = "1";
		_fence.modData["use:Base.BucketPlasterFull"] = "1";
	elseif choice == 7 then
		_fence.modData["need:Base.ZAWBlackFrame"] = "1";
		_fence.modData["need:Base.ZAWGlassPanel"] = "1";
		_fence.modData["need:Base.Screws"] = "10";
		_fence.modData["xp:MetalWelding"] = "5";
	else
		_fence.modData["need:Base.Plank"] = "2";
		_fence.modData["need:Base.Nails"] = "3";
	end

	getCell():setDrag(_fence, player);
end

ZAWISBuildMenu.moreFencePostsMenuBuilder = function(subMenu, player)
	local _sprite = nil;
	local _option = nil;
	local _tooltip = nil;
	local _name = "";
	local _choice = "";


	-- JPM: The materials for wooden fences.
	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 1, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 2, Text = getItemText("Nails"),
		},

		{
			Material = "PaintWhite", Amount = 1, Text = getItemText("White_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};

	ZAWISBuildMenu.neededTools = { "Hammer","Paintbrush" };


	----------------------------------------------------------------------------------
	--
	-- JPM:  White Picket Fence Post
	--
	_sprite = {};
	_sprite.sprite = "fencing_01_7";
	_sprite.northSprite = "fencing_01_7";
	ZAWISBuildMenu.ODescription = getText("ContextMenu_WhitePicketFencePost");

	_choice = 1;
	_name = getText("ContextMenu_White_Picket_Fence_Post");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenFencePost, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 2, 0, _option, player);
	_tooltip:setName(_name);
	_tooltip:setTexture(_sprite.sprite);

	
	----------------------------------------------------------------------------------
	--
	-- Snake:  Poste de valla de madera marron
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 1, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 2, Text = getItemText("Nails"),
		},
	};
	
	ZAWISBuildMenu.neededTools = { "Hammer",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_FencebrownPost");

	_sprite = {};
	_sprite.sprite = "fixtures_railings_01_27";
	_sprite.northSprite = "fixtures_railings_01_27";

	_name = getText("ContextMenu_Fence_brown_Post");
	_choice = 2;
	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenFencePost, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 2, 0, _option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("Tooltip_FencePostWithGlass") .. _tooltip.description;
	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- JPM:  Beige Fence Post With Rail
	--

	ZAWISBuildMenu.neededMaterials =
	{

		{
			Material = "Plank", Amount = 1, Text = getItemText("Plank"),
		},

		{
			Material = "Screws", Amount = 4, Text = getItemText("Screws"),
		},

		{
			Material = "ZAWBlackRailing", Amount = 1, Text = getItemText("Black_Railing"),
		},

		{
			Material = "BucketPlasterFull", Amount = 1, Text = getItemText("Bucket_of_Plaster") .. " " .. getText("Tooltip_Uses"),
		},

	};
	
	ZAWISBuildMenu.neededTools = { "Hammer", "Screwdriver", "ZAWMasonryTrowel",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_BeigeFencePostWithRail");

	_sprite = {};
	_sprite.sprite = "fixtures_railings_01_115";
	_sprite.northSprite = "fixtures_railings_01_115";
	_choice = 3;
	_name = getText("ContextMenu_Beige_Fence_Post_With_Rail");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenFencePost, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 2, 0, _option, player);
	_tooltip:setName(_name);
	_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	-- JPM:  Gray Fence Post With Rail
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 1, Text = getItemText("Plank"),
		},

		{
			Material = "Screws", Amount = 4, Text = getItemText("Screws"),
		},

		{
			Material = "ZAWBlackRailing", Amount = 1, Text = getItemText("Black_Railing"),
		},

		{
			Material = "BucketPlasterFull", Amount = 1, Text = getItemText("Bucket_of_Plaster") .. " " .. getText("Tooltip_Uses"),
		},

		{
			Material = "PaintGrey", Amount = 1, Text = getItemText("Grey_Paint") .. " " .. getText("Tooltip_Uses"),
		},
	};
	
	ZAWISBuildMenu.neededTools = { "Hammer", "Screwdriver", "Paintbrush", "ZAWMasonryTrowel",};
	ZAWISBuildMenu.ODescription = getText("ContextMenu_GrayFencePostWithRail");

	_sprite = {};
	_sprite.sprite = "fixtures_railings_01_119";
	_sprite.northSprite = "fixtures_railings_01_119";
	_choice = 4;
	_name = getText("ContextMenu_Gray_Fence_Post_With_Rail");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenFencePost, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 2, 0, _option, player);
	_tooltip:setName(_name);
	_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	-- Snake:  Poste de valla con vidrio
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 1, Text = getItemText("Plank"),
		},

		{
			Material = "Screws", Amount = 2, Text = getItemText("Screws"),
		},

		{
			Material = "ZAWBlackRailing", Amount = 1, Text = getItemText("Black_Railing"),
		},
	};

	ZAWISBuildMenu.neededTools = { "Hammer","Screwdriver" };

	_sprite = {};
	_sprite.sprite = "location_shop_mall_01_27";
	_sprite.northSprite = "location_shop_mall_01_27";
	ZAWISBuildMenu.ODescription = getText("ContextMenu_FencePostWithGlass");
	_choice = 5;
	_name = getText("ContextMenu_Fence_Post_With_Glass");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenFencePost, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 2, 0, _option, player);
	_tooltip:setName(_name);
	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- Snake:  Poste de valla con vidrio de comercio
	--

	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "ZAWBlackRailing", Amount = 1, Text = getItemText("Black_Railing"),
		},

		{
			Material = "Screws", Amount = 2, Text = getItemText("Screws"),
		},
	};
	ZAWISBuildMenu.neededTools = { "Screwdriver", };
	ZAWISBuildMenu.ODescription = getText("ContextMenu_FencePostWithGlass2");

	_sprite = {};
	_sprite.sprite = "walls_commercial_01_31";
	_sprite.northSprite = "walls_commercial_01_31";
	_choice = 6;
	_name = getText("ContextMenu_Fence_Post_With_Glass2");

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenFencePost, _sprite, player, _name, _choice);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", 2, 0, _option, player);
	_tooltip:setName(_name);
	_tooltip:setTexture(_sprite.sprite);

	----------------------------------------------------------------------------------
	--
	-- Snake:  Poste de valla lujosa de piedra oscura
	--
	--_sprite = {};
	--_sprite.sprite = "walls_commercial_03_15";
	--_sprite.northSprite = "walls_commercial_03_15";

	--_name = getText("ContextMenu_Luxury_Stone_Fence_Post");

	--_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenFencePost, _sprite, player);

	--_tooltip = ZAWISBuildMenu.canBuildObject(ZAWISBuildMenu.skillLevel.wallObject, _option, player);
	--_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("Tooltip_LuxuryStoneFencePost") .. _tooltip.description;
	--_tooltip:setTexture(_sprite.sprite);

	-- JPM: The materials for metal fences.
	--ZAWISBuildMenu.neededMaterials =
	--{
	--	{
	--		Material = "SheetMetal", Amount = 1, Text = getItemText("Metal_Sheet"),
	--	},

	--	{
	--		Material = "Screws", Amount = 2, Text = getItemText("Screws"),
	--	},
	--};

	--ZAWISBuildMenu.neededTools = { "Screwdriver", };


	----------------------------------------------------------------------------------
	--
	-- JPM:  Green Metal Fence Post
	--
	--_sprite = {};
	--_sprite.sprite = "industry_railroad_05_43";
	--_sprite.northSprite = "industry_railroad_05_43";

	--_name = getText("ContextMenu_Green_Metal_Fence_Post");

	--_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildMetalFencePost, _sprite, player);

	--_tooltip = ZAWISBuildMenu.canBuildObject(ZAWISBuildMenu.skillLevel.metalArchitecture, _option, player);
	--_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("Tooltip_GreenMetalFencePost") .. _tooltip.description;
	--_tooltip:setTexture(_sprite.sprite);


	----------------------------------------------------------------------------------
	--
	-- JPM:  Red Metal Fence Post
	--
	--_sprite = {};
	--_sprite.sprite = "industry_bunker_01_27";
	--_sprite.northSprite = "industry_bunker_01_27";

	--_name = getText("ContextMenu_Red_Metal_Fence_Post");

	--_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildMetalFencePost, _sprite, player);

	--_tooltip = ZAWISBuildMenu.canBuildObject(ZAWISBuildMenu.skillLevel.metalArchitecture, _option, player);
	--_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("Tooltip_RedMetalFencePost") .. _tooltip.description;
	--_tooltip:setTexture(_sprite.sprite);


	-- JPM: The materials for stone fences.
	--ZAWISBuildMenu.neededMaterials =
	--{
	--	{
	--		Material = "ZAWBrick", Amount = 2, Text = getItemText("Ladrillo"),
	--	},

	--	{
	--		Material = "ZAWClay", Amount = 2, Text = getItemText("Arcilla"),
	--	},
	--};

	--ZAWISBuildMenu.neededTools = { "ZAWMasonryTrowel", };



	----------------------------------------------------------------------------------
	--
	-- JPM:  Rough Brick Fence Post
	--
	--_sprite = {};
	--_sprite.sprite = "construction_01_3";
	--_sprite.northSprite = "construction_01_3";

	--_name = getText("ContextMenu_Rough_Brick_Fence_Post");

	--_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildStoneFencePost, _sprite, player);

	--_tooltip = ZAWISBuildMenu.canBuildObject(ZAWISBuildMenu.skillLevel.stoneArchitecture, _option, player);
	--_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("Tooltip_RoughBrickFencePost") .. _tooltip.description;
	--_tooltip:setTexture(_sprite.sprite);

end

ZAWISBuildMenu.onBuildWoodenFencePost = function(ignoreThisArgument, sprite, player, name, choice)
	local _fencePost = ISWoodenWall:new(sprite.sprite, sprite.northSprite, nil);

	_fencePost.canPassThrough = true;
	_fencePost.canBarricade = false;
    _fencePost.player = player;
	_fencePost.name = name;
	_fencePost.modData["xp:Woodwork"] = 5;
	-- JPM: Materials required to build the object.  These might get returned on destruction.
	if choice == 1 then
		_fencePost.modData["need:Base.Plank"] = "1";
		_fencePost.modData["need:Base.Nails"] = "2";
		_fencePost.modData["use:Base.PaintWhite"] = "1";
	elseif choice == 2 then
		_fencePost.modData["need:Base.Plank"] = "1";
		_fencePost.modData["need:Base.Nails"] = "2";
	elseif choice == 3 then
		_fencePost.modData["need:Base.Plank"] = "1";
		_fencePost.modData["need:Base.Screws"] = "2";
		_fencePost.modData["need:Base.ZAWBlackRailing"] = "1";
		_fencePost.modData["use:Base.BucketPlasterFull"] = "1";
	elseif choice == 4 then
		_fencePost.modData["need:Base.Plank"] = "1";
		_fencePost.modData["need:Base.Screws"] = "4";
		_fencePost.modData["need:Base.ZAWBlackRailing"] = "1";
		_fencePost.modData["use:Base.BucketPlasterFull"] = "1";
		_fencePost.modData["use:Base.PaintGrey"] = "1";
	elseif choice == 5 then
		_fencePost.modData["need:Base.Plank"] = "1";
		_fencePost.modData["need:Base.Screws"] = "2";
		_fencePost.modData["need:Base.ZAWBlackRailing"] = "1";
	elseif choice == 6 then
		_fencePost.modData["need:Base.ZAWBlackRailing"] = "1";
		_fencePost.modData["need:Base.Screws"] = "2";
	end

	getCell():setDrag(_fencePost, player);
end

ZAWISBuildMenu.cratesMenuBuilder = function(subMenu, player)
	local _sprite = nil;
	local _option = nil;
	local _tooltip = nil;
	local _name = "";
	local _icon = "";


	-- JPM: Cardboard boxes and crates are the same as the default wooden crates.
	ZAWISBuildMenu.neededMaterials =
	{
		{
			Material = "Plank", Amount = 6, Text = getItemText("Plank"),
		},

		{
			Material = "Nails", Amount = 10, Text = getItemText("Nails"),
		},
	};

	ZAWISBuildMenu.neededTools = { "Hammer", };
	ZAWISBuildMenu.ODescription = getText("Tooltip_Palletdesc");


	----------------------------------------------------------------------------------
	--
	-- Pallet
	--
	_sprite = {};
	_sprite.sprite = "walls_exterior_zaw_01_67";
	_sprite.northSprite = "walls_exterior_zaw_01_26";

	_name = getText("ContextMenu_Pallet");
	_icon = "crate";

	_option = subMenu:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenContainer, _sprite, player, _name, _icon);

	_tooltip = ZAWISBuildMenu.canBuildObject("NONE", ZAWISBuildMenu.skillLevel.simpleContainer, 0,_option, player);
	_tooltip:setName(_name);
	--_tooltip.description = "<RGB:1,1,0>" .. getText("Tooltip_Palletdesc") .. _tooltip.description;
	_tooltip:setTexture(_sprite.northSprite);
end

ZAWISBuildMenu.onBuildWoodenContainer = function(ignoreThisArgument, sprite, player, name, icon)
	local _container = ISWoodenContainer:new(sprite.sprite, sprite.northSprite);
	_container.containerType = "brickpallet";
	--_container.canBeAlwaysPlaced = true;
    _container.player = player;
	_container.name = name;
	_container.canBeAlwaysPlaced = false;

	if sprite.eastSprite then
		_container:setEastSprite(sprite.eastSprite);
	end

	if sprite.southSprite then
		_container:setSouthSprite(sprite.southSprite);
	end

	-- JPM: Materials required to build the object.  These might get returned on destruction.
	_container.modData["need:Base.Plank"] = "6";
	_container.modData["need:Base.Nails"] = "10";

	-- JPM: This violates a few best practices for coding, but it allows the health
	--      to be set without creating a new file to inherit.  It also allows for
	--      the correct icon to show up when looting the container.
	--function _container:getHealth()
		--self.javaObject:getContainer():setType(icon);
		--return ZAWISBuildMenu.healthLevel.woodContainer + buildUtil.getWoodHealth(self);
	--end
	_container.renderFloorHelper = true;
	getCell():setDrag(_container, player);
end

ZAWISBuildMenu.windowFramesMenuBuilder = function(subMenu, player)
	local _sprite = nil;
	local _option = nil;
	local _tooltip = nil;
	local _name = "";
	local _choice = "";
	--ZAWISBuildMenu._name = _name;

	if LGISBuildMenu then
	
	else
		--  Setting the materials once for the following objects as they all use
		--      the same materials list to build with.

		----------------------------------------------------------------------------------
		--
		-- Advanced Window Metal Frame
		--

		ZAWISBuildMenu.neededMaterials =
		{
			{
				Material = "Screws", Amount = 10, Text = getItemText("Screws"),
			},

			{
				Material = "MetalPipe", Amount = 8, Text = getItemText("Metal_Pipe"),
			},
		};

		ZAWISBuildMenu.neededTools = { "Hammer",};
		ZAWISBuildMenu.ODescription = getText("Tooltip_craft_AdvancedMetalWindowFramedesc");

		_sprite = {};
		_sprite.sprite = "walls_exterior_zaw_01_32";
		_sprite.northSprite = "walls_exterior_zaw_01_33";
		_choice = 1;
		_name = getText("ContextMenu_AdvancedMetalWindowFrame");
		_option = subMenu[getText("ContextMenu_AdvancedFrames")]:addOption(_name, nil, ZAWISBuildMenu.onBuildWoodenWindowFrame, _sprite, player, _name, _choice);
		
		_tooltip = ZAWISBuildMenu.canBuildObject("Advanced metal frames", 8, 2, _option, player);
		_tooltip:setName(_name);

		_tooltip:setTexture(_sprite.sprite);
	end
end

ZAWISBuildMenu.onBuildWoodenWindowFrame = function(ignoreThisArgument, sprite, player, name, choice)
	local _windowFrame = ISWoodenWall:new(sprite.sprite, sprite.northSprite, sprite.corner);

	_windowFrame.canBePlastered = ZAWISBuildMenu.playerCanPlaster;
	_windowFrame.hoppable = true;
	_windowFrame.isThumpable = false;
	_windowFrame.canBarricade = false;
	_windowFrame.player = player;
	_windowFrame.name = "AdvancedMetalWindowFrame";
	_windowFrame.modData["wallType"] = "windowsframe";
	-- JPM: Materials required to build the object.  These might get returned on destruction.
	_windowFrame.modData["need:Base.Screws"] = "10";
	_windowFrame.modData["need:Base.MetalPipe"] = "8";

	getCell():setDrag(_windowFrame, player);
end

ZAWISBuildMenu.filldata = function(player)
	if LGISBuildMenu then
		ZAWISBuildMenu.playerCarpentrySkill = getSpecificPlayer(player):getPerkLevel(Perks.Woodwork);
		ZAWISBuildMenu.playermetalworkSkill = getSpecificPlayer(player):getPerkLevel(Perks.MetalWelding);

		ZAWISBuildMenu.textCarpentryRed = " <RGB:1,0,0>" .. getText("IGUI_perks_Carpentry") .. " " .. ZAWISBuildMenu.playerCarpentrySkill .. "/";
		ZAWISBuildMenu.textCarpentryGreen = " <RGB:1,1,1>" .. getText("IGUI_perks_Carpentry") .. " ";

		ZAWISBuildMenu.textMetalworkRed = " <RGB:1,0,0>" .. getText("IGUI_perks_MetalWelding") .. " " .. ZAWISBuildMenu.playermetalworkSkill .. "/";
		ZAWISBuildMenu.textMetalworkGreen = " <RGB:1,1,1>" .. getText("IGUI_perks_MetalWelding") .. " ";
	
	
		ZAWISBuildMenu.buildMaterialsList(player);
	else
	
	end
end