require ("TimedActions/ISBaseTimedAction");

LGLearnRecipeAction = ISBaseTimedAction:derive("LGLearnRecipeAction");

function LGLearnRecipeAction:isValid()
	return ((self.character:getPrimaryHandItem() ~= nil and self.character:getPrimaryHandItem():getType() == (self.item:getType())) or (self.character:getSecondaryHandItem() ~= nil and self.character:getSecondaryHandItem():getType() == (self.item:getType())) and not self.character:getKnownRecipes():contains(self.recipe));
end

function LGLearnRecipeAction:update()
    self.item:setJobDelta(self:getJobDelta());
end

function LGLearnRecipeAction:start()
    self.item:setJobDelta(0.0);
end


function LGLearnRecipeAction:stop()
	ISBaseTimedAction.stop(self);
	self.item:setJobDelta(0.0);
end

function LGLearnRecipeAction:perform()

    ISBaseTimedAction.perform(self);
	self.item:setJobDelta(0.0);

	local plrecipe = self.character:getKnownRecipes();
	if not plrecipe:contains(self.recipe) then
		plrecipe:add(self.recipe);
		luautils.okModal(getText("ContextMenu_Learned") .. getText(self.Recipetranslation), true);
	end

end

function LGLearnRecipeAction:new(character, item, time, RecipetoLearn, Recipetranslation)
	local o = {};
	setmetatable(o, self);
	self.__index = self;
	o.character = character;
	o.item = item;
	o.recipe = RecipetoLearn;
	o.Recipetranslation = Recipetranslation;
	o.stopOnWalk = true;
	o.stopOnRun = true;
	o.maxTime = time;
	return o;
end