LGHuntingRocksMenu = {};
LGHuntingRocksMenu.img = {};
LGHuntingRocksMenu.fetchSquares = {}

-- Fenris: new function checks if the item is a ORGM rifle, returns bool.
LGHuntingRocksMenu.isORGMRifle = function(item)
    if item:getModule() == 'ORGM' then
        local gunData = ORGM.Firearm.getData(item)
        if gunData.category == ORGM.RIFLE then return true end
    end
    return false
end

-- Fenris: new table holding totalpercent bonuses for LGHuntingRocksMenu.getcapturedata2()
-- much cleaner then having them all hardcoded into the function.
-- Since actual scopes in ORGM are rarely used and differ in power (x8 Max vs x40)
-- the bonus given to them are slightly different (for balancing)
LGHuntingRocksMenu.ScopeTable ={
    ["x4Scope"] = 2,
    ["x8Scope"] = 4,
    ["x20Scope"] = 5,
    ["x40Scope"] = 6,
    ["StealthTacticalScope"] = 7,
    ["StealthTacticalScope2"] = 8,
    -- orgm
    ["2xScope"] = 2,
    ["4xScope"] = 4,
    ["8xScope"] = 8,
}


LGHuntingRocksMenu.clearFetch = function()
	htree = nil;
	htree2 = nil;
	capture = nil;
	capture2 = nil;
	data = nil;
	LGHuntingRocksMenu.fetchSquares = {}
end

LGHuntingRocksMenu.fetch = function(v, player, doSquare)
	if instanceof(v, "IsoTree") and v:getSize() > 2 and v:getSquare():DistToProper(getSpecificPlayer(player):getSquare()) > 5 and v:getSquare():getZone() and
	  (v:getSquare():getZone():getType() == "Forest" or v:getSquare():getZone():getType() == "DeepForest" or
	  v:getSquare():getZone():getType() == "Vegitation" or v:getSquare():getZone():getType() == "FarmLand") then
		htree = v
	end
	if instanceof(v, "IsoTree") and v:getSize() > 2 and v:getSquare():DistToProper(getSpecificPlayer(player):getSquare()) > 8 and v:getSquare():getZone() and
	  (v:getSquare():getZone():getType() == "Forest" or v:getSquare():getZone():getType() == "DeepForest") then
		htree2 = v
	end
	LGHuntingRocksMenu.fetchSquares[v:getSquare()] = true
end

LGHuntingRocksMenu.initContextMenu = function(player, context, worldobjects)

	local playerObj = getSpecificPlayer(player);

	LGHuntingRocksMenu.clearFetch()
    for i,v in ipairs(worldobjects) do
		LGHuntingRocksMenu.fetch(v, player, true);
    end

	local binocular = playerObj:getInventory():contains("LgBinoculars");
	local slingshot = playerObj:getInventory():contains("Slingshot") or playerObj:getInventory():contains("Slingshot2");
	local rock = playerObj:getInventory():contains("Stone");
	if htree or htree2 then
		local clickedSquare = nil;
		local zonenumber = 0;
		if htree then
			clickedSquare = htree;
		elseif htree2 then
			clickedSquare = htree2;
		end
		local text = "";
		local zone = ISScavengeAction.getScavengingZone(clickedSquare:getX(), clickedSquare:getY());
		if not zone then
			text = "(100" .. getText("ContextMenu_FullPercent") .. ")"
			zonenumber = 100
		else
			if zone:getName() == "0" then
				text = "(" .. getText("ContextMenu_Empty") .. ")";
				zonenumber = 0;
			else
				text = "(" .. math.floor((tonumber(zone:getName()) / tonumber(zone:getOriginalName())) * 100) .. getText("ContextMenu_FullPercent") .. ")";
				zonenumber = math.floor((tonumber(zone:getName()) / tonumber(zone:getOriginalName())) * 100);
			end
		end
		--context:addOption(getText("ContextMenu_Forage") .. " " .. text, nil, ISWorldObjectContextMenu.onScavenge, player, scavengeZone, clickedSquare);

		if htree then
			if binocular then
				capture = LGHuntingRocksMenu.getcapturedata(zonenumber);
				local exploreoption = context:addOption(getText("ContextMenu_ExploreTree")  .. " " .. text, htree, LGHuntingRocksMenu.ExploreandTrowrock, player, capture);
				local tooltipexplore = ISWorldObjectContextMenu.addToolTip();
				tooltipexplore:setName(getText("ContextMenu_ExploreTree"));
				tooltipexplore.description = tooltipexplore.description .. " <RGB:1,1,1> " .. getText("ContextMenu_ExploreTreeTT") .. " <LINE> ";
				tooltipexplore:setTexture("media/textures/Item_LgBinoculars.png");
				exploreoption.toolTip = tooltipexplore;
			elseif slingshot and rock and (not binocular) then
				capture = LGHuntingRocksMenu.getcapturedata(zonenumber);
				local trockoption = context:addOption(getText("ContextMenu_TrowRock") .. " " .. text, htree, LGHuntingRocksMenu.ExploreandTrowrock, player, capture);
				local tooltiptrock = ISWorldObjectContextMenu.addToolTip();
				tooltiptrock:setName(getText("ContextMenu_TrowRock"));
				if playerObj:getInventory():contains("Slingshot2") then
					tooltiptrock.description = tooltiptrock.description .. " <RGB:1,1,1> " .. getText("ContextMenu_TrowRockTT2") .. " <LINE> ";
					tooltiptrock:setTexture("media/textures/Item_Slingshot2.png");
				else
					tooltiptrock.description = tooltiptrock.description .. " <RGB:1,1,1> " .. getText("ContextMenu_TrowRockTT") .. " <LINE> ";
					tooltiptrock:setTexture("media/textures/Item_Gomera1.png");
				end
				trockoption.toolTip = tooltiptrock;
			end
		end
		local Item = playerObj:getPrimaryHandItem();
		if htree2 and (instanceof(Item, "HandWeapon") and Item:getCondition() > 0) and Item:getScope() then

            -- Fenris: added call to LGHuntingRocksMenu.isORGMRifle()
            if (Item:getType() == "VarmintRifle" or Item:getType() == "HuntingRifle") or LGHuntingRocksMenu.isORGMRifle(Item) then
                local scope = Item:getScope()
                -- Fenris: check the ScopeTable to see if its valid
				if LGHuntingRocksMenu.ScopeTable[scope:getType()] then
					capture2 = LGHuntingRocksMenu.getcapturedata2();
					local searchoption = context:addOption(getText("ContextMenu_HuntwithRifle") .. " " .. text, htree2, LGHuntingRocksMenu.Exploreandshoot, player, capture2);
					local tooltipexplore = ISWorldObjectContextMenu.addToolTip();
					tooltipexplore:setName(getText("ContextMenu_HuntwithRifle"));
					if zonenumber < 100 then
						searchoption.notAvailable = true;
						tooltipexplore.description = tooltipexplore.description .. " <RGB:1,1,1> " .. getText("ContextMenu_HuntwithRifleTT") .. " <LINE> <LINE> <RGB:1,0,0> ".. getText("ContextMenu_CantHuntwithRifleTT");
					else
						tooltipexplore.description = tooltipexplore.description .. " <RGB:1,1,1> " .. getText("ContextMenu_HuntwithRifleTT") .. " <LINE> ";
					end
					tooltipexplore:setTexture("media/ui/HLogo/HuntingLogo.png");
					searchoption.toolTip = tooltipexplore;
				end
			end
		end
	end
end

LGHuntingRocksMenu.getcapturedata = function(zonenumber)
	local capture;
	if zonenumber > 0 then
		local playerObj = getPlayer();
		local totalpercent = 5;
		local variable = 0;
		local perklvl = playerObj:getPerkLevel(Perks.PlantScavenging);
		local winter = nil;
		if perklvl > 0 then
			variable = perklvl;
			totalpercent = totalpercent + (variable *2);
		end
		if playerObj:HasTrait("ShortSighted") then
			totalpercent = totalpercent - 10;
		elseif playerObj:HasTrait("EagleEyed") then
			totalpercent = totalpercent + 10;
		end
		if playerObj:HasTrait("Lucky") then
			totalpercent = totalpercent + ZombRand(11);
		elseif playerObj:HasTrait("Unlucky") then
			totalpercent = totalpercent - ZombRand(11);
		else
			if ZombRand(2) == 0 then
				totalpercent = totalpercent + ZombRand(6);
			else
				totalpercent = totalpercent - ZombRand(6);
			end
		end

		-- No podran encontrarse especies habitualmente entre los meses de noviembre y febrero.
		if (getGameTime():getMonth() + 1) >= 11 or (getGameTime():getMonth() + 1) <= 2 then
			totalpercent = totalpercent - ZombRand(25,50);
			winter = true;
		end

		if totalpercent <= 0 then
			totalpercent = 2;
		end
		if totalpercent >= 100 then
			totalpercent = 100;
		end
		if ZombRand(1, 101) <= totalpercent then
			local choose = ZombRand(1, 101);
			if winter ~= nil then
				--Temporada Invierno
				--50%cuervo
				--30%panal
				--20%zombie
				if choose >= 80 then
					capture = "Base.Duffelbag";
				elseif choose >= 50 then
					capture = "Base.BeeNest";
				elseif choose >= 1 then
					capture = "Base.DeadCrow";
				else
					capture = "nothing";
				end
			else
				--Temporada Normal
				--24%cuervo
				--15%canario
				--10%rata
				--10%Ardilla
				--10%pajaro
				--10%panal
				--5%gallina
				--5%Nido de ave
				--1%zombie
				if choose == 100 then
					capture = "Base.Duffelbag";
				elseif choose >= 95 then
					capture = "Base.ChickenDead";
				elseif choose >= 75 then
					capture = "Base.BeeNest";
				elseif choose >= 65 then
					capture = "Base.DeadBird";
				elseif choose >= 55 then
					capture = "Base.DeadSquirrel";
				elseif choose >= 45 then
					capture = "Base.DeadRat";
				elseif choose >= 30 then
					capture = "Base.DeadCanary";
				elseif choose >= 25 then
					capture = "Base.BirdNest";
				elseif choose >= 1 then
					capture = "Base.DeadCrow";
				else
					capture = "nothing";
				end
			end
		else
			capture = "nothing";
		end
	elseif zonenumber < 1 then
		capture = "nothing";
	end

--	capture = "Base.Duffelbag"; --*Borrame

	return capture;
end

LGHuntingRocksMenu.getcapturetable = function(capture)
	local data;
	if capture == "Base.Duffelbag" then
		data = "Zombie";
	elseif capture == "Base.ChickenDead" then
		data = "Chicken";
	elseif capture == "Base.BeeNest" then
		data = "Bee";
	elseif capture == "Base.DeadBird" then
		data = "Bird";
	elseif capture == "Base.DeadSquirrel" then
		data = "Squirrel";
	elseif capture == "Base.DeadRat" then
		data = "Rat";
	elseif capture == "Base.DeadCanary" then
		data = "Canary";
	elseif capture == "Base.BirdNest" then
		data = "BNest";
	elseif capture == "Base.DeadCrow" then
		data = "Crow";
	elseif capture == "nothing" then
		data = "Nothing";
	else
		data = "Nothing";
	end

	return data;
end

LGHuntingRocksMenu.getscopetable = function(capture2)
	local data;
	if capture2 == "Base.DeadBison" then
		data = "Bison";
	elseif capture2 == "Base.DeadPork" then
		data = "Pork";
	elseif capture2 == "Base.DeadMoose" then
		data = "Moose";
	elseif capture2 == "Base.DeadDeer" then
		data = "Deer";
	elseif capture2 == "Base.DeadCow" then
		data = "Cow";
	elseif capture2 == "Base.DeadBear" then
		data = "Bear";
	elseif capture2 == "nothing" then
		data = "Empty";
	else
		data = "Empty";
	end
	return data;
end

LGHuntingRocksMenu.getcapturedata2 = function()
	local capture2;
	local playerObj = getPlayer();
	local totalpercent = 5;
	local variable = 0;
	local perklvl = playerObj:getPerkLevel(Perks.PlantScavenging);
	local Primary = playerObj:getPrimaryHandItem();
	local winter = nil;
	if perklvl > 0 then
		variable = perklvl;
		totalpercent = totalpercent + variable;
	end
	if (instanceof(Primary, "HandWeapon") and Primary:getCondition() > 0) then
        -- Fenris: added call to LGHuntingRocksMenu.isORGMRifle()
		if Primary:getType() == "VarmintRifle" or Primary:getType() == "HuntingRifle" or LGHuntingRocksMenu.isORGMRifle(Primary) then
			if Primary:getScope() ~= nil then
                -- Fenris: check the LGHuntingRocksMenu.ScopeTable to get our bonus to totalpercent
                local scopeType = Primary:getScope():getType()
                totalpercent = totalpercent + (LGHuntingRocksMenu.ScopeTable[scopeType] or 0)
			end
		end
	end
	if playerObj:HasTrait("ShortSighted") then
		totalpercent = totalpercent - 10;
	elseif playerObj:HasTrait("EagleEyed") then
		totalpercent = totalpercent + 10;
	end
	if playerObj:HasTrait("Lucky") then
		totalpercent = totalpercent + ZombRand(11);
	elseif playerObj:HasTrait("Unlucky") then
		totalpercent = totalpercent - ZombRand(11);
	else
		if ZombRand(2) == 0 then
			totalpercent = totalpercent + ZombRand(6);
		else
			totalpercent = totalpercent - ZombRand(6);
		end
	end

	-- No podran encontrarse especies habitualmente entre los meses de noviembre y febrero.
	if (getGameTime():getMonth() + 1) >= 11 or (getGameTime():getMonth() + 1) <= 2 then
		totalpercent = totalpercent - ZombRand(38,50); --Reducción random de porcentaje durante los meses de noviembre y febrero
		winter = true;
	end

	if totalpercent <= 0 then
		totalpercent = 2; --2%de probabilidad de hallar animales en el caso de que el porcentaje de menor o igual a 0.
	end
	if totalpercent >= 100 then
		totalpercent = 100;
	end

	--totalpercent = 100; --*Borrame

	if ZombRand(1, 101) <= totalpercent then
		local choose = ZombRand(1, 101);
		if winter ~= nil then
			--Temporada de Invierno:
			--5%Bison
			--10%Jabalí
			--85%Alce
			if choose <= 5 then
				capture2 = "Base.DeadBison";
			elseif choose <= 15 then
				capture2 = "Base.DeadPork";
			else
				capture2 = "Base.DeadMoose";
			end
		else
			--Temporada Normal:
			--10%Ciervo
			--5%Jabalí
			--5%Vaca
			--80%Oso
			if choose <= 10 then
				capture2 = "Base.DeadDeer";
			elseif choose <= 15 then
				capture2 = "Base.DeadPork";
			elseif choose <= 20 then
				capture2 = "Base.DeadCow";
			else
				capture2 = "Base.DeadBear";
			end
		end
	else
		capture2 = "nothing";
	end
	--capture2 = "Base.DeadMoose"; --*Borrame
	return capture2;
end

LGHuntingRocksMenu.Exploreandshoot = function(htree2, player, capture2)
	local playerObj = getSpecificPlayer(player);
	local image = nil;

	local currentHour = math.floor(math.floor(GameTime:getInstance():getTimeOfDay() * 3600) / 3600);
	local day = false;
	if currentHour >= 4 and currentHour <= 20 then
		day = true;
	end

	-- Seteo de imagen segun tablas----------------------------------
	local data = LGHuntingRocksMenu.getscopetable(capture2);
	local datatable = LGHT.Firearm[data];
	if day == true then
		image = datatable.day[ZombRand(1, #datatable.day +1)];
	else
		image = datatable.night[ZombRand(1, #datatable.night +1)];
	end
	------------------------------------------------------------------
	if capture2 ~= "nothing" then
		if playerObj:getPerkLevel(Perks.PlantScavenging) < 10 then
			local oldXp = playerObj:getXp():getXP(Perks.PlantScavenging);
			playerObj:getXp():AddXP(Perks.PlantScavenging, 3);
			local xp = playerObj:getXp():getXP(Perks.PlantScavenging) - oldXp;
			playerObj:setHaloNote(getText("IGUI_perks_Foraging").."+"..tonumber(string.format("%." .. (2 or 0) .. "f", xp)), 0,255,0,300);
		end
	end

	playerObj:faceLocation(htree2:getX(), htree2:getY());

	local centered = true;
	local posX;
	local posY;
	local width = 400;
	local height = 300;
	local core = getCore();
	if centered ~= nil then
		posX = core:getScreenWidth() * 0.5 - width * 0.5;
		posY = core:getScreenHeight() * 0.5 - height * 0.5;
	end
	if image ~= nil then
		image = "<H1> " .. image .. " <LINE> <H1>"
	end
	image = image .. getText("Tooltip_Shootwithrifle");
	local modal = ISModalRichText2:new(posX, posY, width, height, image, true, nil, LGHuntingRocksMenu.onYesButtonClick2, player, htree2, capture2);
	modal:initialise();
	modal:addToUIManager();

	if capture2 == "Base.DeadBear" or capture2 == "Base.DeadPork" or capture2 == "Base.DeadBison" or capture2 == "Base.DeadMoose" then
		getSoundManager():PlayWorldSound("ZombieSurprisedPlayer", htree:getSquare(), 0, 5, 1, true);
		if not playerObj:HasTrait("Desensitized") then
			local panicvar = 35;
			if playerObj:HasTrait("Brave") then
				panicvar = 10;
			elseif playerObj:HasTrait("Cowardly") then
				panicvar = 50;
			end
			playerObj:getStats():setPanic(playerObj:getStats():getPanic() + panicvar);
		end
	end
end

LGHuntingRocksMenu.ExploreandTrowrock = function(htree, player, capture)
	local playerObj = getSpecificPlayer(player);
	local binocular = playerObj:getInventory():contains("LgBinoculars");
	local slingshot = playerObj:getInventory():contains("Slingshot") or playerObj:getInventory():contains("Slingshot2");
	local rock = playerObj:getInventory():contains("Stone");
	local image = nil;

	local currentHour = math.floor(math.floor(GameTime:getInstance():getTimeOfDay() * 3600) / 3600);
	local day = false;
	if currentHour >= 4 and currentHour <= 20 then
		day = true;
	end
	-- Seteo de imagen segun tablas----------------------------------
	local data = LGHuntingRocksMenu.getcapturetable(capture);
	local datatable = LGHT.Slingshot[data];
	if day == true then
		image = datatable.day[ZombRand(1, #datatable.day +1)];
	else
		if playerObj:HasTrait("NightVision") then
			image = datatable.nv[ZombRand(1, #datatable.nv +1)];
		else
			image = datatable.night[ZombRand(1, #datatable.night +1)];
		end
	end
	------------------------------------------------------------------

	if capture ~= "nothing" then
		if playerObj:getPerkLevel(Perks.PlantScavenging) < 10 then
			local oldXp = playerObj:getXp():getXP(Perks.PlantScavenging);
			playerObj:getXp():AddXP(Perks.PlantScavenging, 3);
			local xp = playerObj:getXp():getXP(Perks.PlantScavenging) - oldXp;
			playerObj:setHaloNote(getText("IGUI_perks_Foraging").."+"..tonumber(string.format("%." .. (2 or 0) .. "f", xp)), 0,255,0,300);
		end
	end
	if binocular and (not slingshot or not rock) then
		local item = playerObj:getInventory():getItemFromType("LgBinoculars");
		if not item:isEquipped() then
			ISTimedActionQueue.add(ISEquipWeaponAction:new(playerObj, item, 50, true, true));
		end
		playerObj:faceLocation(htree:getX(), htree:getY());
		--luautils.okRichModal(image, true, 400, 300);
		local centered = true;
		local posX;
		local posY;
		local width = 400;
		local height = 300;
		local core = getCore();
		if centered ~= nil then
			posX = core:getScreenWidth() * 0.5 - width * 0.5;
			posY = core:getScreenHeight() * 0.5 - height * 0.5;
		end
		if image ~= nil then
			image = "<H1> " .. image .. " <LINE> <H1>"
		end
		local modal = ISModalRichText2:new(posX, posY, width, height, image, false, nil, nil, player, htree, capture);

		modal:initialise();
		modal:addToUIManager();
		if capture == "Base.Duffelbag" then
			getSoundManager():PlayWorldSound("ZombieSurprisedPlayer", htree:getSquare(), 0, 5, 1, true);
			if not playerObj:HasTrait("Desensitized") then
				local panicvar = 25;
				if playerObj:HasTrait("Brave") then
					panicvar = 5;
				elseif playerObj:HasTrait("Cowardly") then
					panicvar = 45;
				end
				playerObj:getStats():setPanic(playerObj:getStats():getPanic() + panicvar);
			end
		end
	elseif slingshot and rock and (not binocular) then
		if playerObj:getInventory():contains("Slingshot2") then
			luautils.equipItems(playerObj, "Base.Slingshot2", "Base.Stone");
		else
			luautils.equipItems(playerObj, "Base.Slingshot", "Base.Stone");
		end
		ISTimedActionQueue.add(LGHuntingRocksAction:new(playerObj, htree, 50, capture));
	elseif slingshot and rock and binocular then
		local item = playerObj:getInventory():getItemFromType("LgBinoculars");
		if not item:isEquipped() then
			ISTimedActionQueue.add(ISEquipWeaponAction:new(playerObj, item, 50, true, true));
		end
		playerObj:faceLocation(htree:getX(), htree:getY());

		local centered = true;
		local posX;
		local posY;
		local width = 400;
		local height = 300;
		local core = getCore();
		if centered ~= nil then
			posX = core:getScreenWidth() * 0.5 - width * 0.5;
			posY = core:getScreenHeight() * 0.5 - height * 0.5;
		end
		if image ~= nil then
			image = "<H1> " .. image .. " <LINE> <H1>"
		end
		image = image .. getText("Tooltip_Shoot");

		local modal = ISModalRichText2:new(posX, posY, width, height, image, true, nil, LGHuntingRocksMenu.onYesButtonClick, player, htree, capture);
		modal:initialise();
		modal:addToUIManager();

		if capture == "Base.Duffelbag" then
			getSoundManager():PlayWorldSound("ZombieSurprisedPlayer", htree:getSquare(), 0, 5, 1, true);
			if not playerObj:HasTrait("Desensitized") then
				local panicvar = 25;
				if playerObj:HasTrait("Brave") then
					panicvar = 5;
				elseif playerObj:HasTrait("Cowardly") then
					panicvar = 45;
				end
				playerObj:getStats():setPanic(playerObj:getStats():getPanic() + panicvar);
			end
		end
	end
end

function LGHuntingRocksMenu:onYesButtonClick(button, htree, capture)
    if button.internal == "YES" then
		local playerObj = getPlayer();
		local binocular = playerObj:getInventory():contains("LgBinoculars");
		local slingshot = playerObj:getInventory():contains("Slingshot") or playerObj:getInventory():contains("Slingshot2");
		local rock = playerObj:getInventory():contains("Stone");

		if not slingshot then return; end
		if not rock then return; end
		if not binocular then return; end

		if slingshot and binocular and rock then
			if playerObj:getInventory():contains("Slingshot2") then
				luautils.equipItems(playerObj, "Base.Slingshot2", "Base.Stone");
			else
				luautils.equipItems(playerObj, "Base.Slingshot", "Base.Stone");
			end
			local _capture = capture;
			ISTimedActionQueue.add(LGHuntingRocksAction:new(playerObj, htree, 50, _capture))
		end
    end
end

function LGHuntingRocksMenu:onYesButtonClick2(button, htree2, capture2)
    if button.internal == "YES" then
		local playerObj = getPlayer();
		local _capture2 = capture2;
		ISTimedActionQueue.add(LGHuntingScopeAction:new(playerObj, htree2, 20, _capture2))
    end
end

Events.OnPreFillWorldObjectContextMenu.Add(LGHuntingRocksMenu.initContextMenu);
