----------------------------------------------------------------------------------
--
-- LGHuntingRocksAction.lua
-- Parte del mod Le Gourmet Evolution.
-- Creado por Snake.
--
----------------------------------------------------------------------------------

require "TimedActions/ISBaseTimedAction"

LGHuntingRocksAction = ISBaseTimedAction:derive("LGHuntingRocksAction");


function LGHuntingRocksAction:isValid()
	return true;
end


function LGHuntingRocksAction:update()
    self.character:faceLocation(self.htree:getX(), self.htree:getY())
end


function LGHuntingRocksAction:start()
    self.character:playSound("SlingshotShoot", true);
	if self.character:getSecondaryHandItem() ~= nil and self.character:getSecondaryHandItem():getType() == "Stone" then
		self.character:getSecondaryHandItem():Use();
		self.character:setSecondaryHandItem(nil);
	end
end


function LGHuntingRocksAction:stop()
    ISBaseTimedAction.stop(self);
end


function LGHuntingRocksAction:perform()

	self.character:getStats():setEndurance(self.character:getStats():getEndurance() - 0.02)

	local _inventory = self.character:getInventory();


	if self.character:getPrimaryHandItem() ~= nil and (self.character:getPrimaryHandItem():getType() == "Slingshot" or self.character:getPrimaryHandItem():getType() == "Slingshot2") then
		local chancetobreak = 3;
		local number = 5;
		if self.character:getPrimaryHandItem():getType() == "Slingshot2" then
			chancetobreak = (chancetobreak + self.character:getPerkLevel(Perks.Woodwork)) * 2;
			number = 3;
		else
			chancetobreak = chancetobreak;
			number = number;
		end
		if ZombRand(chancetobreak) == 0 then
			--local Data = self.character:getPrimaryHandItem():getModData();
			if self.character:getPrimaryHandItem():getModData().SlingshotDurability and self.character:getPrimaryHandItem():getModData().SlingshotDurability > 0 then
				self.character:getPrimaryHandItem():getModData().SlingshotDurability = self.character:getPrimaryHandItem():getModData().SlingshotDurability - ZombRand(number);
			end
			local ItemName;
			if self.character:getPrimaryHandItem():getType() == "Slingshot2" then
				ItemName = "Base.SlingshotHandle"
			else
				ItemName = "Base.Twigs"
			end
			if self.character:getPrimaryHandItem().SlingshotDurability and self.character:getPrimaryHandItem():getModData().SlingshotDurability == 0 then
				self.character:getPrimaryHandItem():Use();
				self.character:setPrimaryHandItem(nil);
				self.character:playSound("BreakLockOnWindow", true);
				_inventory:AddItem(ItemName);
			end
		end
	end
	if self.capture ~= "nothing" then
		local totalpercent = 15;
		local variable = 0;
		local perklvl = self.character:getPerkLevel(Perks.Aiming);
		if perklvl > 0 then
			variable = perklvl * 4;
			totalpercent = totalpercent + variable;
		end
		if self.character:HasTrait("ShortSighted") then
			totalpercent = totalpercent - 10;
		elseif self.character:HasTrait("EagleEyed") then
			totalpercent = totalpercent + 10;
		end
		if not self.character:HasTrait("Desensitized") then
			local paniclvl = self.character:getStats():getPanic();
			if paniclvl > 0 then
				local panicvariable = 0;
				if paniclvl > 0 and paniclvl < 25 then
					panicvariable = 5;
				elseif paniclvl > 25 and paniclvl < 50 then
					panicvariable = 10;
				elseif paniclvl > 50 and paniclvl < 75 then
					panicvariable = 15;
				elseif paniclvl > 75 and paniclvl < 100 then
					panicvariable = 20;
				end
				totalpercent = totalpercent - panicvariable;
			end
		end
		if totalpercent <= 0 then
			totalpercent = 1;
		end
		if totalpercent >= 100 then
			totalpercent = 100;
		end

		if ZombRand(1, 101) <= totalpercent then
			self.character:playSound("SlingshotHit", true);
			local AnimalSize = 0;
			local AnimalWeigthChange = 1;
			local data = LGHuntingRocksMenu.getcapturetable(self.capture);
			local datatable = LGHT.Slingshot[data];
			if datatable.sound ~= nil then
				getSoundManager():PlayWorldSound(datatable.sound, self.htree:getSquare(), 0, 10, 1, true);
			end
			if datatable.minsize ~= nil and datatable.maxsize ~= nil then
				AnimalSize = ZombRand(datatable.minsize, datatable.maxsize);
			end
			if datatable.weigthchange ~= nil then
				AnimalWeigthChange = datatable.weigthchange;
			end

			if self.capture == "Base.Duffelbag" then
				local luck1 = self:getLuck();
				local luck2 = self:getLuck();
				local luck3 = self:getLuck() + ZombRand(1,11);
				if ZombRand(1, 101) <= luck1 then
					local item1 = "None";
					if ZombRand(1, 101) <= luck2 then
						item1 = "Base.Rope";
					else 
						item1 = "Base.SheetRope";
					end
					if item1 ~= "None" then
						self.htree:getSquare():AddWorldInventoryItem(item1, self.htree:getX() - math.floor(self.htree:getX()), self.htree:getY() - math.floor(self.htree:getY()), self.htree:getZ() - math.floor(self.htree:getZ()));
					end
					spawnHorde(self.htree:getX(), self.htree:getY(), self.htree:getX(), self.htree:getY(), self.htree:getZ(), 1);
					if not self.character:HasTrait("Desensitized") then
						local panicvar = 15;
						if self.character:HasTrait("Brave") then
							panicvar = 5;
						elseif self.character:HasTrait("Cowardly") then
							panicvar = 25;
						end
						self.character:getStats():setPanic(self.character:getStats():getPanic() + panicvar);
					end
				end
				if ZombRand(1, 101) <= luck3 then
					local bag = self.htree:getSquare():AddWorldInventoryItem(self.capture, self.htree:getX() - math.floor(self.htree:getX()), self.htree:getY() - math.floor(self.htree:getY()), self.htree:getZ() - math.floor(self.htree:getZ()));
					local bagtype = ZombRand(1, 7);
					local subtype = "NoMods";
					local bagname = "";
					if bagtype == 1 then
						bagname = "WeaponBag";
						if AMBaseGameCharacterDetails then
							subtype = "AmmoMaker";
						else
							subtype  = "NoMods";
						end
					elseif bagtype == 2 then
						bagname = "FoodBag";
					elseif bagtype == 3 then
						bagname = "ToolBag";
					elseif bagtype == 4 then
						bagname = "TrapperBag";
					elseif bagtype == 5 then
						bagname = "MedicBag";
					elseif bagtype == 6 then
						bagname = "LeGourmetBag";
					end
					local items = LGHTZItems[bagname][subtype];
					local rolls = 1;
					if SandboxVars.WeaponLoot == 1 then -- very poor
						rolls = ZombRand(1,5);
					elseif SandboxVars.WeaponLoot == 2 then -- poor
						rolls = ZombRand(1,6);
					elseif SandboxVars.WeaponLoot == 3 then -- normal
						rolls = ZombRand(1,7);
					elseif SandboxVars.WeaponLoot == 4 then -- abundant
						rolls = ZombRand(2,8);
					elseif SandboxVars.WeaponLoot == 5 then -- very abundant
						rolls = ZombRand(3,9);
					end
					for i = 0, rolls do
						bag:getItemContainer():AddItem(items[ZombRand(1, #items +1)]);
					end
				else
				end
			else
				local Animalgived = nil;
				if self.capture == "Base.BeeNest" or self.capture == "Base.BirdNest" then
					self.htree:getSquare():AddWorldInventoryItem(self.capture, self.htree:getX() - math.floor(self.htree:getX()), self.htree:getY() - math.floor(self.htree:getY()), self.htree:getZ() - math.floor(self.htree:getZ()));
				else
					Animalgived = InventoryItemFactory.CreateItem(self.capture);
					Animalgived:setBaseHunger(- AnimalSize / 100);
					Animalgived:setHungChange(- AnimalSize / 100);
					Animalgived:setActualWeight(AnimalSize / AnimalWeigthChange);
					Animalgived:setCustomWeight(true);
					self.htree:getSquare():AddWorldInventoryItem(Animalgived, self.htree:getX() - math.floor(self.htree:getX()), self.htree:getY() - math.floor(self.htree:getY()), self.htree:getZ() - math.floor(self.htree:getZ()));
				end
			end
			local zone = self:getScavengeZone();
			local scavengeZoneNumber = ZombRand(5,15) + self.scavengeZoneIncrease;
			local actualzone = ISScavengeAction.getScavengingZone(self.htree:getX(), self.htree:getY());
			if not zone then -- register the new zone
				zone = getWorld():registerZone(scavengeZoneNumber .. "", "PlantScavenge",self.htree:getX() - 20, self.htree:getY() - 20, 0, 40, 40);
				zone:setLastActionTimestamp(getGametimeTimestamp());
--				if zone then
--					zone = self:getScavengeZone();
					local plantLeft = tonumber(zone:getName());
					local totalnumber = plantLeft - 3;
					if totalnumber <= 0 then
						zone:setName(0 .. "");
					else
						zone:setName(totalnumber .. "");
					end
					--zone:setLastActionTimestamp(getGametimeTimestamp());
					--if plantLeft <= "0" then
					--	zone:setName(0 .. "");
					--end
--				end
			else
				local plantLeft = tonumber(zone:getName());
				zone:setName(plantLeft - 3 .. "");
				zone:setLastActionTimestamp(getGametimeTimestamp());
				if actualzone:getName() <= "0" then
					zone:setName(0 .. "");
				end
			end
			if isClient() then zone:sendToServer() end
			self:AddAimingxp(perklvl, (perklvl +1) * ZombRand(5,11));
		else
			--self.character:playSound("PZ_ChopTree", true);
			getSoundManager():PlayWorldSound("ChopTree", self.htree:getSquare(), 0, 5, 1, true);
			self:AddAimingxp(perklvl, 1);
		end
	else
		--self.character:playSound("PZ_ChopTree", true);
		getSoundManager():PlayWorldSound("ChopTree", self.htree:getSquare(), 0, 5, 1, true);
	end
	ISBaseTimedAction.perform(self);
end

function LGHuntingRocksAction:AddAimingxp(perklvl, Exp)
	if perklvl < 10 then
		local oldXp = self.character:getXp():getXP(Perks.Aiming);
		self.character:getXp():AddXP(Perks.Aiming, Exp);
		local xp = self.character:getXp():getXP(Perks.Aiming) - oldXp;
		self.character:setHaloNote(getText("IGUI_perks_Aiming").."+"..tonumber(string.format("%." .. (2 or 0) .. "f", xp)), 0,255,0,300);
	end
end

function LGHuntingRocksAction:getLuck()
	local basepercent = 30;
	if self.character:HasTrait("Lucky") then
		basepercent = basepercent + ZombRand(1,26);
	elseif self.character:HasTrait("Unlucky") then
		basepercent = basepercent - ZombRand(1,26);
	end
	return basepercent;
end

function LGHuntingRocksAction:getScavengeZone()
    local zones = getWorld():getMetaGrid():getZonesAt(self.htree:getX(), self.htree:getY(), 0);
    if zones then
        for i=0,zones:size()-1 do
            if zones:get(i):getType() == "PlantScavenge" then
                return zones:get(i);
            end
        end
    end
end

function LGHuntingRocksAction:new(player, htree, time, capture)
	local o = {}
	setmetatable(o, self)
	self.__index = self
	o.character = player;
	o.htree = htree;
	o.capture = capture;
	o.stopOnWalk = true;
	o.stopOnRun = true;
	o.maxTime = time;

    -- sandbox settings
    o.scavengeZoneIncrease = 0;
    if SandboxVars.NatureAbundance == 1 then -- very poor
        o.scavengeZoneIncrease = -5;
    elseif SandboxVars.NatureAbundance == 2 then -- poor
        o.scavengeZoneIncrease = -2;
    elseif SandboxVars.NatureAbundance == 4 then -- abundant
        o.scavengeZoneIncrease = 2;
    elseif SandboxVars.NatureAbundance == 5 then -- very abundant
        o.scavengeZoneIncrease = 5;
    end
	return o
end
