----------------------------------------------------------------------------------
--
-- AFDigRWormMenu.lua
-- Parte del mod Advanced Fishing.
-- Creado por Snake.
--
--
-- El codigo base se encuentra en ISInventoryBuildMenu.lua
-- los cuales han sido creados por Robert Johnson.
--
----------------------------------------------------------------------------------


AFDigRWormMenu = {};

AFDigRWormMenu.doBuildMenu = function(player, context, worldobjects, test)

    local object = worldobjects[1];
	if test and ISWorldObjectContextMenu.Test then
		return true;
	end

    local _inventory = getSpecificPlayer(player):getInventory();
	local _canDigRedWorm = false;
	local _RedWormSourceSquare = nil;

    -- Si se tiene Shovel, y tiene la condicion mayor a 0 entonces se puede abrir el menu contextual.
    local shovels = getSpecificPlayer(player):getInventory():getBestCondition("Shovel")

	if shovels and shovels:getCondition() > 0 then
		local _squares = {};
		local _duplicate = false;
		local _objectSquare = nil;

		for _, _currentObject in pairs(worldobjects) do
			_duplicate = false;
			_objectSquare = _currentObject:getSquare(); 	-- La celda del objeto.
			if _objectSquare ~= nil then
				for _, _currentSquare in pairs(_squares) do
					if _currentSquare == _objectSquare then
						_duplicate = true;
						break
					end
				end
			end

			if not _duplicate then
				table.insert(_squares, _objectSquare);
			end
		end

		local _spriteName = "";
		local _possibleFloor = nil;
		local _objectList = nil;
		for _, _currentSquare in pairs(_squares) do
			_objectList = _currentSquare:getObjects();
			for i = 0, _objectList:size()-1 do
				_possibleFloor = _objectList:get(i)
				if _possibleFloor:getSprite() and _possibleFloor:getSprite():getName() then
					_spriteName = _possibleFloor:getSprite():getName();
					if ( _spriteName == "location_community_cemetary_01_0" or
						_spriteName == "location_community_cemetary_01_1" or
						_spriteName == "location_community_cemetary_01_2" or
						_spriteName == "location_community_cemetary_01_3" or
						_spriteName == "location_community_cemetary_01_4" or
						_spriteName == "location_community_cemetary_01_5" or
						_spriteName == "location_community_cemetary_01_8" or
						_spriteName == "location_community_cemetary_01_9")then
						_canDigRedWorm = true;
						_RedWormSourceSquare = _currentSquare;
						local objectData = object:getModData();
						if not objectData.remainingcav then
                            if SandboxVars.OtherLoot == 1 then -- very poor
								objectData.remainingcav = ZombRand(1,4);
							elseif SandboxVars.OtherLoot == 2 then -- poor
								objectData.remainingcav = ZombRand(1,6);
							elseif SandboxVars.OtherLoot == 3 then -- normal
								objectData.remainingcav = ZombRand(4,11);
							elseif SandboxVars.OtherLoot == 4 then -- abundant
								objectData.remainingcav = ZombRand(6,16);
							elseif SandboxVars.OtherLoot == 5 then -- very abundant
								objectData.remainingcav = ZombRand(10,21);
							end
							object:transmitModData();
						elseif objectData.remainingcav < 1 then
						    return;
						end
						break;
					end
				end
			end

			-- No necesita el reloop cuando ya se sabe que se puede buscar Lombriz colorada.
			if _canDigRedWorm == true then
				break;
			end
		end
    end

	
	if _canDigRedWorm then
	    local player = getSpecificPlayer(player);
--		local objectData = object:getModData();
--		local cavpercent = math.floor(objectData.remainingcav * 100 / totalcav);
	    if(not player:getBodyDamage():getBodyPart(BodyPartType.Hand_L):HasInjury() and not player:getBodyDamage():getBodyPart(BodyPartType.Hand_R):HasInjury()) then
	        local option = context:addOption(getText("ContextMenu_Scarvengewithshovel"), _RedWormSourceSquare, AFDigRWormMenu.onDigForRedWorm, player, object);
            local tooltip = ISWorldObjectContextMenu.addToolTip();
            tooltip.description = getText("ContextMenu_ScarvengewithshovelTT");
            option.toolTip = tooltip;
	    else
            local option = context:addOption(getText("ContextMenu_Scarvengewithshovel"), _RedWormSourceSquare, AFDigRWormMenu.onDigForRedWorm, player, object)
            option.notAvailable = true;
            local tooltip = ISWorldObjectContextMenu.addToolTip();
            tooltip.description = getText("ContextMenu_DamagedHands");
            option.toolTip = tooltip;
		end	
	end
end


AFDigRWormMenu.onDigForRedWorm = function(targetSquare, player, object)
	if luautils.walkAdj(player, targetSquare) then
		ISWorldObjectContextMenu.equip(player, player:getPrimaryHandItem(), "Shovel", true);
		local player2 = getPlayer()
			local time = 250;
			if player2:HasTrait("Hiker") and not player2:HasTrait("Formerscout") then
				time = time - 25;
			elseif player2:HasTrait("Formerscout") and not player2:HasTrait("Hiker") then
				time = time - 25;
			elseif player2:HasTrait("Formerscout") and player2:HasTrait("Hiker") then
				time = time - 75;
			elseif player2:HasTrait("Obese") then
				time = time + 50;
			elseif player2:HasTrait("Overweight") then
				time = time + 150;
			end
			ISTimedActionQueue.add(AFDigRedWormAction:new(player, targetSquare, time, object));

	end

end

Events.OnFillWorldObjectContextMenu.Add(AFDigRWormMenu.doBuildMenu);
