----------------------------------------------------------------------------------
--
-- LGEPCheckWeather.lua
-- Parte del mod Advanced Fishing.
-- Creado por Snake.
--
--
-- El codigo base se encuentra en ISInventoryBuildMenu.lua
-- los cuales han sido creados por Robert Johnson.
--
----------------------------------------------------------------------------------


LGEPCheckWeather = {};

LGEPCheckWeather.doBuildMenu = function(player, context, worldobjects, test)
	local playerObj = getSpecificPlayer(player);
	if playerObj then
		local room = playerObj:getCurrentSquare():getRoom();
		if not room and not playerObj:getVehicle() then
			if JoypadState.players[player+1] == nil then
				--if getSpecificPlayer(player):HasTrait("Outdoorsman") then
					if test == true then return true; end
					context:addOption(getText("ContextMenu_CheckWeather"), worldobjects, LGEPCheckWeather.onCheckWeather, item, player);
				--end
			end
		else
		end
    end

end

LGEPCheckWeather.onCheckWeather = function(worldobjects, item, player)
	local currentHour = math.floor(math.floor(GameTime:getInstance():getTimeOfDay() * 3600) / 3600); --La hora del día
	local picturetitle = "";
	local recipes = getSpecificPlayer(player):getKnownRecipes(); --Las recetas del jugador
	local fishinglvl = getSpecificPlayer(player):getPerkLevel(Perks.Fishing)
	local FishingChance = "";
	local recipeknown = nil;
	if recipes:contains("Advanced Climatology") then --Validar si tiene la receta indicada.
		recipeknown = true;
	end
	if (currentHour >= 4 and currentHour <= 20) then --Validar la imagen a colocar dia/noche
		picturetitle = "<IMAGECENTRE:media/ui/WeatherIcons/weathertittleday.png>";
	else
		picturetitle = "<IMAGECENTRE:media/ui/WeatherIcons/weathertittlenight.png>";
	end
	local title = " <CENTRE> <SIZE:medium> " .. getText("Tooltip_WeatherCondition").. " <LINE> " .. picturetitle ; -- el titulo
	---------------------- Condición climática general --------------------------------------
	local weather = getWorld():getWeather();
	local weatherStr = "";
	local Red = " <RGB:1,0,0> ";
	local Green = " <RGB:0,1,0> ";
	local weatherFishing = "";
	if "sunny" == weather then
		weatherStr = getText("Tooltip_Sunny");
	elseif "normal" == weather then
		weatherStr = getText("Tooltip_normal");
	elseif "cloud" == weather then
		weatherStr = getText("Tooltip_cloud");
	elseif "rain" == weather then
		weatherStr = getText("Tooltip_rain");
	end
	if fishinglvl >= 3 then
		weatherStr = weatherStr .. " <LINE> ";
		FishingChance = getText("Tooltip_FishingPointsChance");
		if "sunny" == weather or "cloud" == weather then
			if fishinglvl < 6 then
				weatherFishing = Green .. getText("Tooltip_Good");
			else
				weatherFishing = Green .. getText("Tooltip_Good") .. " " .. getText("Tooltip_Random") .. " (+0 & +5) ";
			end
		elseif "normal" == weather then
			if fishinglvl < 6 then
				weatherFishing = getText("Tooltip_Neutral");
			else
				weatherFishing = getText("Tooltip_Neutral") .. " (0) ";
			end
		elseif "rain" == weather then
			if fishinglvl < 6 then
				weatherFishing = Red .. getText("Tooltip_Bad");
			else
				weatherFishing = Red .. getText("Tooltip_Bad") .. " " .. getText("Tooltip_Random") .. " (-0 & -5) ";
			end
		end
	end
	
	local Weathertext = getText("Tooltip_GeneralWeather") .. weatherStr .. " <TEXT> <RGB:1,1,1> " .. FishingChance .. weatherFishing .. " <LINE> ";
	----------------------------Viento----------------------------
	local wind = getClimateManager():getWindPower();
    local windStr = "";
	local windFishing = "";
	local cloudFishing = "";
	local moonFishing = "";
    if wind>0.65 then
        windStr = getText("Tooltip_Extremely_windy");
    elseif wind>0.45 then
        windStr = getText("Tooltip_Very_strong_wind");
    elseif wind>0.3 then
        windStr = getText("Tooltip_Very_windy");
    elseif wind>0.2 then
        windStr = getText("Tooltip_Windy");
    elseif wind>0.1 then
        windStr = getText("Tooltip_Slightly_windy");
    else
        windStr = getText("Tooltip_Minor_breezes");
    end
	if fishinglvl >= 3 then
		windStr = windStr .. " <LINE> ";
		FishingChance = getText("Tooltip_FishingPointsChance");
		if wind>0.65 then
			if fishinglvl < 6 then
				windFishing = Red .. getText("Tooltip_ExtremeBad");
			else
				windFishing = Red .. getText("Tooltip_ExtremeBad") .. " (-15) ";
			end
		elseif wind>0.45 then
			if fishinglvl < 6 then
				windFishing = Red .. getText("Tooltip_VeryBad");
			else
				windFishing = Red .. getText("Tooltip_VeryBad") .. " (-10) ";
			end
		elseif wind>0.3 then
			if fishinglvl < 6 then
				windFishing = Red .. getText("Tooltip_Bad");
			else
				windFishing = Red .. getText("Tooltip_Bad") .. " (-5) ";
			end
		elseif wind>0.2 then
			if fishinglvl < 6 then
				windFishing = getText("Tooltip_Neutral");
			else
				windFishing = getText("Tooltip_Neutral") .. " (0) ";
			end
		elseif wind>0.1 then
			if fishinglvl < 6 then
				windFishing = Green .. getText("Tooltip_Good");
			else
				windFishing = Green .. getText("Tooltip_Good") .. " (+5) ";
			end
		else
			if fishinglvl < 6 then
				windFishing = Green .. getText("Tooltip_VeryGood");
			else
				windFishing = Green .. getText("Tooltip_VeryGood") .. " (+10) ";
			end
		end
	end
	local Windtext = " <LEFT> <RGB:1,1,1> <SIZE:medium> " .. getText("Tooltip_Wind") .. windStr .. " <TEXT> <RGB:1,1,1> " .. FishingChance .. windFishing .. " <LINE> ";
	----------------------------Nubosidad----------------------------
	local clouds = getClimateManager():getCloudIntensity();
    local cloudStr = "";
    if clouds>0.35 then
        cloudStr = getText("Tooltip_Extremely_cloudy");
    elseif clouds>0.25 then
        cloudStr = getText("Tooltip_Very_cloudy");
    elseif clouds>0.125 then
        cloudStr = getText("Tooltip_Cloudy");
    elseif clouds>0.05 then
        cloudStr = getText("Tooltip_Slightly_cloudy");
    else
        cloudStr = getText("Tooltip_Mostly_clear_sky");
    end
	if fishinglvl >= 3 then
		cloudStr = cloudStr .. " <LINE> ";
		FishingChance = getText("Tooltip_FishingPointsChance");
		cloudFishing = getText("Tooltip_NotAffect");
		if clouds>0.35 then
			if fishinglvl < 6 then
				cloudFishing = Green .. getText("Tooltip_VeryGood");
			else
				cloudFishing = Green .. getText("Tooltip_VeryGood") .. " " .. getText("Tooltip_Random") .. " (0 & 5) ";
			end
		elseif clouds>0.25 then
			if fishinglvl < 6 then
				cloudFishing = Green .. getText("Tooltip_VeryGood");
			else
				cloudFishing = Green .. getText("Tooltip_VeryGood") .. " " .. getText("Tooltip_Random") .. " (0 & 4) ";
			end
		elseif clouds>0.125 then
			if fishinglvl < 6 then
				cloudFishing = Green .. getText("Tooltip_Good");
			else
				cloudFishing = Green .. getText("Tooltip_Good") .. " " .. getText("Tooltip_Random") .. " (0 & 3) ";
			end
		elseif clouds>0.05 then
			if fishinglvl < 6 then
				cloudFishing = Green .. getText("Tooltip_Good");
			else
				cloudFishing = Green .. getText("Tooltip_Good") .. " " .. getText("Tooltip_Random") .. " (0 & 2) ";
			end
		else
			if fishinglvl < 6 then
				cloudFishing = getText("Tooltip_Neutral");
			else
				cloudFishing = getText("Tooltip_Neutral") .. " (0) ";
			end
		end
	end
	local Cloudtext = " <LEFT> <RGB:1,1,1> <SIZE:medium> " .. getText("Tooltip_Clouds") .. cloudStr .. " <TEXT> <RGB:1,1,1> " .. FishingChance .. cloudFishing .. " <LINE> ";
	----------------------------La Luna----------------------------
	local moon = season.moonCycle;
    local moonStr = "";
    if moon>=3 and moon<=6 then
        moonStr = getText("Tooltip_New_Moon");
    elseif moon>=18 and moon<=21 then
        moonStr = getText("Tooltip_Full_Moon");
    elseif moon>=7 and moon<=17 then
        moonStr = getText("Tooltip_Crescent_Moon");
    else
        moonStr = getText("Tooltip_Descent_Moon");
    end
	if fishinglvl >= 3 then
		moonStr = moonStr .. " <LINE> ";
		FishingChance = getText("Tooltip_FishingPointsChance");
		if moon>=3 and moon<=6 then
			if fishinglvl < 6 then
				moonFishing = Green .. getText("Tooltip_Good");
			else
				moonFishing = Green .. getText("Tooltip_Good") .. " (+5) ";
			end
		elseif moon>=18 and moon<=21 then
			if fishinglvl < 6 then
				moonFishing = Red .. getText("Tooltip_Bad");
			else
				moonFishing = Red .. getText("Tooltip_Bad") .. " (-5) ";
			end
		elseif moon>=7 and moon<=17 then
			if fishinglvl < 6 then
				moonFishing = getText("Tooltip_Neutral");
			else
				moonFishing = getText("Tooltip_Neutral") .. " (0) ";
			end
		else
			if fishinglvl < 6 then
				moonFishing = getText("Tooltip_Neutral");
			else
				moonFishing = getText("Tooltip_Neutral") .. " (0) ";
			end
		end
	end
	local Moontext = " <LEFT> <RGB:1,1,1> <SIZE:medium> " .. getText("Tooltip_MoonPhase") .. moonStr .. " <TEXT> <RGB:1,1,1> " .. FishingChance .. moonFishing .. " <LINE> ";
	
	---------------------Texto Completo----------------------------
	local totaltext = "";
	local h = 320;
	if getSpecificPlayer(player):HasTrait("Outdoorsman") or recipeknown ~= nil then -- Si tiene rasgo o receta indicada muestra mas información.
		totaltext = title .. " <LINE> <LINE> " .. Windtext .. " <LINE> " .. Cloudtext .. " <LINE> " .. Moontext;
	else
		totaltext = title .. " <LINE> <LINE> " .. Weathertext; --Información normal: Estado General del Clima.
		h = 220;
	end
	luautils.okRichModal(totaltext, true, 300, h);
end

Events.OnFillWorldObjectContextMenu.Add(LGEPCheckWeather.doBuildMenu);
