--***********************************************************
--**               LEMMY/ROBERT JOHNSON                    **
--***********************************************************

require "ISUI/ISPanel"
require "ISUI/ISButton"
require "ISUI/ISMouseDrag"
require "TimedActions/ISTimedActionQueue"
require "TimedActions/ISEatFoodAction"
require "ISUI/ISInventoryPane"

function ISInventoryPane:refreshContainer()
    self.itemslist = {}
    self.itemindex = {}

    if self.collapsed == nil then
        self.collapsed = {}
    end
    local playerObj = getSpecificPlayer(self.player)
    local it = self.inventory:getItems();
    for i = 0, it:size()-1 do
        local item = it:get(i);
        local itemName = item:getName();
        if instanceof(item, "Food") and item:getHerbalistType() and item:getHerbalistType() ~= "" then
            if playerObj:getKnownRecipes():contains("Herbalist") then
                if item:getHerbalistType() == "Berry" then
                    itemName = (item:getPoisonPower() > 0) and getText("IGUI_PoisonousBerry") or getText("IGUI_Berry")
                end
                if item:getHerbalistType() == "Mushroom" then
                    itemName = (item:getPoisonPower() > 0) and getText("IGUI_PoisonousMushroom") or getText("IGUI_Mushroom")
                end
            else
                if item:getHerbalistType() == "Berry"  then
                    itemName = getText("IGUI_UnknownBerry")
                end
                if item:getHerbalistType() == "Mushroom" then
                    itemName = getText("IGUI_UnknownMushroom")
                end
            end
            if itemName ~= item:getDisplayName() then
                item:setName(itemName);
            end
			itemName = item:getName()
        end
		if item:getType() == "CowSkin" 
		  or item:getType() == "DeerSkin" 
		  or item:getType() == "BearSkin" 
		  or item:getType() == "SugarcanePile"
		  or item:getType() == "CheeseMoldFull"
		  or item:getType() == "CheeseMoldFull2"
		  or item:getType() == "CheeseMoldFull3" then
			local itemdata = item:getModData();
			local ItemNm = "";
			local animal = false;
			local State = getText("Tooltip_Cured");
			if item:getType() == "CowSkin" then
				ItemNm = getItemText("Cow_skin");
				animal = true;
			elseif item:getType() == "DeerSkin" then
				ItemNm = getItemText("Deer_skin");
				animal = true;
			elseif item:getType() == "BearSkin" then
				ItemNm = getItemText("Bear_skin");
				animal = true;
			elseif item:getType() == "SugarcanePile" then
				ItemNm = getItemText("Sugarcane_Pile");
			elseif item:getType() == "CheeseMoldFull" then
				ItemNm = getItemText("Cheese_in_Mold");
			elseif item:getType() == "CheeseMoldFull2" then
				ItemNm = getItemText("BarCheese_in_Mold");
			elseif item:getType() == "CheeseMoldFull3" then
				ItemNm = getItemText("Mozzarella_in_Mold");
			else
			end
			if (not itemdata.dry) or (itemdata.dry == 0) then
				--itemdata.dry = 0;
				if item:getContainer() and item:getContainer():getType() == "floor" then
					if itemdata.dry == 0 then
						if animal then
							itemdata.dry = 2;
							item:setName(ItemNm .. " " .. getText("Tooltip_Ruined"));
							if itemdata.initialhour then
								if not itemdata.timetake then
									itemdata.timetake = getGameTime():getWorldAgeHours() - itemdata.initialhour;
								end
							end
						
						end
						if itemdata.IsInside and itemdata.IsInside == 1 then
							itemdata.IsInside = 0;
						end
					end
				end
				--if animal then
					if itemdata.hoursneeded and itemdata.initialhour then
						local actualhours = getGameTime():getWorldAgeHours() - itemdata.initialhour;
						if actualhours >= itemdata.hoursneeded then
							itemdata.dry = 1;
							if animal then
								State = getText("Tooltip_Cured");
							else
								if item:getType() == "SugarcanePile" then
									State = getText("Tooltip_Dry");
								else
									State = getText("Tooltip_Finished");
								end
							end
						else
							if animal then
								State = getText("Tooltip_NotCured");
							else
								if item:getType() == "SugarcanePile" then
									State = getText("Tooltip_Green");
								else
									State = getText("Tooltip_NotFinished");
								end
							end
						end
						item:setName(ItemNm .. " " .. State);
					end
				--end
			elseif itemdata.dry == 1 then
				if animal then
					State = getText("Tooltip_Cured");
				else
					if item:getType() == "SugarcanePile" then
						State = getText("Tooltip_Dry");
					else
						State = getText("Tooltip_Finished");
					end
				end
				item:setName(ItemNm .. " " .. State);
			else
				if animal then
					State = getText("Tooltip_Ruined");
				else
					if item:getType() == "SugarcanePile" then
						State = getText("Tooltip_Green");
					else
						State = getText("Tooltip_NotFinished");
					end
				end

				item:setName(ItemNm .. " " .. State);
			end
		end
		if item:getType() == "ZAWBrick" 
		  or item:getType() == "ZAWConcreteBrick"
		  or item:getType() == "ZAWBrickPack" then
			if item:getContainer() and item:getContainer():getType() == "floor" then
				local itemdata = item:getModData();
				if itemdata.bweight then
					if itemdata.bweight >= item:getActualWeight() then
						item:setActualWeight(itemdata.bweight);
						item:setWeight(item:getActualWeight());
						item:setCustomWeight(true)
					end
				end
			end
			if item:getContainer() and item:getContainer():getType() == "brickpallet" then
				local itemdata = item:getModData();
				if not itemdata.bweight then
					itemdata.bweight = item:getActualWeight();
					item:setActualWeight(itemdata.bweight * 0.5);
					item:setWeight(item:getActualWeight());
					item:setCustomWeight(true)
				end
			end
		end
        local equipped = false
        if playerObj:isEquipped(item) then
            itemName = "equipped:"..itemName
            equipped = true
        elseif item:getType() == "KeyRing" and playerObj:getInventory():contains(item) then
            itemName = "keyring:"..itemName
            equipped = true
        end
        if self.itemindex[itemName] == nil then
            self.itemindex[itemName] = {};
            self.itemindex[itemName].items = {}
        end
        local ind = self.itemindex[itemName];
        ind.equipped = equipped

        table.insert(ind.items, item);

    end

    for k, v in pairs(self.itemindex) do

        if v ~= nil then
            table.insert(self.itemslist, v);
            local count = 1;
            for k2, v2 in ipairs(v.items) do
                if v2 == nil then
                    table.remove(v.items, k2);
                else
                    count = count + 1;
                end
            end
            v.count = count;
            v.invPanel = self;
            v.name = k -- v.items[1]:getName();
            v.cat = v.items[1]:getDisplayCategory() or v.items[1]:getCategory();
            if self.collapsed[v.name] == nil then
                self.collapsed[v.name] = true;
            end
        end
    end


    --print("Preparing to sort inv items");
    table.sort(self.itemslist, self.itemSortFunc );
    
    -- Adding the first item in list additionally at front as a dummy at the start, to be used in the details view as a header.
    for k, v in ipairs(self.itemslist) do
        local item = v.items[1];
        table.insert(v.items, 1, item);

    end

   -- if self.inventoryPage ~= nil then
   --     self.inventoryPage:refreshBackpacks();
   -- end
    self:updateScrollbars();
    self.inventory:setDrawDirty(false);

    -- Update the buttons
    if self:isMouseOver() then
        self:onMouseMove(0, 0)
    end
end