--Made by Snake
SkillsMagMenu = {};


SkillsMagMenu.doMenu = function(player, context, items)
	local pl = getPlayer();
	if not pl:HasTrait("Illiterate") then
		local SMag = nil;
	
		for i,v in ipairs(items) do
			local tempitem = v;
			if not instanceof(v, "InventoryItem") then
				tempitem = v.items[1];
			end
			if tempitem:getType() == "SkillMagSprint" or 
			  tempitem:getType() == "SkillMagLightFoot" or
			  tempitem:getType() == "SkillMagNimble" or
			  tempitem:getType() == "SkillMagSneaking" or
			  tempitem:getType() == "SkillMagBlade" or
			  tempitem:getType() == "SkillMagBladeGuard" or
			  tempitem:getType() == "SkillMagBladeMant" or
			  tempitem:getType() == "SkillMagBlunt" or
			  tempitem:getType() == "SkillMagBluntGuard" or
			  tempitem:getType() == "SkillMagBluntMant" or
			  tempitem:getType() == "SkillMagCarpentry" or
			  tempitem:getType() == "SkillMagCooking" or
			  tempitem:getType() == "SkillMagFarming" or
			  tempitem:getType() == "SkillMagFirstAid" or
			  tempitem:getType() == "SkillMagElectricity" or
			  tempitem:getType() == "SkillMagMetal" or
			  tempitem:getType() == "SkillMagFirearm" or
			  tempitem:getType() == "SkillMagReloading" or
			  tempitem:getType() == "SkillMagFishing" or
			  tempitem:getType() == "SkillMagTrapping" or
			  tempitem:getType() == "SkillMagForaging" or
			  tempitem:getType() == "SkillMagMechanics" then
				SMag = tempitem;
			end
		end
	
		if SMag then
			local option = context:addOption((getText("ContextMenu_Read") .. " " .. SMag:getDisplayName()), SMag, SkillsMagMenu.ReadMagazine_OnCreate, player);
			local tooltip = ISWorldObjectContextMenu.addToolTip();
			tooltip:setName(getText("ContextMenu_Read") .. " " .. SMag:getDisplayName());
			tooltip.description = tooltip.description .. getText("ContextMenu_CheckMagTT");
			tooltip:setTexture(SMag:getTexture():getName());
			option.toolTip = tooltip;
		end
	end
end

SkillsMagMenu.ReadMagazine_OnCreate = function(item, playernum)

	local player = getSpecificPlayer(playernum)
	
	-- check if needs to be moved
	if luautils.haveToBeTransfered(player, item) then
		ISTimedActionQueue.add(ISInventoryTransferAction:new(player, item, item:getContainer(), player:getInventory()));
	end
	
	if not item:isEquipped() then
		local toPrimary = true;
		if not (not getSpecificPlayer(playernum):getBodyDamage():getBodyPart(BodyPartType.Hand_R):isDeepWounded() and (getSpecificPlayer(playernum):getBodyDamage():getBodyPart(BodyPartType.Hand_R):getFractureTime() == 0 or getSpecificPlayer(playernum):getBodyDamage():getBodyPart(BodyPartType.Hand_R):getSplintFactor() > 0)) then
			-- Primary hand is damaged
			toPrimary = false;
		elseif player:getPrimaryHandItem() and not player:getSecondaryHandItem() then
			-- Primary hand has an item, but secondary is free
			if not getSpecificPlayer(playernum):getBodyDamage():getBodyPart(BodyPartType.Hand_L):isDeepWounded() and (getSpecificPlayer(playernum):getBodyDamage():getBodyPart(BodyPartType.Hand_L):getFractureTime() == 0 or getSpecificPlayer(playernum):getBodyDamage():getBodyPart(BodyPartType.Hand_L):getSplintFactor() > 0) then
				-- Secondary hand is not damaged, so secondary it is!
				toPrimary = false;
			end
		end
		
		-- equip the item first
		ISTimedActionQueue.add(ISEquipWeaponAction:new(player, item, 50, toPrimary, false))
	end

	ISTimedActionQueue.add(SkillsMagReadAction:new(player, item, nil));
end

Events.OnFillInventoryObjectContextMenu.Add(SkillsMagMenu.doMenu);