--***********************************************************
--**                    THE INDIE STONE                    **
--***********************************************************

require "ISUI/ISPanelJoypad"
require "OptionScreens/CoopCharacterCreation"

function CoopCharacterCreation.newPlayer(joypadIndex, joypadData)
	if CoopCharacterCreation.instance then return end
	if UIManager.getSpeedControls() and not IsoPlayer.allPlayersDead() then
		setShowPausedMessage(false)
		UIManager.getSpeedControls():SetCurrentGameSpeed(0)
		joypadData.activeWhilePaused = true
	end
	CoopCharacterCreation.setVisibleAllUI(false)
	local playerIndex = joypadData.player
	if not playerIndex then -- true when not respawning
		for i=0,getMaxActivePlayers()-1 do
			local player = getSpecificPlayer(i)
			if not player or player:isDead() then
				playerIndex = i
				break
			end
		end
	end
	local w = CoopCharacterCreation:new(joypadIndex, joypadData, playerIndex)
	w:initialise()
	w:addToUIManager()
	if w.coopUserName:shouldShow() then
		w.coopUserName:beforeShow()
		w.coopUserName:setVisible(true, joypadData)
	elseif w.mapSpawnSelect:hasChoices() then
		w.mapSpawnSelect:fillList()
		w.mapSpawnSelect:setVisible(true, joypadData)
	else
		w.mapSpawnSelect:useDefaultSpawnRegion()
		w.charCreationMain:setVisible(true, joypadData)
	end
end

function CoopCharacterCreation:newPlayerMouse()
    ProfessionFactory.Reset();
    BaseGameCharacterDetails.DoProfessions();
	if SWPBaseGameCharacterDetails then
		SWPBaseGameCharacterDetails.DoProfessions();
	end
	if ZAWBaseGameCharacterDetails then
		ZAWBaseGameCharacterDetails.DoProfessions();
	end
	if AMBaseGameCharacterDetails then
		AMBaseGameCharacterDetails.DoProfessions();
	end
	if EKBaseGameCharacterDetails then
		EKBaseGameCharacterDetails.DoProfessions();
	end
	if BMBaseGameCharacterDetails then
		BMBaseGameCharacterDetails.DoProfessions();
	end
	if AFBaseGameCharacterDetails then
		AFBaseGameCharacterDetails.DoProfessions();
	end
	if ABSBaseGameCharacterDetails then
		ABSBaseGameCharacterDetails.DoProfessions();
	end
	if WPABaseGameCharacterDetails then
		WPABaseGameCharacterDetails.DoProfessions();
	end
	if LPBaseGameCharacterDetails then
		LPBaseGameCharacterDetails.DoProfessions();
	end
	if PfarmBaseGameCharacterDetails then
		PfarmBaseGameCharacterDetails.DoProfessions();
	end
	if LGBaseGameCharacterDetails then
		LGBaseGameCharacterDetails.DoProfessions();
	end
	if CoopCharacterCreation.instance then return end
	if UIManager.getSpeedControls() and not IsoPlayer.allPlayersDead() then
		setShowPausedMessage(false)
		UIManager.getSpeedControls():SetCurrentGameSpeed(0)
	end
	CoopCharacterCreation.setVisibleAllUI(false)
	local w = CoopCharacterCreation:new(nil, nil, 0)
	w:initialise()
	w:addToUIManager()
	if w.mapSpawnSelect:hasChoices() then
		w.mapSpawnSelect:fillList()
		w.mapSpawnSelect:setVisible(true)
	else
		w.mapSpawnSelect:useDefaultSpawnRegion()
		w.charCreationMain:setVisible(true)
	end
end

