----------------------------------------------------------------------------------
--
-- AFDigRedWormAction.lua
-- Parte del mod Advanced Fishing.
-- Creado por Snake.
--
--
-- El codigo base se encuentra en ISShovelAction.lua y ISShovelGround.lua,
-- los cuales han sido creados por Robert Johnson.
--
----------------------------------------------------------------------------------

require "TimedActions/ISBaseTimedAction"

AFDigRedWormAction = ISBaseTimedAction:derive("AFDigRedWormAction");


function AFDigRedWormAction:isValid()
	return true;
--    return self.character:getStats():getEndurance() < 1;
end


function AFDigRedWormAction:update()
    self.character:faceLocation(self.RedWormSquare:getX(), self.RedWormSquare:getY())
end


function AFDigRedWormAction:start()
    self.sound = getSoundManager():PlayWorldSound("Shoveling", self.RedWormSquare, 0, 10, 1, true);
end


function AFDigRedWormAction:stop()
    if self.sound and self.sound:isPlaying() then
        self.sound:stop();
    end
    ISBaseTimedAction.stop(self);
end


function AFDigRedWormAction:perform()
    if self.sound and self.sound:isPlaying() then
        self.sound:stop();
    end
	
	-- Agregar la fatiga al jugador
--    self.character:getStats():setFatigue(self.character:getStats():getFatigue() + 0.05)
	self.character:getStats():setEndurance(self.character:getStats():getEndurance() - 0.004)
    -- Agregar la lombriz roja al inventario del jugador
	local _inventory = self.character:getInventory();

	-- Crear chances de success de acuerdo al trait que tenga el personaje.
	local player = getPlayer()
	local success = 40;
	
	if player:HasTrait("Hiker") and not player:HasTrait("Formerscout") then
	    success = success + 35;
	elseif player:HasTrait("Formerscout") and not player:HasTrait("Hiker") then
	    success = success + 35;
	elseif player:HasTrait("Formerscout") and player:HasTrait("Hiker") then
	    success = success + 50;
	elseif player:HasTrait("Lucky") then
	    success = success + 10;
	elseif player:HasTrait("Unlucky") then
	    success = success - 30
    end

    if ZombRand(0,100)<=success then
	    getPlayer():Say(getText("IGUI_PlayerText_Foundsome"));
		local randomchance = ZombRand(3);
		if randomchance == 0 then
			self.object:getSquare():AddWorldInventoryItem("AdvancedFishing.RedWorm", 0, 0, 0);
		elseif randomchance == 1 then
			self.object:getSquare():AddWorldInventoryItem("Base.Worm", 0, 0, 0);
		else
			self.object:getSquare():AddWorldInventoryItem("Base.Stone", 0, 0, 0);
		end
		if ZombRand(3) == 0 then
			self.object:getSquare():AddWorldInventoryItem("AdvancedFishing.HiddenBox", 0, 0, 0);
		end
		if ZombRand(6) == 0 then
			self.object:getSquare():AddWorldInventoryItem("AdvancedFishing.UnusableWood", 0, 0, 0);
		end
		self.character:getXp():AddXP(Perks.PlantScavenging, 1);
	else
		local txtRandom = ZombRand(3);
		if txtRandom == 0 then
		    getPlayer():Say(getText("IGUI_PlayerText_Foundnothing1"));
		elseif txtRandom == 1 then
            getPlayer():Say(getText("IGUI_PlayerText_Foundnothing2"));
		else
            getPlayer():Say(getText("IGUI_PlayerText_Foundnothing3"));
		end
	end
	local objectData = self.object:getModData();
	if objectData.remainingcav and objectData.remainingcav > 0 then
        objectData.remainingcav = objectData.remainingcav - 1;
	else
	end
    self.object:transmitModData();
	
	if self.character:getPrimaryHandItem() ~= nil and self.character:getPrimaryHandItem():getType() == "Shovel" then
	    self.shovel = self.character:getPrimaryHandItem();
		if ZombRand(self.shovel:getConditionLowerChance() + self.character:getMaintenanceMod() * 2) == 0 then
		    self.shovel:setCondition(self.shovel:getCondition() - 1);
            ISWorldObjectContextMenu.checkWeapon(self.character);
		else
			self.character:getXp():AddXP(Perks.BluntMaintenance, 1);
		end
	end
	if objectData.remainingcav == 0 then
	    luautils.okModal(getText("UI_objectremaining0"), true);
	    self.object:getSquare():transmitRemoveItemFromSquare(self.object)
	    self.object:getSquare():RemoveTileObject(self.object)
	end
	ISBaseTimedAction.perform(self);
end


function AFDigRedWormAction:new(player, RedWormSquare, time, object)
	local o = {}
	setmetatable(o, self)
	self.__index = self
	o.character = player;
	o.RedWormSquare = RedWormSquare;
	o.object = object;
	o.stopOnWalk = true;
	o.stopOnRun = true;
	o.maxTime = time;
	return o
end
