require ("TimedActions/ISBaseTimedAction");

ChoppingAction = ISBaseTimedAction:derive("ChoppingAction");

function ChoppingAction:isValid()
	return ((self.character:getPrimaryHandItem() ~= nil and self.character:getPrimaryHandItem():getType() == "ElectricMeatMincer") and (self.character:getSecondaryHandItem() ~= nil and self.character:getSecondaryHandItem():getType() == "PorkChop" or self.character:getSecondaryHandItem():getType() == "Steak"));
end

function ChoppingAction:update()
    self.item:setJobDelta(self:getJobDelta());
end

function ChoppingAction:start()
    self.item:setJobType(getText("ContextMenu_Chopping"));
    self.item:setJobDelta(0.0);
    self.character:getEmitter():playSoundImpl("EMincer", nil);
end


function ChoppingAction:stop()

	ISBaseTimedAction.stop(self);
	self.item:setJobDelta(0.0);
end

function ChoppingAction:perform()

    self.item:setJobDelta(0.0);

	local pl = self.character;
	local inv = pl:getInventory();
	local itm;
    self.secondary = pl:getSecondaryHandItem();
	local validitem = false;
    if self.secondary ~= nil and self.secondary:getType() == "PorkChop" then
        validitem = true;
		itm = "Base.Choppedporkmeat"
	elseif self.secondary ~= nil and self.secondary:getType() == "Steak" then
		validitem = true;
		itm = "Base.Choppedmeat"
    end
	if validitem then
		local itemtoadd = InventoryItemFactory.CreateItem(itm)
		itemtoadd:setBaseHunger(self.secondary:getHungChange());
		itemtoadd:setHungChange(self.secondary:getHungChange());
		itemtoadd:setThirstChange(self.secondary:getThirstChange());
		itemtoadd:setUnhappyChange(self.secondary:getUnhappyChange());
		itemtoadd:setBoredomChange(self.secondary:getBoredomChange());
		itemtoadd:setCarbohydrates(self.secondary:getCarbohydrates());
		itemtoadd:setLipids(self.secondary:getLipids());
		itemtoadd:setProteins(self.secondary:getProteins());
		itemtoadd:setCalories(self.secondary:getCalories());
		itemtoadd:setCooked(self.secondary:isCooked());
		itemtoadd:setRotten(self.secondary:isRotten());
		itemtoadd:setBurnt(self.secondary:isBurnt());

		pl:getSecondaryHandItem():Use();
		pl:setSecondaryHandItem(nil);

		inv:AddItem(itemtoadd);

		local perklvl = pl:getPerkLevel(Perks.Cooking);

	--    hwaffle:setBaseHunger(hwaffle * v);
	--    hwaffle:setHungChange(hwaffle * v);
		if perklvl < 10 then
			pl:getXp():AddXP(Perks.Cooking, 3);
		end
	end
	ISBaseTimedAction.perform(self);
end

function ChoppingAction:new(character, item, time)
	local o = {};
	setmetatable(o, self);
	self.__index = self;
	o.character = character;
	o.item = item;
	o.stopOnWalk = false;
	o.stopOnRun = true;
	o.maxTime = time;
	return o;
end