require ("TimedActions/ISBaseTimedAction");

MakeWafflesAction = ISBaseTimedAction:derive("MakeWafflesAction");

function MakeWafflesAction:isValid()
	return ((self.character:getPrimaryHandItem() ~= nil and self.character:getPrimaryHandItem():getType() == "WafflesPrep") or (self.character:getSecondaryHandItem() ~= nil and self.character:getSecondaryHandItem():getType() == "WafflesPrep"));
end

function MakeWafflesAction:update()
    self.item:setJobDelta(self:getJobDelta());
end

function MakeWafflesAction:start()
    self.item:setJobType(getText("ContextMenu_Cooking"));
    self.item:setJobDelta(0.0);
    self.character:getEmitter():playSoundImpl("wafflemachine", nil);
end


function MakeWafflesAction:stop()

	ISBaseTimedAction.stop(self);
	self.item:setJobDelta(0.0);
end

function MakeWafflesAction:perform()

    self.item:setJobDelta(0.0);

	local pl = self.character;
    self.machine = pl:getPrimaryHandItem();
    self.primary = false;
    if self.machine ~= nil and self.machine:getType() == "WafflesPrep" then
        self.primary = true;
    end
	if self.primary then
        pl:getPrimaryHandItem():Use();
        pl:setPrimaryHandItem(nil);
	elseif not self.primary then
        pl:getSecondaryHandItem():Use();
        pl:setSecondaryHandItem(nil);
	end

	local perklvl = pl:getPerkLevel(Perks.Cooking);
--	local v = 1;
--	if perklvl == 1 then
--		v = 1.1;
--	elseif perklvl == 2 then
--		v = 1.2;
--	elseif perklvl == 3 then
--		v = 1.3;
--	elseif perklvl == 4 then
--		v = 1.4;
--	elseif perklvl == 5 then
--		v = 1.5;
--	elseif perklvl == 6 then
--		v = 1.6;
--	elseif perklvl == 7 then
--		v = 1.7;
--	elseif perklvl == 8 then
--		v = 1.8;
--	elseif perklvl == 9 then
--		v = 1.9;
--	elseif perklvl == 10 then
--		v = 2;
--	else
--		v = v;
--	end

	local inv = pl:getInventory();
    inv:AddItem("Base.HandmadeWaffles");

--    hwaffle:setBaseHunger(hwaffle * v);
--    hwaffle:setHungChange(hwaffle * v);
	if perklvl < 10 then
		pl:getXp():AddXP(Perks.Cooking, 3);
	end
	ISBaseTimedAction.perform(self);
end

function MakeWafflesAction:new(character, item, time)
	local o = {};
	setmetatable(o, self);
	self.__index = self;
	o.character = character;
	o.item = item;
	o.stopOnWalk = false;
	o.stopOnRun = true;
	o.maxTime = time;
	return o;
end