require ("TimedActions/ISBaseTimedAction");

SkillsMagReadAction = ISBaseTimedAction:derive("SkillsMagReadAction");

function SkillsMagReadAction:isValid()
	return ((self.character:getPrimaryHandItem() ~= nil and self.character:getPrimaryHandItem():getType() == (self.item:getType())) or (self.character:getSecondaryHandItem() ~= nil and self.character:getSecondaryHandItem():getType() == (self.item:getType())));
end

function SkillsMagReadAction:update()
    self.item:setJobDelta(self:getJobDelta());
end

function SkillsMagReadAction:start()
    self.item:setJobType(getText("ContextMenu_Reading"));
    self.item:setJobDelta(0.0);
--    self.character:getEmitter():playSoundImpl("FishingLureBrowse", nil);
end


function SkillsMagReadAction:stop()

	ISBaseTimedAction.stop(self);
	self.item:setJobDelta(0.0);
end

function SkillsMagReadAction:perform()

    self.item:setJobDelta(0.0);
	local perk = nil;

    self.prim = self.character:getPrimaryHandItem();
	self.sec = self.character:getSecondaryHandItem();
	
	-- Determinacion del perk de la revista segun el objeto clickeado
    if self.prim ~= nil and self.prim:getType() == (self.item:getType()) or self.sec ~= nil and self.sec:getType() == (self.item:getType()) then
		if self.item:getType() == "SkillMagSprint" then
			perk = Perks.Sprinting;
		elseif self.item:getType() == "SkillMagLightFoot" then
			perk = Perks.Lightfoot;
		elseif self.item:getType() == "SkillMagNimble" then
			perk = Perks.Nimble;
		elseif self.item:getType() == "SkillMagSneaking" then
			perk = Perks.Sneak;
		elseif self.item:getType() == "SkillMagBlade" then
			perk = Perks.Axe;
		elseif self.item:getType() == "SkillMagBladeGuard" then
			perk = Perks.BladeGuard;
		elseif self.item:getType() == "SkillMagBladeMant" then
			perk = Perks.BladeMaintenance;
		elseif self.item:getType() == "SkillMagBlunt" then
			perk = Perks.Blunt;
		elseif self.item:getType() == "SkillMagBluntGuard" then
			perk = Perks.BluntGuard;
		elseif self.item:getType() == "SkillMagBluntMant" then
			perk = Perks.BluntMaintenance;
		elseif self.item:getType() == "SkillMagCarpentry" then
			perk = Perks.Woodwork;
		elseif self.item:getType() == "SkillMagCooking" then
			perk = Perks.Cooking;
		elseif self.item:getType() == "SkillMagFarming" then
			perk = Perks.Farming;
		elseif self.item:getType() == "SkillMagFirstAid" then
			perk = Perks.Doctor;
		elseif self.item:getType() == "SkillMagElectricity" then
			perk = Perks.Electricity;
		elseif self.item:getType() == "SkillMagMetal" then
			perk = Perks.MetalWelding;
		elseif self.item:getType() == "SkillMagFirearm" then
			perk = Perks.Aiming;
		elseif self.item:getType() == "SkillMagReloading" then
			perk = Perks.Reloading;
		elseif self.item:getType() == "SkillMagFishing" then
			perk = Perks.Fishing;
		elseif self.item:getType() == "SkillMagTrapping" then
			perk = Perks.Trapping;
		elseif self.item:getType() == "SkillMagForaging" then
			perk = Perks.PlantScavenging;
		elseif self.item:getType() == "SkillMagMechanics" then
			perk = Perks.Mechanics;
		end
    end

    if perk then
	    local pl = self.character;
	    local perklvl = pl:getPerkLevel(perk);
		
		-- calculos para los jugadores que tengan nivel 0 en el perk de la revista
		if perklvl == 0 then
			perklvl = perklvl +1;
		end

		-- Calculos para la variable segun los rasgos
		if self.character:HasTrait("FastLearner") then
			self.variable = self.variable * (perklvl) * 2;
		elseif self.character:HasTrait("SlowLearner") then
			self.variable = self.variable * (perklvl) / 2;
		else
			self.variable = self.variable * (perklvl);
		end
		
		-- calculos para que el nivel de exp ganado no quede por debajo de 0
		if self.variable <= 0 then
			self.variable = 0;
		end

		-- Dar xp solo para los players que no hayan llegado al maximo nivel del perk que otorga la revista.
		if perklvl < 10 then
			self.character:getXp():AddXP(perk, self.variable);
--			luautils.okModal((getText("ContextMenu_SMExpgain") .. self.variable), true);
		else
			luautils.okModal(getText("ContextMenu_SMLevelMax"), true);
		end
	end

	-- Eliminacion del objeto del inventario y de la mano
	if self.prim ~= nil and self.prim:getType() == (self.item:getType()) then
        self.character:getPrimaryHandItem():Use();
        self.character:setPrimaryHandItem(nil);
	elseif self.sec ~= nil and self.sec:getType() == (self.item:getType()) then
        self.character:getSecondaryHandItem():Use();
        self.character:setSecondaryHandItem(nil);
	end
	
	ISBaseTimedAction.perform(self);
end

function SkillsMagReadAction:new(character, item, time)
	local o = {};
	setmetatable(o, self);
	self.__index = self;
	o.character = character;
	o.item = item;
	o.stopOnWalk = false;
	o.stopOnRun = true;
	o.maxTime = 300;

	-- calculos de tiempo segun el rasgo
	if character:HasTrait("FastReader") then
		o.maxTime = o.maxTime * 0.5
	end
	if character:HasTrait("SlowReader") then
		o.maxTime = o.maxTime * 1.5
	end

	o.variable = ZombRand(3,11);
	return o;
end