require "TimedActions/ISBaseTimedAction"

ZAWDigClayAction = ISBaseTimedAction:derive("ZAWDigClayAction");


function ZAWDigClayAction:isValid()
	return self.character ~= nil and self.character:getPrimaryHandItem() ~= nil and self.character:getPrimaryHandItem():getType() == "Shovel" and self.character:getPrimaryHandItem():getCondition() > 0 and self.character:getStats():getEndurance() >= 0.2;
end


function ZAWDigClayAction:update()
end


function ZAWDigClayAction:start()
--	self.character:faceLocation(self.claySquare:getX(), self.claySquare:getY());
--	getSoundManager():PlayWorldSound("shoveling", self.claySquare, 0, 10, 1, true);
	self.character:playSound("Shoveling", true);
end


function ZAWDigClayAction:stop()
    ISBaseTimedAction.stop(self);
end


function ZAWDigClayAction:perform()
	local _inventory = self.character:getInventory();
--    local digchance = ZombRand(101);
	local totalpercent = 25;
	local variable = 0;
	local rolls = 1;
	if SandboxVars.NatureAbundance == 1 then -- very poor
		totalpercent = 5;
		rolls = 1;
	elseif SandboxVars.NatureAbundance == 2 then -- poor
		totalpercent = 15;
		rolls = ZombRand(1,3);
	elseif SandboxVars.NatureAbundance == 3 then -- normal
		totalpercent = 25;
		rolls = ZombRand(1,4);
	elseif SandboxVars.NatureAbundance == 4 then -- abundant
		totalpercent = 35;
		rolls = ZombRand(1,5);
	elseif SandboxVars.NatureAbundance == 5 then -- very abundant
		totalpercent = 45;
		rolls = ZombRand(1,6);
	end
	if self.perkSlvl > 0 then
		variable = self.perkSlvl * 4;
		totalpercent = totalpercent + variable;
	end
	if self.character:HasTrait("Unlucky") then
		totalpercent = totalpercent - 10;
	elseif self.character:HasTrait("Lucky") then
		totalpercent = totalpercent + 10;
	end
	if ZombRand(1, 101) <= totalpercent then
		local items = {'Base.Stone','Base.Stone','Base.ZAWClay','Base.ZAWClay','Base.ZAWClay','Base.ZAWClay','Base.ZAWClay','Base.ZAWClay','Base.ZAWClay','Base.ZAWClay','Base.ZAWClay'};
		if rolls > 1 then
			for i = 0, ZombRand(2, rolls) do
				self.character:getSquare():AddWorldInventoryItem(items[ZombRand(#items)+1], 0, 0, 0)
			end
		else
			self.character:getSquare():AddWorldInventoryItem("Base.ZAWClay", 0, 0, 0)
		end
	end
	
	if self.character:getPrimaryHandItem() ~= nil and self.character:getPrimaryHandItem():getType() == "Shovel" then
	    self.shovel = self.character:getPrimaryHandItem();
		if ZombRand(self.shovel:getConditionLowerChance() + self.character:getMaintenanceMod() * 2) == 0 then
		    self.shovel:setCondition(self.shovel:getCondition() - 1);
            ISWorldObjectContextMenu.checkWeapon(self.character);
		else
			self.character:getXp():AddXP(Perks.BluntMaintenance, 1);
		end
		self.character:getStats():setEndurance(self.character:getStats():getEndurance() - 0.02)
		if self.character:getStats():getEndurance() >= 0.2 then
			ISTimedActionQueue.add(ZAWDigClayAction:new(self.character, self.claysquare, 200));
		end
	end
--	if objectData.remainingch > 0 then
--		ISTimedActionQueue.add(ZAWDigClayAction:new(self.character, self.claysquare, 100));
--	elseif objectData.remainingch == 0 then
	--	    luautils.okModal(getText("UI_sandremaining0"), true);
--		if self.sound and self.sound:isPlaying() then
--			self.sound:stop();
--		end
--		self.character:getXp():AddXP(Perks.PlantScavenging, 1);
--		self.character:setHaloNote("**** " .. getText("UI_sandremaining0") .. " ****", 160,160,160,300);
--	end
	-- needed to remove from queue / start next.
	ISBaseTimedAction.perform(self);
end

function ZAWDigClayAction:new(player, claySquare, time)
	local o = {}
	setmetatable(o, self)
	self.__index = self
	o.character = player;
	o.claySquare = claySquare;
	o.stopOnWalk = true;
	o.stopOnRun = true;
	o.perkSlvl = player:getPerkLevel(Perks.PlantScavenging);
	if o.perkSlvl >= 1 then
		o.maxTime = time - (o.perkSlvl * 10)
	else
		o.maxTime = time;
	end
	return o
end
