require "TimedActions/ISInventoryTransferAction"
function ISInventoryTransferAction:isValid()
	if not self.destContainer or not self.srcContainer then return false; end
	if (not self.destContainer:isExistYet()) or (not self.srcContainer:isExistYet()) then
		return false
	end
	-- Limit items per container in MP
	if isClient() then
		local limit = getServerOptions():getInteger("ItemNumbersLimitPerContainer")
		if limit > 0 and (not instanceof(self.destContainer:getParent(), "IsoGameCharacter")) and self.destContainer:getItems():size()+1 > limit then
			return false
		end
	end

    if ISTradingUI.instance and ISTradingUI.instance:isVisible() then
        return false;
    end
	if not self.srcContainer:contains(self.item) then
		return false;
    end
    if self.srcContainer == self.destContainer then return false; end

    if self.destContainer:getType()=="floor" then
        if instanceof(self.item, "Moveable") and self.item:getSpriteGrid()==nil then
            if not self.item:CanBeDroppedOnFloor() then
                return false;
            end
        end
    end
	------------------------------------------Nuevo Contenido del Mod-----------------
	if self.destContainer:getType() == "furframe" then
		if self.item:getType() == "CowSkin" or self.item:getType() == "DeerSkin" or self.item:getType() == "BearSkin" then
			if self.destContainer:getContentsWeight() ~= 0 then
				return false;
			else
				return true
			end
		else
			return false;
		end
	end
	if self.destContainer:getType() == "cane_support" then
		if self.item:getType() == "SugarcanePile" then
			return true;
		else
			return false;
		end
	end
	if self.destContainer:getType() == "brickpallet" then
		if self.item:getType() == "ZAWBrick" 
		  or self.item:getType() == "ZAWConcreteBrick"
		  or self.item:getType() == "ZAWBrickPack" then
			return true;
		else
			return false;
		end
	end
	if self.destContainer:getType() == "cheese_table" then
		if self.item:getType() == "CheeseMoldFull" 
		  or self.item:getType() == "CheeseMoldFull2"
		  or self.item:getType() == "CheeseMoldFull3" then
			return true;
		else
			return false;
		end
	end
	-----------------------------------------------------------------------------------
	if not self.destContainer:hasRoomFor(self.character, self.item) then
        if (self.destContainer:getType() == "floor") then
            if (self.item:getActualWeight() < self.destContainer:getCapacity() or self.destContainer:getContentsWeight() > self.destContainer:getCapacity()) then
                return false;
            end
        else
            return false;
        end
    end

    if self.destContainer:getOnlyAcceptCategory() and self.item:getCategory() ~= self.destContainer:getOnlyAcceptCategory() then
        return false;
    end
    if self.item:getContainer() == self.srcContainer and not self.destContainer:isInside(self.item) then
        return true;
    end
    if isClient() and self.srcContainer:getSourceGrid() and SafeHouse.isSafeHouse(self.srcContainer:getSourceGrid(), self.character:getUsername(), true) then
        return false;
    end
    return false;
end

function ISInventoryTransferAction:perform()
    self.item:setJobDelta(0.0);
    if self.item:isFavorite() and not self.destContainer:isInCharacterInventory(self.character) then
        ISBaseTimedAction.perform(self);
        return;
    end

    if self.destContainer:isInCharacterInventory(self.character) then

    end
    if self.srcContainer:isInCharacterInventory(self.character) then

    end
    if self.srcContainer:getType() ~= "TradeUI" and isClient() and not self.destContainer:isInCharacterInventory(self.character) and self.destContainer:getType()~="floor" then
        self.destContainer:addItemOnServer(self.item);
    end
    if self.srcContainer:getType() ~= "TradeUI" and isClient() and not self.srcContainer:isInCharacterInventory(self.character) and self.srcContainer:getType()~="floor" then
        self.srcContainer:removeItemOnServer(self.item);
    end

    if self.destContainer:getType() ~= "TradeUI" then
        self.srcContainer:DoRemoveItem(self.item);
    end
    -- clear it from the queue.
    self.srcContainer:setDrawDirty(true);
    self.srcContainer:setHasBeenLooted(true);
    self.destContainer:setDrawDirty(true);

	----------------------------- Contenido del Mod-------------------
	if self.destContainer:getType() == "furframe" then
		self:checkskintimeputin(self.item);
	elseif self.srcContainer:getType() == "furframe" then
		self:checkskintimetakeit(self.item);
	end
	if self.destContainer:getType() == "cane_support" then
		self:checkskintimeputin(self.item);
	elseif self.srcContainer:getType() == "cane_support" then
		self:checkskintimetakeit(self.item);
	end
	if self.destContainer:getType() == "brickpallet" then
		self:reduceweightonputin(self.item);
	elseif self.srcContainer:getType() == "brickpallet" then
		self:restoreweightontake(self.item);
	end
	if self.destContainer:getType() == "cheese_table" then
		self:checkskintimeputin(self.item);
	elseif self.srcContainer:getType() == "cheese_table" then
		self:checkskintimetakeit(self.item);
	end
	-------------------------------------------------------------------
    -- deal with containers that are floor
    if self.destContainer:getType()=="floor" then
        self.destContainer:DoAddItemBlind(self.item);
        self.character:getCurrentSquare():AddWorldInventoryItem(self.item, self.character:getX() - math.floor(self.character:getX()), self.character:getY() - math.floor(self.character:getY()), self.character:getZ() - math.floor(self.character:getZ()));
        self:removeItemOnCharacter();
    elseif self.srcContainer:getType()=="floor" and self.item:getWorldItem() ~= nil then
        self.item:getWorldItem():getSquare():transmitRemoveItemFromSquare(self.item:getWorldItem());
		self.item:getWorldItem():getSquare():removeWorldObject(self.item:getWorldItem());
--        self.item:getWorldItem():getSquare():getObjects():remove(self.item:getWorldItem());
        self.item:setWorldItem(nil);
        self.destContainer:AddItem(self.item);
    else
        if self.srcContainer:getType() ~= "TradeUI" then
            self.destContainer:AddItem(self.item);
        end
        if self.character:getInventory() ~= self.destContainer then
            self:removeItemOnCharacter();
        end
    end

	if self.destContainer:getParent() and instanceof(self.destContainer:getParent(), "BaseVehicle") and self.destContainer:getParent():getPartById(self.destContainer:getType()) then
		local part = self.destContainer:getParent():getPartById(self.destContainer:getType());
		part:setContainerContentAmount(part:getItemContainer():getCapacityWeight());
	end
	
	if self.srcContainer:getParent() and instanceof(self.srcContainer:getParent(), "BaseVehicle") and self.srcContainer:getParent():getPartById(self.srcContainer:getType()) then
		local part = self.srcContainer:getParent():getPartById(self.srcContainer:getType());
		part:setContainerContentAmount(part:getItemContainer():getCapacityWeight());
	end

	triggerEvent("OnContainerUpdate", self.srcContainer, self.destContainer, self.character);
	
    -- Hack for giving cooking XP.
    if instanceof(self.item, "Food") then
        self.item:setChef(self.character:getFullName())
    end
    if self.destContainer:getType() == "stonefurnace" then
       self.item:setWorker(self.character:getFullName());
    end

    local pdata = getPlayerData(self.character:getPlayerNum());

    pdata.playerInventory:refreshBackpacks();
    pdata.lootInventory:refreshBackpacks();


    -- do the overlay sprite
    if not isClient() then
        if self.srcContainer:getParent() and self.srcContainer:getParent():getOverlaySprite() then
            ItemPicker.updateOverlaySprite(self.srcContainer:getParent())
        end
        if self.destContainer:getParent() then
            ItemPicker.updateOverlaySprite(self.destContainer:getParent())
        end
    end

--    needed to remove from queue / start next.
    ISBaseTimedAction.perform(self);

	if self.onCompleteFunc then
		local args = self.onCompleteArgs
		self.onCompleteFunc(args[1], args[2], args[3], args[4], args[5], args[6], args[7], args[8])
	end
end

function ISInventoryTransferAction:checkskintimeputin(item)
	if item:getType() == "CowSkin" 
	  or item:getType() == "DeerSkin" 
	  or item:getType() == "BearSkin" 
	  or item:getType() == "SugarcanePile"
	  or item:getType() == "CheeseMoldFull"
	  or item:getType() == "CheeseMoldFull2"
	  or item:getType() == "CheeseMoldFull3"	  then
		local data = item:getModData();
		local ItemName = "";
		local animal = false;
		local hoursneeded = 360;
		local State = getText("Tooltip_NotCured");
		if item:getType() == "CowSkin" then
			ItemName = getItemText("Cow_skin");
			animal = true;
			hoursneeded = 360;
		elseif item:getType() == "DeerSkin" then
			ItemName = getItemText("Deer_skin");
			animal = true;
			hoursneeded = 168;
		elseif item:getType() == "BearSkin" then
			ItemName = getItemText("Bear_skin");
			animal = true;
			hoursneeded = 360;
		elseif item:getType() == "SugarcanePile" then
			ItemName = getItemText("Sugarcane_Pile");
			animal = false;
			hoursneeded = 72;
			State = getText("Tooltip_Green");
		elseif item:getType() == "CheeseMoldFull" then
			ItemName = getItemText("Cheese_in_Mold");
			animal = false;
			hoursneeded = 20;
			State = getText("Tooltip_NotFinished");
		elseif item:getType() == "CheeseMoldFull2" then
			ItemName = getItemText("BarCheese_in_Mold");
			animal = false;
			hoursneeded = 14;
			State = getText("Tooltip_NotFinished");
		elseif item:getType() == "CheeseMoldFull3" then
			ItemName = getItemText("Mozzarella_in_Mold");
			animal = false;
			hoursneeded = 12;
			State = getText("Tooltip_NotFinished");
		else
		end
		if not data.dry then
			data.dry = 0;
		end
		if not data.IsInside then
			data.IsInside = 1;
		end
		if data.dry == 0 then
			if not data.hoursneeded then
				data.hoursneeded = hoursneeded;
			end
			if not data.initialhour then
				data.initialhour = getGameTime():getWorldAgeHours();
			end
			item:setName(ItemName .. " " .. State);
		end
		if not animal then
			if data.dry == 2 then
				data.initialhour = getGameTime():getWorldAgeHours();
				data.IsInside = 1;
			end
		end
	end
end

function ISInventoryTransferAction:checkskintimetakeit(item)
	if item:getType() == "CowSkin" 
	  or item:getType() == "DeerSkin"
	  or item:getType() == "BearSkin"
	  or item:getType() == "SugarcanePile"
	  or item:getType() == "CheeseMoldFull"
	  or item:getType() == "CheeseMoldFull2"
	  or item:getType() == "CheeseMoldFull3"then
		local data = item:getModData();
		local ItemName = "";
		local State = getText("Tooltip_Cured");
		local animal = false;
		if item:getType() == "CowSkin" then
			ItemName = getItemText("Cow_skin");
			animal = true;
		elseif item:getType() == "DeerSkin" then
			ItemName = getItemText("Deer_skin");
			animal = true;
		elseif item:getType() == "BearSkin" then
			ItemName = getItemText("Bear_skin");
			animal = true;
		elseif item:getType() == "SugarcanePile" then
			ItemName = getItemText("Sugarcane_Pile");
			State = getText("Tooltip_Dry");
		elseif item:getType() == "CheeseMoldFull" then
			ItemName = getItemText("Cheese_in_Mold");
			State = getText("Tooltip_Finished");
		elseif item:getType() == "CheeseMoldFull2" then
			ItemName = getItemText("BarCheese_in_Mold");
			State = getText("Tooltip_Finished");
		elseif item:getType() == "CheeseMoldFull3" then
			ItemName = getItemText("Mozzarella_in_Mold");
			State = getText("Tooltip_Finished");
		else
		end
		if not data.dry then
			data.dry = 0;
		end
		if data.dry == 0 then
			if getGameTime():getWorldAgeHours() - data.initialhour  >= data.hoursneeded then
				data.dry = 1;
				item:setName(ItemName .. " " .. State);
				--if item:getType() == "SugarcanePile" then
					--local newTexture = item:getTexture():setName("media/textures/Item_CanePileDry.png");
					--item:setTexture(newTexture);
					--item:setTexture(getTexture("media/textures/Item_CanePileDry.png"))
				--end
			else
				if not data.timetake then
					data.timetake = getGameTime():getWorldAgeHours() - data.initialhour;
					data.initialhour = data.timetake;
				end
				if animal then
					State = getText("Tooltip_Ruined");
				else
					if item:getType() == "SugarcanePile" then
						State = getText("Tooltip_Green");
					else
						State = getText("Tooltip_NotFinished");
					end
				end
				item:setName(ItemName .. " " .. State);
				data.dry = 2;
			end
		else
			if not animal then
				if data.dry and data.dry == 2 then
					if data.timetake then
						if (data.timetake + (getGameTime():getWorldAgeHours() - data.initialhour))  >= data.hoursneeded then
							data.dry = 1;
							item:setName(ItemName .. " " .. State);
						else
							data.timetake = data.timetake + (getGameTime():getWorldAgeHours() - data.initialhour);
							data.initialhour = data.timetake;
						end
					end
				end
			end
		end
		data.IsInside = 0;
	end
end

function ISInventoryTransferAction:reduceweightonputin(item)
	local itemdata = item:getModData();
	if not itemdata.bweight then
		itemdata.bweight = item:getActualWeight();
	end
	item:setActualWeight((itemdata.bweight * 0.5));
    item:setWeight(item:getActualWeight());
    item:setCustomWeight(true)
end

function ISInventoryTransferAction:restoreweightontake(item)
	local itemdata = item:getModData();
	if itemdata.bweight then
		item:setActualWeight(itemdata.bweight);
		item:setWeight(item:getActualWeight());
		item:setCustomWeight(true)
	end
end