----------------------------------------------------------------------------------
--
-- ZAWDigClayMenu.lua
-- Parte del mod Advanced Fishing.
-- Creado por Snake.
--
--
-- El codigo base se encuentra en ISInventoryBuildMenu.lua
-- los cuales han sido creados por Robert Johnson.
--
----------------------------------------------------------------------------------


ZAWDigClayMenu = {};

ZAWDigClayMenu.DigMenu = function(player, context, worldobjects, test)

	if test and ISWorldObjectContextMenu.Test then
		return true;
	end
	local pl = getSpecificPlayer(player);
    local _inventory = pl:getInventory();
	local candig = nil;
	local _digforclaySourceSquare = nil;
--	local perkflvl = player:getPerkLevel(Perks.PlantScavenging);
	local shovel = _inventory:getBestCondition("Shovel")

	local _squares = {};
	local _duplicate = false;
	local _objectSquare = nil;

	if shovel and shovel:getCondition() > 0 then
		for _, _currentObject in pairs(worldobjects) do
			_duplicate = false;
			_objectSquare = _currentObject:getSquare(); 	-- La celda del objeto.
			if _objectSquare ~= nil then
				for _, _currentSquare in pairs(_squares) do
					if _currentSquare == _objectSquare then
						_duplicate = true;
						break
					end
				end
			end

			if not _duplicate then
				table.insert(_squares, _objectSquare);
			end
		end

		local _spriteName = "";
		local _possibleFloor = nil;
		local _objectList = nil;
		for _, _currentSquare in pairs(_squares) do
			_objectList = _currentSquare:getObjects();
			for i = 0, _objectList:size()-1 do
				_possibleFloor = _objectList:get(i)
				if _possibleFloor:getSprite() and _possibleFloor:getSprite():getProperties() then
					_spriteName = _possibleFloor:getSprite():getProperties();
					if _spriteName:Is(IsoFlagType.water) and _possibleFloor:getSquare():DistToProper(pl:getSquare()) < 2 then
						candig = true;
						_digforclaySourceSquare = _currentSquare;
						break;
					end
				end
			end

			if candig == true then
				break;
			end
		end
	end
	
	if candig ~= nil and shovel and shovel:getCondition() > 0 then
--		if player:getStats():getEndurance() < 0.8 then
		local _option = context:addOption(getText("ContextMenu_DigForClay"), _digforclaySourceSquare, ZAWDigClayMenu.onDigForClay, pl);
		if pl:getStats():getEndurance() <= 0.2 then
--			local _option = context:addOption(getText("ContextMenu_DigForClay"), _digforclaySourceSquare, ZAWDigClayMenu.onDigForClay, player);
			_option.notAvailable = true;
			local tooltip = ISWorldObjectContextMenu.addToolTip();
			tooltip:setName(getText("ContextMenu_DigForClay"));
			tooltip.description = getText("IGUI_TooExhausted");
			_option.toolTip = tooltip;
		end
	end
end

ZAWDigClayMenu.onDigForClay = function(targetSquare, player)
	if luautils.walkAdj(player, targetSquare) then
		local item = player:getInventory():getItemFromType("Shovel");
		if item:getCondition() > 0 then
			if not item:isEquipped() then
				ISTimedActionQueue.add(ISEquipWeaponAction:new(player, item, 50, true, true))
			end
	--		ISWorldObjectContextMenu.equip(player, player:getPrimaryHandItem(), "Shovel", true);
			getPlayer():faceLocation(targetSquare:getX(), targetSquare:getY());
			local time = 350;
			ISTimedActionQueue.add(ZAWDigClayAction:new(player, targetSquare, time));
		end
	else
		luautils.okModal(getText("Tooltip_ZAWTooFar"), true);
	end
end

Events.OnFillWorldObjectContextMenu.Add(ZAWDigClayMenu.DigMenu);
