require "ISUI/ISToolTipInv"

local isFood = nil;
local LeGourmetMod = nil;
local AmmoMakerMod = nil;
local WPAMod = nil;
local KeysMod = nil;
local MoneyMod = nil;

if ZMoney then
    MoneyMod = true;
end
if DIHAKFT then
    KeysMod = true;
end
if LGBaseGameCharacterDetails then
    LeGourmetMod = true;
end

if SWPBaseGameCharacterDetails or AMBaseGameCharacterDetails then
    AmmoMakerMod = true;
end
if WPABaseGameCharacterDetails then
    WPAMod = true;
end

if ISToolTipInv.loaded ~= nil then
    print('INFO: Custom tooltips already loaded, skipping...');
    return
else
    ISToolTipInv.loaded = 1
end

function ISToolTipInv:render()
    if self.item:getModule() == 'ORGM' and self.renderORGM then
        self:renderORGM()
        return
    end
    -- we render the tool tip for inventory item only if there's no context menu showed
    if not ISContextMenu.instance or not ISContextMenu.instance.visibleCheck then

        local mx = getMouseX() + 24;
        local my = getMouseY() + 24;
        if not self.followMouse then
            mx = self:getX()
            my = self:getY()
            if self.anchorBottomLeft then
                mx = self.anchorBottomLeft.x
                my = self.anchorBottomLeft.y
            end
        end

        self.tooltip:setX(mx+11);
        self.tooltip:setY(my);

        self.tooltip:setWidth(50)
        self.tooltip:setMeasureOnly(true)
        self.item:DoTooltip(self.tooltip);
        self.tooltip:setMeasureOnly(false)

        local myCore = getCore();
        local maxX = myCore:getScreenWidth();
        local maxY = myCore:getScreenHeight();

        local lh = getTextManager():getFontFromEnum(UIFont.Small):getLineHeight(); --height dimesion of one line

        local tw = self.tooltip:getWidth();
        local th = self.tooltip:getHeight();

        if AmmoMakerMod ~= nil or WPAMod ~= nil then
            if self.item:getModule() == "SnakeWeaponPack"
              or self.item:getModule() == "AmmoMaker"
              or self.item:getModule() == "WPA"
              or self.item:getType() == "Pistol"
              or self.item:getType() == "Shotgun"
              or self.item:getType() == "VarmintRifle"
              or self.item:getType() == "HuntingRifle" then

                local modData = self.item:getModData() -- gets the item's mod data

                local wtext = nil
                -- set the text to show what the item is currently loaded with
                --if modData.loadedAmmo == nil then
                    -- pass
                --elseif modData.loadedAmmo == 'mixed' then
                --    wtext = getText("ContextMenu_LoadedMixed")
                --else
                --    local ammoName = getScriptManager():FindItem('SnakeWeaponPack.' .. modData.loadedAmmo):getDisplayName()
                --    wtext = getText("ContextMenu_LoadedAmmo") .. ammoName
                --end

                -- set the text to show the current fire mode
                if modData.selectFire ~= nil then
                    wtext = "";
                    local fireMode = "";
                    if modData.selectFire == 1 then
                        fireMode = getText("ContextMenu_FireMode") .. getText("ContextMenu_Full-Auto");
                    else
                        fireMode = getText("ContextMenu_FireMode") .. getText("ContextMenu_Semi-Auto");
                    end
                    if wtext ~= nil then
                        wtext = getText("ContextMenu_FireModeBinding") .. "\n" .. fireMode;
                        th = th + lh;
                    else
                        wtext = fireMode;
                    end
                end

                if wtext ~= nil then
                    self.item:setTooltip(wtext)
                end
                if modData.SilencerDurability ~= nil and modData.SilencerDurability ~= 0 then
                    if self.item:getType() == "AK47"
                      or self.item:getType() == "M16"
                      or self.item:getType() == "M16cammo" then
                        th = th + lh *2;
                    end
                    if self.item:getType() == "SilencerAK"
                      or self.item:getType() == "Silencerm16"
                      or self.item:getType() == "Silencer1"
                      or self.item:getType() == "Silencer2"
                      or self.item:getType() == "Silencer3"
                      or self.item:getType() == "Silencer6"
                      or self.item:getType() == "Shotgun" then
                        th = th + 4 + lh *2;
                    end
                    if self.item:getType() == "Silencer5" then
                        th = th + lh *3;
                    end
                    if self.item:getType() == "HuntingRifle"
                      or self.item:getType() == "VarmintRifle" then
                        tw = tw + 20;
                        th = th + 4 + lh *2;
                    end
                    if self.item:getType() == "Pistol" then
                        tw = tw + 30;
                        th = th + 4 + lh *2;
                    end
                end
            end
        end
        if LeGourmetMod ~= nil then
            if self.item:isFishingLure() then
                local FishingLevel = getPlayer():getPerkLevel(Perks.Fishing);
                local recipes =  getPlayer():getKnownRecipes();
                local learned = nil;
--                if FishingLevel >= 5 or learned ~= nil then
                    local linemultiplier = 1;
                    local tn = nil;
                    if self.item:getType() == "StormFlutterstick" then
                        tn = true;
                        linemultiplier = 14;
                    elseif self.item:getType() == "SpoonLure2" then
                        tn = true;
                        linemultiplier = 13;
                    elseif self.item:getType() == "RattlinRap" or self.item:getType() == "SpoonLure1" or self.item:getType() == "Crankbait" or self.item:getType() == "SwimShad" or self.item:getType() == "Spinnerbait" then
                        tn = true;
                        linemultiplier = 10;
                    elseif self.item:getType() == "SpoonLure3" or self.item:getType() == "Alfers" then
                        tn = true;
                        linemultiplier = 9;
                    elseif self.item:getType() == "SwimJig2" or self.item:getType() == "SwimJig3" then
                        tn = true;
                        linemultiplier = 8;
                    elseif self.item:getType() == "SwimJig" or self.item:getType() == "GTPopper" or self.item:getType() == "JitterBug" then
                        tn = true;
                        linemultiplier = 7;
                    end
                  --Mas espacio si se tiene el rasgo o nivel necesario.
                    tw = tw;
                    if tn ~= nil then
                        th = th + lh *linemultiplier;
                    else
                        th = th;
                    end
--                end
            end
            if self.item:getCategory() == "Food" then
                if self.item:getType() == "Cigarettes"
                  or self.item:getType() == "Bleach"
                  or self.item:getType() == "Worm"
                  or self.item:getType() == "RedWorm"
                  or self.item:getType() == "ZAWRawBrickPack"
                  or self.item:getType() == "Sugarcane"
                  or self.item:getType() == "SugarcanePile" then
                    --if self.item:getType() == "SugarcanePile" then
                        --local modData = self.item:getModData()
                        --if not modData

                    --nothing
                else
                    local hasTrait = nil;
                    local cookingLevel = getPlayer():getPerkLevel(Perks.Cooking);
                    if getPlayer(0):HasTrait("foodexpiration") or getPlayer(0):HasTrait("foodexpiration2") then
                        hasTrait = true;
                    end
                    if cookingLevel >= 4 and cookingLevel < 6 then
                      --Mas espacio si se tiene el rasgo o nivel necesario.
                      tw = tw;
                      th = th + lh *2;
                    elseif hasTrait ~= nil or cookingLevel >= 6 then
                      tw = tw + 120;
                      th = th + lh *2 + lh;
                    else
                      tw = tw;
                      th = th;
                    end
                end
            end
            if self.item:getType() == "Slingshot"
              or self.item:getType() == "Slingshot2"
              or self.item:getType() == "CowSkin"
              or self.item:getType() == "DeerSkin"
              or self.item:getType() == "BearSkin"
              or self.item:getType() == "SugarcanePile"
              or self.item:getType() == "CheeseMoldFull"
              or self.item:getType() == "CheeseMoldFull2"
              or self.item:getType() == "CheeseMoldFull3" then
                local modData = self.item:getModData()
                if self.item:getType() == "Slingshot" or self.item:getType() == "Slingshot2" then
                    if not modData.SlingshotDurability then
                        modData.SlingshotDurability = 100;
                    end
                    if modData.SlingshotDurability ~= nil and modData.SlingshotDurability ~= 0 then
                        th = th + lh *3;
                    end
                elseif self.item:getType() == "CowSkin"
                  or self.item:getType() == "DeerSkin"
                  or self.item:getType() == "BearSkin"
                  or self.item:getType() == "SugarcanePile"
                  or self.item:getType() == "CheeseMoldFull"
                  or self.item:getType() == "CheeseMoldFull2"
                  or self.item:getType() == "CheeseMoldFull3" then
                    if not modData.dry then
                        --modData.dry = 0;
                        th = self.tooltip:getHeight();
                    else
                        th = th + lh;
                    end
                end
            end
        end

        self.tooltip:setX(math.max(0, math.min(mx + 11, maxX - tw - 1)));
        if not self.followMouse and self.anchorBottomLeft then
            self.tooltip:setY(math.max(0, math.min(my - th, maxY - th - 1)));
        else
            self.tooltip:setY(math.max(0, math.min(my, maxY - th - 1)));
        end

        self:setX(self.tooltip:getX() - 11);
        self:setY(self.tooltip:getY());

        self:setWidth(tw + 11);

        if ZMoney then
            MoneyMod = true;
        end

        function len(T)
            local c = 0
            for _ in pairs(T) do c = c + 1 end
            return c
        end

        local itemData = nil;
        if self.item:hasModData() then
            itemData = self.item:getModData();
            if itemData.tooltip ~= nil then
                th = th + (lh * len(itemData.tooltip));
            end
        end

        self:setHeight(th);
        if self.followMouse then
            self:adjustPositionToAvoidOverlap({ x = mx - 24 * 2, y = my - 24 * 2, width = 24 * 2, height = 24 * 2 })
        end
        self:drawRect(0, 0, self.width, self.height, self.backgroundColor.a, self.backgroundColor.r, self.backgroundColor.g, self.backgroundColor.b);
        self:drawRectBorder(0, 0, self.width, self.height, self.borderColor.a, self.borderColor.r, self.borderColor.g, self.borderColor.b);
        if AmmoMakerMod ~= nil or WPAMod ~= nil then
            if self.item:getModule() == "SnakeWeaponPack"
              or self.item:getModule() == "AmmoMaker"
              or self.item:getModule() == "WPA"
              or self.item:getType() == "Pistol"
              or self.item:getType() == "Shotgun"
              or self.item:getType() == "VarmintRifle"
              or self.item:getType() == "HuntingRifle" then
                local modData = self.item:getModData() -- gets the item's mod data
                if modData.SilencerDurability ~= nil and modData.SilencerDurability ~= 0 then
                    if self.item:getType() == "AK47"
                      or self.item:getType() == "M16"
                      or self.item:getType() == "M16cammo"
                      or self.item:getType() == "SilencerAK"
                      or self.item:getType() == "Silencerm16"
                      or self.item:getType() == "Pistol"
                      or self.item:getType() == "Shotgun"
                      or self.item:getType() == "VarmintRifle"
                      or self.item:getType() == "HuntingRifle"
                      or self.item:getType() == "Silencer1"
                      or self.item:getType() == "Silencer2"
                      or self.item:getType() == "Silencer3"
                      or self.item:getType() == "Silencer5"
                      or self.item:getType() == "Silencer6" then
                        local items_count = math.floor((self.tooltip:getHeight() / lh) - 1); --calculate number of actual items in tooltip.
                        local r = 1;
                        local g = 1;
                        local b = 1;
                        local percent = modData.SilencerDurability;
                        local label = getText("ContextMenu_SilencerD");
                        local label_pos = 26 + (lh * (items_count));
                        local wpos = (tw/2) - 50;
                        local PX_LETTER = 10;
                        local lblInfo = "";
                        local element = "%s";
                        if percent <= 100 and percent >= 80 then
                            r = 0.0; --Si se encuentra entre 80 y 100, perfecto estado color Celeste
                            g = 0.8;
                            b = 0.8;
                        elseif percent < 80 and percent >= 60 then
                            r = 0.0; --Si se encuentra entre 60 y 80, Buen estado color verde
                            g = 0.8;
                            b = 0.0;
                        elseif percent < 60 and percent >= 40 then
                            r = 0.4; --Si se encuentra entre 40 y 60, Normal color verde claro
                            g = 0.8;
                            b = 0.0;
                        elseif percent < 40 and percent >= 20 then
                            r = 0.8; --Si se encuentra entre 20 y 40, Un poco pasado color amarillo
                            g = 0.8;
                            b = 0.0;
                        elseif percent < 20 and percent > 10 then
                            r = 0.8; --Si se encuentra entre 10 y 20, Muy pasado color naranja
                            g = 0.4;
                            b = 0.0;
                        elseif percent < 10 and percent > 0 then
                            r = 1; --Si se encuentra entre 1 y 10, Muy pasado color rojo
                            g = 0.0;
                            b = 0.0;
                        else
                        end


                        lblInfo = lblInfo .. string.format(element, percent);
                        self.tooltip:DrawText(label, 5, label_pos - 4, 1,1,0.8,self.borderColor.a);
                        self:drawRect(tw - 5 - 100, label_pos + 4, 100, 2, 0.05, 1.0, 1.0, 1.0);
                        self:drawRectBorder(tw - 5 - 100, label_pos + 4, 100, 2, self.borderColor.a, self.borderColor.r, self.borderColor.g, self.borderColor.b);
                        self:drawRect(tw - 5 - 100, label_pos + 4, percent, 2, 1, r, g, b);
                        self.tooltip:DrawText(lblInfo .. "%", tw - 5 - 75, label_pos + (lh/2), r,g,b,self.borderColor.a);
                    end
                end
            end
        end
        if LeGourmetMod ~= nil then
            if self.item:getType() == "Slingshot" or self.item:getType() == "Slingshot2" then
                local modData = self.item:getModData() -- gets the item's mod data
                if modData.SlingshotDurability ~= nil and modData.SlingshotDurability ~= 0 then
                        local items_count = math.floor((self.tooltip:getHeight() / lh) - 1); --calculate number of actual items in tooltip.
                        local r = 1;
                        local g = 1;
                        local b = 1;
                        local percent = modData.SlingshotDurability;
                        local label = getText("ContextMenu_SlingshotD");
                        local label_pos = 26 + (lh * (items_count));
                        local wpos = (tw/2) - 50;
                        local PX_LETTER = 10;
                        local lblInfo = "";
                        local element = "%s";
                        if percent <= 100 and percent >= 80 then
                            r = 0.0; --Si se encuentra entre 80 y 100, perfecto estado color Celeste
                            g = 0.8;
                            b = 0.8;
                        elseif percent < 80 and percent >= 60 then
                            r = 0.0; --Si se encuentra entre 60 y 80, Buen estado color verde
                            g = 0.8;
                            b = 0.0;
                        elseif percent < 60 and percent >= 40 then
                            r = 0.4; --Si se encuentra entre 40 y 60, Normal color verde claro
                            g = 0.8;
                            b = 0.0;
                        elseif percent < 40 and percent >= 20 then
                            r = 0.8; --Si se encuentra entre 20 y 40, Un poco pasado color amarillo
                            g = 0.8;
                            b = 0.0;
                        elseif percent < 20 and percent > 10 then
                            r = 0.8; --Si se encuentra entre 10 y 20, Muy pasado color naranja
                            g = 0.4;
                            b = 0.0;
                        elseif percent < 10 and percent > 0 then
                            r = 1; --Si se encuentra entre 1 y 10, Muy pasado color rojo
                            g = 0.0;
                            b = 0.0;
                        else
                        end
                        lblInfo = lblInfo .. string.format(element, percent);
                        self.tooltip:DrawText(label, 5, label_pos - 4, 1,1,0.8,self.borderColor.a);
                        self:drawRect(tw - 5 - 100, label_pos + 4, 100, 2, 0.05, 1.0, 1.0, 1.0);
                        self:drawRectBorder(tw - 5 - 100, label_pos + 4, 100, 2, self.borderColor.a, self.borderColor.r, self.borderColor.g, self.borderColor.b);
                        self:drawRect(tw - 5 - 100, label_pos + 4, percent, 2, 1, r, g, b);
                        self.tooltip:DrawText(lblInfo .. "%", tw - 5 - 75, label_pos + (lh/2), r,g,b,self.borderColor.a);
                end
            end
            if self.item:getType() == "CowSkin"
              or self.item:getType() == "DeerSkin"
              or self.item:getType() == "BearSkin"
              or self.item:getType() == "SugarcanePile"
              or self.item:getType() == "CheeseMoldFull"
              or self.item:getType() == "CheeseMoldFull2"
              or self.item:getType() == "CheeseMoldFull3" then
                local modData = self.item:getModData() -- gets the item's mod data
                local items_count = math.floor((self.tooltip:getHeight() / lh) - 1); --calculate number of actual items in tooltip
                local label_pos = lh * (items_count);
                local text = "";
                local text2 = "";
                local actualhours = 0;
                local ItemName = "";
                local animal = false;
                local State = "";
                if self.item:getType() == "CowSkin" then
                    ItemName = getItemText("Cow_skin");
                    animal = true;
                elseif self.item:getType() == "DeerSkin" then
                    ItemName = getItemText("Deer_skin");
                    animal = true;
                elseif self.item:getType() == "BearSkin" then
                    ItemName = getItemText("Bear_skin");
                    animal = true;
                elseif self.item:getType() == "SugarcanePile" then
                    ItemName = getItemText("Sugarcane_Pile");
                    animal = false;
                elseif self.item:getType() == "CheeseMoldFull" then
                    ItemName = getItemText("Cheese_in_Mold");
                    animal = false;
                elseif self.item:getType() == "CheeseMoldFull2" then
                    ItemName = getItemText("BarCheese_in_Mold");
                    animal = false;
                elseif self.item:getType() == "CheeseMoldFull3" then
                    ItemName = getItemText("Mozzarella_in_Mold");
                    animal = false;
                else
                end
                if modData.hoursneeded and modData.initialhour then
                    if modData.IsInside and modData.IsInside == 1 then
                        actualhours = getGameTime():getWorldAgeHours() - modData.initialhour;
                    else
                        actualhours = 0;
                    end
                    if self.item:getType() == "CheeseMoldFull"
                      or self.item:getType() == "CheeseMoldFull2"
                      or self.item:getType() == "CheeseMoldFull3" then
                        if actualhours >= 24 then
                            text = getText("IGUI_Days_need2");
                        else
                            text = getText("IGUI_Hours_need2");
                        end
                        if modData.hoursneeded >= 24 then
                            text = getText("IGUI_Days_need2");
                            text2 = tonumber(string.format("%." .. (2 or 0) .. "f", (modData.hoursneeded / 24)))
                        else
                            text = getText("IGUI_Hours_need2");
                            text2 = modData.hoursneeded;
                        end
                    else
                        if actualhours >= 24 then
                            text = getText("IGUI_Days_need");
                        else
                            text = getText("IGUI_Hours_need");
                        end
                        if modData.hoursneeded >= 24 then
                            text = getText("IGUI_Days_need");
                            text2 = tonumber(string.format("%." .. (2 or 0) .. "f", (modData.hoursneeded / 24)))
                        else
                            text = getText("IGUI_Hours_need");
                            text2 = modData.hoursneeded;
                        end
                    end
                end

                if modData.dry == 0 then
                    --self.tooltip:DrawText(getText("IGUI_Hours_need") .. ":", 5, label_pos - 4, 1,1,0.8,self.borderColor.a);
                    --self.tooltip:DrawTextCentre(getText("IGUI_Hours_need") .. ":", tw / 2, label_pos, 1,1,0.4,self.borderColor.a);
                    if self.item:getContainer() and self.item:getContainer():getType() == "floor" then
                        if animal then
                            modData.dry = 2;
                            self.item:setName(ItemName .. " " .. getText("Tooltip_Ruined"));
                        else
                        end
                    end
                    if modData.hoursneeded and modData.initialhour then
                        self.tooltip:DrawText(text .. ":", 5, label_pos + (lh - 3), 1,1,0.8,self.borderColor.a);
                        if actualhours >= modData.hoursneeded then
                            modData.dry = 1;
                            if self.item:getType() == "CheeseMoldFull"
                              or self.item:getType() == "CheeseMoldFull"
                              or self.item:getType() == "CheeseMoldFull" then
                                self.item:setName(ItemName .. " " .. getText("Tooltip_Finished"));
                            elseif self.item:getType() == "SugarcanePile" then
                                self.item:setName(ItemName .. " " .. getText("Tooltip_Dry"));
                            else
                                self.item:setName(ItemName .. " " .. getText("Tooltip_Cured"));
                            end
                            self.tooltip:DrawTextCentre(text2 .. "/" .. text2, tw / 2, label_pos + (lh - 3), 1,1,1,self.borderColor.a);
                        else
                            --actualhours = round2(actualhours, 2) .. "";
                            if text == getText("IGUI_Days_need") or text == getText("IGUI_Days_need2") then
                                --days = actualhours / 24
                                actualhours = tonumber(string.format("%." .. (2 or 0) .. "f", (actualhours/24)))
                            else
                                actualhours = tonumber(string.format("%." .. (2 or 0) .. "f", actualhours))
                            end
                            self.tooltip:DrawTextCentre(actualhours .. "/" .. text2, tw / 2, label_pos + (lh - 3), 1,1,1,self.borderColor.a);
                        end
                    end
                elseif modData.dry == 1 then
                    self.tooltip:DrawText(text .. ":", 5, label_pos + (lh - 3), 1,1,0.8,self.borderColor.a);
                    self.tooltip:DrawTextCentre(modData.hoursneeded .. "/" .. text2, tw / 2, label_pos + (lh - 3), 1,1,1,self.borderColor.a);
                elseif modData.dry == 2 then
                    if animal then
                        self.tooltip:DrawText(text .. ":", 5, label_pos + (lh - 3), 1,1,0.8,self.borderColor.a);
                        local number = 0;
                        --if modData.timetake and modData.timetake > 0 then
                            --if text == getText("IGUI_Days_need") then
                            --    modData.timetake = tonumber(string.format("%." .. (2 or 0) .. "f", (modData.timetake/24)))
                            --else
                            --    modData.timetake = tonumber(string.format("%." .. (2 or 0) .. "f", modData.timetake))
                            --end
                            if text == getText("IGUI_Days_need") or text == getText("IGUI_Days_need2") then
                                --days = actualhours / 24
                                number = self:round2(modData.timetake/24, 2); ---tonumber(string.format("%." .. (2) .. "f", (modData.timetake/24)))
                            else
                                number = self:round2(modData.timetake, 2);--tonumber(string.format("%." .. (2) .. "f", modData.timetake))
                            end
                            --modData.timetake = 0;
                        --end
                        --self.tooltip:DrawTextCentre(modData.timetake .. "/" .. text2, tw / 2, label_pos + (lh - 3), 1,1,1,self.borderColor.a);
                        self.tooltip:DrawTextCentre(number .. "/" .. text2, tw / 2, label_pos + (lh - 3), 1,1,1,self.borderColor.a);
                    else
                        if modData.hoursneeded and modData.initialhour then
                            self.tooltip:DrawText(text .. ":", 5, label_pos + (lh - 3), 1,1,0.8,self.borderColor.a);
                            if (modData.timetake + actualhours) >= modData.hoursneeded then
                                modData.dry = 1;
                                if self.item:getType() == "SugarcanePile" then
                                    self.item:setName(ItemName .. " " .. getText("Tooltip_Dry"));
                                else
                                    self.item:setName(ItemName .. " " .. getText("Tooltip_Finished"));
                                end
                                self.tooltip:DrawTextCentre(text2 .. "/" .. text2, tw / 2, label_pos + (lh - 3), 1,1,1,self.borderColor.a);
                            else
                                --actualhours = round2(actualhours, 2) .. "";
                                local number = 0;
                                if text == getText("IGUI_Days_need") or text == getText("IGUI_Days_need2") then
                                    --days = actualhours / 24
                                    actualhours = self:round2(actualhours/24, 2); --tonumber(string.format("%." .. (2) .. "f", (actualhours/24)))
                                    number = self:round2(modData.timetake/24, 2); ---tonumber(string.format("%." .. (2) .. "f", (modData.timetake/24)))
                                else
                                    actualhours = self:round2(actualhours, 2); --tonumber(string.format("%." .. (2) .. "f", actualhours))
                                    number = self:round2(modData.timetake, 2);--tonumber(string.format("%." .. (2) .. "f", modData.timetake))
                                end
                                if modData.IsInside and modData.IsInside == 1 then
                                    self.tooltip:DrawTextCentre(self:round2(number + actualhours, 2) .. "/" .. text2, tw / 2, label_pos + (lh - 3), 1,1,1,self.borderColor.a);
                                else
                                    self.tooltip:DrawTextCentre(number .. "/" .. text2, tw / 2, label_pos + (lh - 3), 1,1,1,self.borderColor.a);
                                end
                            end
                        end
                    end
                end
            end

            if self.item:isFishingLure() then
                local hasProf = nil;
                if getPlayer(0):getDescriptor():getProfession() == "fisherman" then
                    hasProf = true;
                end
                local FishingLevel = getPlayer():getPerkLevel(Perks.Fishing);
                local recipes =  getPlayer():getKnownRecipes();
                local items_count = math.floor((self.tooltip:getHeight() / lh) - 1); --calculate number of actual items in tooltip.
                local label = getText("UI_fishingtooltip");
                local label_pos = 26 + (lh * (items_count));

                if self.item:getType() == "StormFlutterstick" then
                    self.tooltip:DrawTextCentre(getText("UI_fishingproperties"), tw / 2, label_pos, 1,1,0.4,self.borderColor.a);
                    self.tooltip:DrawText(label, 5, label_pos + lh, 1,1,0.8,self.borderColor.a);
                    if recipes:contains("AttractDorado") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Dorado"), 5, label_pos + (lh * 2), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Dorado"), 5, label_pos + (lh * 2), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPiranha") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Piranha"), 5, label_pos + (lh * 3), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Piranha"), 5, label_pos + (lh * 3), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPalometa") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Palometa"), 5, label_pos + (lh * 4), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Palometa"), 5, label_pos + (lh * 4), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPayara") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Payara"), 5, label_pos + (lh * 5), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Payara"), 5, label_pos + (lh * 5), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractTararira") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Tararira"), 5, label_pos + (lh * 6), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Tararira"), 5, label_pos + (lh * 6), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractTucunare") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Tucunare"), 5, label_pos + (lh * 7), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Tucunare"), 5, label_pos + (lh * 7), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractSnakehead") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Snakehead"), 5, label_pos + (lh * 8), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Snakehead"), 5, label_pos + (lh * 8), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractArowana") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Arowana"), 5, label_pos + (lh * 9), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Arowana"), 5, label_pos + (lh * 9), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractBass") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Bass"), 5, label_pos + (lh * 10), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Bass"), 5, label_pos + (lh * 10), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractCrappie") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Crappiefish"), 5, label_pos + (lh * 11), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Crappiefish"), 5, label_pos + (lh * 11), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPerch") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Perch"), 5, label_pos + (lh * 12), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Perch"), 5, label_pos + (lh * 12), 1.0,1.0,1.0,self.borderColor.a);
                    end
                elseif self.item:getType() == "RattlinRap" then
                    self.tooltip:DrawTextCentre(getText("UI_fishingproperties"), tw / 2, label_pos, 1,1,0.4,self.borderColor.a);
                    self.tooltip:DrawText(label, 5, label_pos + lh, 1,1,0.8,self.borderColor.a);
                    if recipes:contains("AttractDorado") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Dorado"), 5, label_pos + (lh * 2), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Dorado"), 5, label_pos + (lh * 2), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPiranha") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Piranha"), 5, label_pos + (lh * 3), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Piranha"), 5, label_pos + (lh * 3), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPalometa") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Palometa"), 5, label_pos + (lh * 4), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Palometa"), 5, label_pos + (lh * 4), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPayara") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Payara"), 5, label_pos + (lh * 5), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Payara"), 5, label_pos + (lh * 5), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractTararira") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Tararira"), 5, label_pos + (lh * 6), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Tararira"), 5, label_pos + (lh * 6), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractTucunare") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Tucunare"), 5, label_pos + (lh * 7), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Tucunare"), 5, label_pos + (lh * 7), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractSnakehead") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Snakehead"), 5, label_pos + (lh * 8), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Snakehead"), 5, label_pos + (lh * 8), 1.0,1.0,1.0,self.borderColor.a);
                    end
                elseif self.item:getType() == "SwimJig" then
                    self.tooltip:DrawTextCentre(getText("UI_fishingproperties"), tw / 2, label_pos, 1,1,0.4,self.borderColor.a);
                    self.tooltip:DrawText(label, 5, label_pos + lh, 1,1,0.8,self.borderColor.a);
                    if recipes:contains("AttractPiranha") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Piranha"), 5, label_pos + (lh * 2), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Piranha"), 5, label_pos + (lh * 2), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPalometa") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Palometa"), 5, label_pos + (lh * 3), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Palometa"), 5, label_pos + (lh * 3), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractCatfish") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_CatFish"), 5, label_pos + (lh * 4), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_CatFish"), 5, label_pos + (lh * 4), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractWalleye") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Walleye"), 5, label_pos + (lh * 5), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Walleye"), 5, label_pos + (lh * 5), 1.0,1.0,1.0,self.borderColor.a);
                    end
                elseif self.item:getType() == "SwimJig2" then
                    self.tooltip:DrawTextCentre(getText("UI_fishingproperties"), tw / 2, label_pos, 1,1,0.4,self.borderColor.a);
                    self.tooltip:DrawText(label, 5, label_pos + lh, 1,1,0.8,self.borderColor.a);
                    if recipes:contains("AttractPiranha") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Piranha"), 5, label_pos + (lh * 2), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Piranha"), 5, label_pos + (lh * 2), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPalometa") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Palometa"), 5, label_pos + (lh * 3), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Palometa"), 5, label_pos + (lh * 3), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractTararira") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Tararira"), 5, label_pos + (lh * 4), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Tararira"), 5, label_pos + (lh * 4), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractCatfish") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_CatFish"), 5, label_pos + (lh * 5), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_CatFish"), 5, label_pos + (lh * 5), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractWalleye") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Walleye"), 5, label_pos + (lh * 6), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Walleye"), 5, label_pos + (lh * 6), 1.0,1.0,1.0,self.borderColor.a);
                    end
                elseif self.item:getType() == "SwimJig3" then
                    self.tooltip:DrawTextCentre(getText("UI_fishingproperties"), tw / 2, label_pos, 1,1,0.4,self.borderColor.a);
                    self.tooltip:DrawText(label, 5, label_pos + lh, 1,1,0.8,self.borderColor.a);
                    if recipes:contains("AttractPiranha") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Piranha"), 5, label_pos + (lh * 2), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Piranha"), 5, label_pos + (lh * 2), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPalometa") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Palometa"), 5, label_pos + (lh * 3), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Palometa"), 5, label_pos + (lh * 3), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractBass") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Bass"), 5, label_pos + (lh * 4), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Bass"), 5, label_pos + (lh * 4), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractCatfish") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_CatFish"), 5, label_pos + (lh * 5), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_CatFish"), 5, label_pos + (lh * 5), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractWalleye") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Walleye"), 5, label_pos + (lh * 6), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Walleye"), 5, label_pos + (lh * 6), 1.0,1.0,1.0,self.borderColor.a);
                    end
                elseif self.item:getType() == "GTPopper" then
                    self.tooltip:DrawTextCentre(getText("UI_fishingproperties"), tw / 2, label_pos, 1,1,0.4,self.borderColor.a);
                    self.tooltip:DrawText(label, 5, label_pos + lh, 1,1,0.8,self.borderColor.a);
                    if recipes:contains("AttractTararira") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Tararira"), 5, label_pos + (lh * 2), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Tararira"), 5, label_pos + (lh * 2), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractArowana") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Arowana"), 5, label_pos + (lh * 3), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Arowana"), 5, label_pos + (lh * 3), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractBass") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Bass"), 5, label_pos + (lh * 4), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Bass"), 5, label_pos + (lh * 4), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPerch") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Perch"), 5, label_pos + (lh * 5), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Perch"), 5, label_pos + (lh * 5), 1.0,1.0,1.0,self.borderColor.a);
                    end
                elseif self.item:getType() == "SpoonLure1" then
                    self.tooltip:DrawTextCentre(getText("UI_fishingproperties2"), tw / 2, label_pos, 1,1,0.4,self.borderColor.a);
                    self.tooltip:DrawText(label, 5, label_pos + lh, 1,1,0.8,self.borderColor.a);
                    if recipes:contains("AttractPiranha") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Piranha"), 5, label_pos + (lh * 2), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Piranha"), 5, label_pos + (lh * 2), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPalometa") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Palometa"), 5, label_pos + (lh * 3), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Palometa"), 5, label_pos + (lh * 3), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPayara") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Payara"), 5, label_pos + (lh * 4), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Payara"), 5, label_pos + (lh * 4), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractRTrout") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Rainbowtrout"), 5, label_pos + (lh * 5), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Rainbowtrout"), 5, label_pos + (lh * 5), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractSalmon") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Salmon"), 5, label_pos + (lh * 6), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Salmon"), 5, label_pos + (lh * 6), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractTrout") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Trout"), 5, label_pos + (lh * 7), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Trout"), 5, label_pos + (lh * 7), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractBass") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Bass"), 5, label_pos + (lh * 8), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Bass"), 5, label_pos + (lh * 8), 1.0,1.0,1.0,self.borderColor.a);
                    end
                elseif self.item:getType() == "SpoonLure2" then
                    self.tooltip:DrawTextCentre(getText("UI_fishingproperties2"), tw / 2, label_pos, 1,1,0.4,self.borderColor.a);
                    self.tooltip:DrawText(label, 5, label_pos + lh, 1,1,0.8,self.borderColor.a);
                    if recipes:contains("AttractDorado") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Dorado"), 5, label_pos + (lh * 2), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Dorado"), 5, label_pos + (lh * 2), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPiranha") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Piranha"), 5, label_pos + (lh * 3), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Piranha"), 5, label_pos + (lh * 3), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPalometa") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Palometa"), 5, label_pos + (lh * 4), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Palometa"), 5, label_pos + (lh * 4), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractRTrout") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Rainbowtrout"), 5, label_pos + (lh * 5), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Rainbowtrout"), 5, label_pos + (lh * 5), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractSalmon") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Salmon"), 5, label_pos + (lh * 6), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Salmon"), 5, label_pos + (lh * 6), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractTararira") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Tararira"), 5, label_pos + (lh * 7), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Tararira"), 5, label_pos + (lh * 7), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractTucunare") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Tucunare"), 5, label_pos + (lh * 8), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Tucunare"), 5, label_pos + (lh * 8), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractSnakehead") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Snakehead"), 5, label_pos + (lh * 9), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Snakehead"), 5, label_pos + (lh * 9), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractTrout") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Trout"), 5, label_pos + (lh * 10), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Trout"), 5, label_pos + (lh * 10), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPerch") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Perch"), 5, label_pos + (lh * 11), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Perch"), 5, label_pos + (lh * 11), 1.0,1.0,1.0,self.borderColor.a);
                    end
                elseif self.item:getType() == "SpoonLure3" then
                    self.tooltip:DrawTextCentre(getText("UI_fishingproperties2"), tw / 2, label_pos, 1,1,0.4,self.borderColor.a);
                    self.tooltip:DrawText(label, 5, label_pos + lh, 1,1,0.8,self.borderColor.a);
                    if recipes:contains("AttractPiranha") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Piranha"), 5, label_pos + (lh * 2), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Piranha"), 5, label_pos + (lh * 2), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPalometa") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Palometa"), 5, label_pos + (lh * 3), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Palometa"), 5, label_pos + (lh * 3), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPayara") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Payara"), 5, label_pos + (lh * 4), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Payara"), 5, label_pos + (lh * 4), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractRTrout") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Rainbowtrout"), 5, label_pos + (lh * 5), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Rainbowtrout"), 5, label_pos + (lh * 5), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractSalmon") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Salmon"), 5, label_pos + (lh * 6), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Salmon"), 5, label_pos + (lh * 6), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractTrout") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Trout"), 5, label_pos + (lh * 7), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Trout"), 5, label_pos + (lh * 7), 1.0,1.0,1.0,self.borderColor.a);
                    end
                elseif self.item:getType() == "JitterBug" then
                    self.tooltip:DrawTextCentre(getText("UI_fishingproperties"), tw / 2, label_pos, 1,1,0.4,self.borderColor.a);
                    self.tooltip:DrawText(label, 5, label_pos + lh, 1,1,0.8,self.borderColor.a);
                    if recipes:contains("AttractTararira") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Tararira"), 5, label_pos + (lh * 2), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Tararira"), 5, label_pos + (lh * 2), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPike") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Pike"), 5, label_pos + (lh * 3), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Pike"), 5, label_pos + (lh * 3), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractBass") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Bass"), 5, label_pos + (lh * 4), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Bass"), 5, label_pos + (lh * 4), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractCrappie") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Crappiefish"), 5, label_pos + (lh * 5), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Crappiefish"), 5, label_pos + (lh * 5), 1.0,1.0,1.0,self.borderColor.a);
                    end
                elseif self.item:getType() == "Crankbait" then
                    self.tooltip:DrawTextCentre(getText("UI_fishingproperties"), tw / 2, label_pos, 1,1,0.4,self.borderColor.a);
                    self.tooltip:DrawText(label, 5, label_pos + lh, 1,1,0.8,self.borderColor.a);
                    if recipes:contains("AttractPiranha") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Piranha"), 5, label_pos + (lh * 2), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Piranha"), 5, label_pos + (lh * 2), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPalometa") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Palometa"), 5, label_pos + (lh * 3), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Palometa"), 5, label_pos + (lh * 3), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPayara") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Payara"), 5, label_pos + (lh * 4), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Payara"), 5, label_pos + (lh * 4), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractSurubi") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Surubi"), 5, label_pos + (lh * 5), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Surubi"), 5, label_pos + (lh * 5), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractBass") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Bass"), 5, label_pos + (lh * 6), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Bass"), 5, label_pos + (lh * 6), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPerch") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Perch"), 5, label_pos + (lh * 7), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Perch"), 5, label_pos + (lh * 7), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractWalleye") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Walleye"), 5, label_pos + (lh * 8), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Walleye"), 5, label_pos + (lh * 8), 1.0,1.0,1.0,self.borderColor.a);
                    end
                elseif self.item:getType() == "SwimShad" then
                    self.tooltip:DrawTextCentre(getText("UI_fishingproperties"), tw / 2, label_pos, 1,1,0.4,self.borderColor.a);
                    self.tooltip:DrawText(label, 5, label_pos + lh, 1,1,0.8,self.borderColor.a);
                    if recipes:contains("AttractPiranha") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Piranha"), 5, label_pos + (lh * 2), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Piranha"), 5, label_pos + (lh * 2), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPalometa") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Palometa"), 5, label_pos + (lh * 3), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Palometa"), 5, label_pos + (lh * 3), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractSurubi") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Surubi"), 5, label_pos + (lh * 4), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Surubi"), 5, label_pos + (lh * 4), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPike") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Pike"), 5, label_pos + (lh * 5), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Pike"), 5, label_pos + (lh * 5), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractBass") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Bass"), 5, label_pos + (lh * 6), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Bass"), 5, label_pos + (lh * 6), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractCatfish") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_CatFish"), 5, label_pos + (lh * 7), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_CatFish"), 5, label_pos + (lh * 7), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractCrappie") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Crappiefish"), 5, label_pos + (lh * 8), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Crappiefish"), 5, label_pos + (lh * 8), 1.0,1.0,1.0,self.borderColor.a);
                    end
                elseif self.item:getType() == "Alfers" then
                    self.tooltip:DrawTextCentre(getText("UI_fishingproperties"), tw / 2, label_pos, 1,1,0.4,self.borderColor.a);
                    self.tooltip:DrawText(label, 5, label_pos + lh, 1,1,0.8,self.borderColor.a);
                    if recipes:contains("AttractPiranha") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Piranha"), 5, label_pos + (lh * 2), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Piranha"), 5, label_pos + (lh * 2), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPalometa") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Palometa"), 5, label_pos + (lh * 3), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Palometa"), 5, label_pos + (lh * 3), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPayara") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Payara"), 5, label_pos + (lh * 4), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Payara"), 5, label_pos + (lh * 4), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractArowana") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Arowana"), 5, label_pos + (lh * 5), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Arowana"), 5, label_pos + (lh * 5), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractPike") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Pike"), 5, label_pos + (lh * 6), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Pike"), 5, label_pos + (lh * 6), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractWalleye") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Walleye"), 5, label_pos + (lh * 7), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Walleye"), 5, label_pos + (lh * 7), 1.0,1.0,1.0,self.borderColor.a);
                    end
                elseif self.item:getType() == "Spinnerbait" then
                    self.tooltip:DrawTextCentre(getText("UI_fishingproperties2"), tw / 2, label_pos, 1,1,0.4,self.borderColor.a);
                    self.tooltip:DrawText(label, 5, label_pos + lh, 1,1,0.8,self.borderColor.a);
                    if recipes:contains("AttractDorado") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Dorado"), 5, label_pos + (lh * 2), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Dorado"), 5, label_pos + (lh * 2), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractRTrout") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Rainbowtrout"), 5, label_pos + (lh * 3), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Rainbowtrout"), 5, label_pos + (lh * 3), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractSalmon") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Salmon"), 5, label_pos + (lh * 4), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Salmon"), 5, label_pos + (lh * 4), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractTararira") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Tararira"), 5, label_pos + (lh * 5), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Tararira"), 5, label_pos + (lh * 5), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractTucunare") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Tucunare"), 5, label_pos + (lh * 6), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Tucunare"), 5, label_pos + (lh * 6), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractSnakehead") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Snakehead"), 5, label_pos + (lh * 7), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Snakehead"), 5, label_pos + (lh * 7), 1.0,1.0,1.0,self.borderColor.a);
                    end
                    if recipes:contains("AttractTrout") or hasProf ~= nil then
                        self.tooltip:DrawText(getText("IGUI_Fish_Trout"), 5, label_pos + (lh * 8), 0.4,0.8,0.0,self.borderColor.a);
                    else
                        self.tooltip:DrawText(getText("IGUI_?_Fish_Trout"), 5, label_pos + (lh * 8), 1.0,1.0,1.0,self.borderColor.a);
                    end
                end
            end
            if self.item:getCategory() == "Food" then
                if self.item:getType() == "Cigarettes"
                  or self.item:getType() == "Bleach"
                  or self.item:getType() == "Worm"
                  or self.item:getType() == "RedWorm"
                  or self.item:getType() == "ZAWRawBrickPack"
                  or self.item:getType() == "Sugarcane"
                  or self.item:getType() == "SugarcanePile" then
                    --nothing
                else
                    local hasTrait = nil;
                    local cookingLevel = getPlayer():getPerkLevel(Perks.Cooking);
                    if getPlayer(0):HasTrait("foodexpiration") or getPlayer(0):HasTrait("foodexpiration2") then
                        hasTrait = true;
                    end
                    if hasTrait ~= nil or cookingLevel >= 4 then
                        local r = 1;
                        local g = 1;
                        local b = 1;
                        local total = self.item:getScriptItem():getDaysTotallyRotten();
                        local left = total - self.item:getAge();
                        local percent = left * 100 / total;
                        local portions = "";
                        local lblInfo = "";
                        if total > 1000 then
                            b = 0.4; -- if not rotten, gold color
                        elseif percent <= 100 and percent >= 80 then
                            r = 0.0; --Si se encuentra entre 80 y 100, perfecto estado color Celeste
                            g = 0.8;
                            b = 0.8;
                            portions = getText("UI_status_VERYGOOD");
                        elseif percent < 80 and percent >= 60 then
                            r = 0.0; --Si se encuentra entre 60 y 80, Buen estado color verde
                            g = 0.8;
                            b = 0.0;
                            portions = getText("UI_status_GOOD");
                        elseif percent < 60 and percent >= 40 then
                            r = 0.4; --Si se encuentra entre 40 y 60, Normal color verde claro
                            g = 0.8;
                            b = 0.0;
                            portions = getText("UI_status_NORMAL");
                        elseif percent < 40 and percent >= 20 then
                            r = 0.8; --Si se encuentra entre 20 y 40, Un poco pasado color amarillo
                            g = 0.8;
                            b = 0.0;
                            portions = getText("UI_status_LITTLEROTTEN");
                        elseif percent < 20 and percent > 0 then
                            r = 0.8; --Si se encuentra entre 1 y 20, Muy pasado color naranja
                            g = 0.4;
                            b = 0.0;
                            portions = getText("UI_status_LITTLEMOREROTTEN");
                        else
                            g = 0.0; --Si se encuentra en 0, Podrido color rojo
                            b = 0.0;
                            portions = getText("UI_status_ROTTEN");
                        end

                        local items_count = math.floor((self.tooltip:getHeight() / lh) - 1); --calculate number of actual items in tooltip.
                        local label = getText("UI_tooltip");
                        local label_pos = 26 + (lh * (items_count));
                        local age;
                        local PX_LETTER = 10;

                        if(total > 1000) then
                            lblInfo = string.format("%s\n", getText("UI_status_NOROTTEN"));
                        else
                            --construcción de texto informativo para los alimentos
                            local element_ext = "%s (%.1f %s %d)";
                            local element = "%s";

                            age = string.format("%.1f", self.item:getAge());

                            if (hasTrait ~= nil) or cookingLevel >= 6 then
                                lblInfo = lblInfo .. string.format(element_ext, portions, age, getText("UI_have_daysoff"), total);
                            elseif cookingLevel >= 4 and cookingLevel < 6 then
                                lblInfo = lblInfo .. string.format(element, portions);
                            end
                        end

                        self.tooltip:DrawText(label, 5, label_pos - 4, 1,1,0.8,self.borderColor.a);
                        self.tooltip:DrawText(lblInfo, string.len(label) * PX_LETTER - PX_LETTER, label_pos - 4, r,g,b,self.borderColor.a);
                        if total < 1000 and (hasTrait ~= nil or cookingLevel >= 6) then
                            if percent < 0 then
                                percent = 0;
                            end
                            self:drawRect((string.len(label) * PX_LETTER - PX_LETTER) * 1.5, label_pos + lh, 100, 2, 0.05, 1.0, 1.0, 1.0);
                            self:drawRectBorder((string.len(label) * PX_LETTER - PX_LETTER) * 1.5, label_pos + lh, 100, 2, self.borderColor.a, self.borderColor.r, self.borderColor.g, self.borderColor.b);
                            self:drawRect((string.len(label) * PX_LETTER - PX_LETTER) * 1.5, label_pos + lh, percent, 2, 1, r, g, b);
                        end
                    else
                    end
                end
            end
        end

        if MoneyMod ~= nil then
            if itemData ~= nil and itemData.tooltip ~= nil then
                local count = 1;
                local label;
                local ty;
                for key in pairs(itemData.tooltip) do
                    ty = 25 + (lh * count);
                    label = getText("Tooltip_Mamount");
                    self.tooltip:DrawText(label, 5, ty, 1,1,0.8,1);
                    self.tooltip:DrawText(itemData.tooltip[key], (self.width / 2) + 12, ty, 1,1,1,1);
                    count = count + 1;
                end
            end
        end
        if KeysMod ~= nil then
            if self.item:getFullType() == "Base.Doorknob" then
                local text = nil;
                if self.item:getKeyId() ~= nil then
                    if getPlayer(0):getInventory():haveThisKeyId(self.item:getKeyId()) then
                        text = getText("Tooltip_keystate1");
                    else
                        text = getText("Tooltip_keystate2");
                    end
                end
                if text ~= nil then
                    self.item:setTooltip(text);
                end
            end
        end

        self.item:DoTooltip(self.tooltip);
    end
end

function ISToolTipInv:round2(num, idp)
  return tonumber(string.format("%." .. (idp or 0) .. "f", num))
end
