require "recipecode" --Made by Snake

function TieMTAnimal_OnCreate(items, result, player)
    local animal = nil;
    for i=0,items:size() - 1 do
        if instanceof(items:get(i), "Food") then
            animal = items:get(i);
            break;
        end
    end
    if animal then
		result:getModData().Bhung = animal:getBaseHunger();
		result:getModData().hung = animal:getHungChange();
		result:getModData().bweight = animal:getActualWeight();
		
		result:setAge(animal:getAge());
		result:setCarbohydrates(animal:getCarbohydrates());
        result:setLipids(animal:getLipids());
        result:setProteins(animal:getProteins());
        result:setCalories(animal:getCalories());
        result:setActualWeight((animal:getActualWeight() * 0.2));
        result:setWeight(result:getActualWeight());
        result:setCustomWeight(true)
    end
end

function UnTieMTAnimal_OnCreate(items, result, player)
    local animal = nil;
    for i=0,items:size() - 1 do
        if instanceof(items:get(i), "Food") then
            animal = items:get(i);
            break;
        end
    end
    if animal then
		result:setBaseHunger(animal:getModData().Bhung);
        result:setHungChange(animal:getModData().hung);
		result:setCarbohydrates(animal:getCarbohydrates());
        result:setLipids(animal:getLipids());
        result:setProteins(animal:getProteins());
        result:setCalories(animal:getCalories());
		result:setAge(animal:getAge());
        result:setActualWeight(animal:getModData().bweight);
        result:setWeight(result:getActualWeight());
        result:setCustomWeight(true);
		result:setRotten(animal:isRotten());
        player:getInventory():AddItems("Base.Rope", 4)
    end
end

function TieAnimal_TestIsValid(sourceItem, result)
    if instanceof(sourceItem, "Food") then
        return sourceItem:getActualWeight() >= 50 and sourceItem:isRotten() == false;
    end
    return true
end

function AnimalRugs_TestIsValid(sourceItem, result)
    if sourceItem:getFullType() == "Base.CowSkin" 
	  or sourceItem:getFullType() == "Base.DeerSkin" 
	  or sourceItem:getFullType() == "Base.BearSkin" then
		local data = sourceItem:getModData();
		if data.dry then
			return data.dry == 1;
		else
			return false;
		end
    end
    return true
end

function DepostarMTAnimal_OnCreate(items, result, player)
    local animal = nil;
    for i=0,items:size() - 1 do
        if instanceof(items:get(i), "Food") then
            animal = items:get(i);
            break;
        end
    end
    if animal then
		local weightchange = animal:getActualWeight();
		if animal:getType() == "ChickenDead" then
			player:getInventory():AddItems("Base.Feather", ZombRand(1,4))
			weightchange = weightchange * 0.9;
		elseif animal:getType() == "DeadCow" then
			player:getInventory():AddItem("Base.RawCowSkin")
			weightchange = weightchange - 20;
		elseif animal:getType() == "DeadDeer" then
			player:getInventory():AddItem("Base.RawDeerSkin")
			weightchange = weightchange - 15;
		elseif animal:getType() == "DeadBear" then
			player:getInventory():AddItem("Base.RawBearSkin")
			weightchange = weightchange - 30;
		else
			weightchange = weightchange * 0.9;
		end
        result:setBaseHunger(animal:getBaseHunger() + 0.02);
        result:setHungChange(animal:getBaseHunger() + 0.02);
        result:setActualWeight(weightchange)
        result:setWeight(result:getActualWeight());
        result:setCustomWeight(true)
        result:setCarbohydrates(animal:getCarbohydrates() * 0.8);
        result:setLipids(animal:getLipids() * 0.8);
        result:setProteins(animal:getProteins() * 0.8);
        result:setCalories(animal:getCalories() * 0.8);
		result:setCooked(animal:isCooked());
		result:setRotten(animal:isRotten());
		result:setBurnt(animal:isBurnt());
    end
end

function CutMTAnimal_OnCreate(items, result, player)
	local addType = "farming.Bacon"
	local addType2 = "Base.Ham"
	local addType3 = "Base.HogCasings"
	local addType4 = "Base.Tendon"
    local animal = nil;
    for i=0,items:size() - 1 do
        if instanceof(items:get(i), "Food") then
            animal = items:get(i);
            break;
        end
    end

    if animal then
--        local hunger = math.max(animal:getBaseHunger(), animal:getHungChange())
		player:getInventory():AddItem("Base.BoarHead")
        result:setBaseHunger(animal:getHungChange() / 4);
        result:setHungChange(animal:getHungChange() / 4);
        result:setActualWeight((animal:getActualWeight() * 0.9) / 55)
        result:setWeight(result:getActualWeight());
        result:setCustomWeight(true)
		result:setCooked(animal:isCooked());
		result:setRotten(animal:isRotten());
		result:setBurnt(animal:isBurnt());

		local item = InventoryItemFactory.CreateItem(addType);		
        item:setBaseHunger(animal:getHungChange() / 6);
        item:setHungChange(animal:getHungChange() / 6);
        item:setActualWeight((animal:getActualWeight() * 0.9) / 75)
        item:setWeight(result:getActualWeight());
        item:setCustomWeight(true)
		item:setCooked(animal:isCooked());
		item:setRotten(animal:isRotten());
		item:setBurnt(animal:isBurnt());
--		player:getInventory():AddItems(item, 5);
        if isServer() then
            player:sendObjectChange('addItems', { item = item, 5 })
        else
            player:getInventory():AddItems(item, 5)
        end

		local item2 = InventoryItemFactory.CreateItem(addType2);
        item2:setBaseHunger(animal:getHungChange() / 2);
        item2:setHungChange(animal:getHungChange() / 2);
        item2:setActualWeight((animal:getActualWeight() * 0.9) / 65)
        item2:setWeight(result:getActualWeight());
        item2:setCustomWeight(true)
		item2:setCooked(animal:isCooked());
		item2:setRotten(animal:isRotten());
		item2:setBurnt(animal:isBurnt());
--		player:getInventory():AddItems(item2, 2);
        if isServer() then
            player:sendObjectChange('addItems', { item2 = item2, 2})
        else
            player:getInventory():AddItems(item2, 2)
        end
		local item3 = InventoryItemFactory.CreateItem(addType3);
        item3:setBaseHunger(animal:getHungChange() / 4);
        item3:setHungChange(animal:getHungChange() / 4);
        item3:setActualWeight((animal:getActualWeight() * 0.9) / 75)
        item3:setWeight(result:getActualWeight());
        item3:setCustomWeight(true)
		item3:setCooked(animal:isCooked());
		item3:setRotten(animal:isRotten());
		item3:setBurnt(animal:isBurnt());
--		player:getInventory():AddItems(item2, 2);
        if isServer() then
            player:sendObjectChange('addItem', { item3 = item3});
        else
            player:getInventory():AddItem(item3);
        end
		local item4 = InventoryItemFactory.CreateItem(addType4);
        if isServer() then
            player:sendObjectChange('addItems', { item4 = item4, 4});
        else
            player:getInventory():AddItems(item4, 4);
        end
    end
end

function CutMTBisonAnimal_OnCreate(items, result, player)
	local addType = "Base.HogCasings"
	local addType2 = "Base.Bisonribs"
	local addType3 = "Base.Tendon"
    local animal = nil;
    for i=0,items:size() - 1 do
        if instanceof(items:get(i), "Food") then
            animal = items:get(i);
            break;
        end
    end
    if animal then
		player:getInventory():AddItem("Base.BisonHead")
--        local hunger = math.max(animal:getBaseHunger(), animal:getHungChange())
        result:setBaseHunger(animal:getHungChange() / 5);
        result:setHungChange(animal:getHungChange() / 5);
        result:setActualWeight((animal:getActualWeight() * 0.9) / 55)
        result:setWeight(result:getActualWeight());
        result:setCustomWeight(true)
		result:setCooked(animal:isCooked());
		result:setRotten(animal:isRotten());
		result:setBurnt(animal:isBurnt());

		local item = InventoryItemFactory.CreateItem(addType);		
        item:setBaseHunger(animal:getHungChange() / 6);
        item:setHungChange(animal:getHungChange() / 6);
        item:setActualWeight((animal:getActualWeight() * 0.9) / 75)
        item:setWeight(result:getActualWeight());
        item:setCustomWeight(true)
		item:setCooked(animal:isCooked());
		item:setRotten(animal:isRotten());
		item:setBurnt(animal:isBurnt());
--		player:getInventory():AddItems(item, 5);
        if isServer() then
            player:sendObjectChange('addItems', { item = item, 5 })
        else
            player:getInventory():AddItems(item, 5)
        end
		
		local item2 = InventoryItemFactory.CreateItem(addType2);		
		item2:setCooked(animal:isCooked());
		item2:setRotten(animal:isRotten());
		item2:setBurnt(animal:isBurnt());
--		player:getInventory():AddItems(item, 5);
        if isServer() then
            player:sendObjectChange('addItems', { item2 = item2, 2 })
        else
            player:getInventory():AddItems(item2, 2)
        end

		local item3 = InventoryItemFactory.CreateItem(addType3);		
        if isServer() then
            player:sendObjectChange('addItems', { item3 = item3, 4 })
        else
            player:getInventory():AddItems(item3, 4)
        end
    end
end

function CutMTCowAnimal_OnCreate(items, result, player)
	local addType = "Base.HogCasings"
	local addType2 = "Base.Cowribs"
	local addType3 = "Base.Tendon"
    local animal = nil;
    for i=0,items:size() - 1 do
        if instanceof(items:get(i), "Food") then
            animal = items:get(i);
            break;
        end
    end
    if animal then
		player:getInventory():AddItem("Base.CowHead")
--        local hunger = math.max(animal:getBaseHunger(), animal:getHungChange())
        result:setBaseHunger(animal:getHungChange() / 5);
        result:setHungChange(animal:getHungChange() / 5);
        result:setActualWeight((animal:getActualWeight() * 0.9) / 55)
        result:setWeight(result:getActualWeight());
        result:setCustomWeight(true)
		result:setCooked(animal:isCooked());
		result:setRotten(animal:isRotten());
		result:setBurnt(animal:isBurnt());

		local item = InventoryItemFactory.CreateItem(addType);		
        item:setBaseHunger(animal:getHungChange() / 6);
        item:setHungChange(animal:getHungChange() / 6);
        item:setActualWeight((animal:getActualWeight() * 0.9) / 75)
        item:setWeight(result:getActualWeight());
        item:setCustomWeight(true)
		item:setCooked(animal:isCooked());
		item:setRotten(animal:isRotten());
		item:setBurnt(animal:isBurnt());
--		player:getInventory():AddItems(item, 5);
        if isServer() then
            player:sendObjectChange('addItems', { item = item, 5 })
        else
            player:getInventory():AddItems(item, 5)
        end
		
		local item2 = InventoryItemFactory.CreateItem(addType2);		
		item2:setCooked(animal:isCooked());
		item2:setRotten(animal:isRotten());
		item2:setBurnt(animal:isBurnt());
--		player:getInventory():AddItems(item, 5);
        if isServer() then
            player:sendObjectChange('addItems', { item2 = item2, 2 })
        else
            player:getInventory():AddItems(item2, 2)
        end

		local item3 = InventoryItemFactory.CreateItem(addType3);		
        if isServer() then
            player:sendObjectChange('addItems', { item3 = item3, 6 })
        else
            player:getInventory():AddItems(item3, 6)
        end
    end
end

function CutMTMooseAnimal_OnCreate(items, result, player)
    local animal = nil;
    for i=0,items:size() - 1 do
        if instanceof(items:get(i), "Food") then
            animal = items:get(i);
            break;
        end
    end
    if animal then
--        local hunger = math.max(animal:getBaseHunger(), animal:getHungChange())
		player:getInventory():AddItem("Base.MooseHead")
        result:setBaseHunger(animal:getHungChange() / 5);
        result:setHungChange(animal:getHungChange() / 5);
        result:setActualWeight((animal:getActualWeight() * 0.9) / 55)
        result:setWeight(result:getActualWeight());
        result:setCustomWeight(true)
		result:setCooked(animal:isCooked());
		result:setRotten(animal:isRotten());
		result:setBurnt(animal:isBurnt());
    end
end

function CutMTBearAnimal_OnCreate(items, result, player)
    local animal = nil;
    for i=0,items:size() - 1 do
        if instanceof(items:get(i), "Food") then
            animal = items:get(i);
            break;
        end
    end
    if animal then
--        local hunger = math.max(animal:getBaseHunger(), animal:getHungChange())
		player:getInventory():AddItem("Base.BearHead")
        result:setBaseHunger(animal:getHungChange() / 5);
        result:setHungChange(animal:getHungChange() / 5);
        result:setActualWeight((animal:getActualWeight() * 0.9) / 55)
        result:setWeight(result:getActualWeight());
        result:setCustomWeight(true)
		result:setCooked(animal:isCooked());
		result:setRotten(animal:isRotten());
		result:setBurnt(animal:isBurnt());
    end
end

function CutMTDeerAnimal_OnCreate(items, result, player)
    local animal = nil;
	local addType = "Base.HogCasings"
	local addType2 = "Base.Tendon"
    for i=0,items:size() - 1 do
        if instanceof(items:get(i), "Food") then
            animal = items:get(i);
            break;
        end
    end
    if animal then
--        local hunger = math.max(animal:getBaseHunger(), animal:getHungChange())
--        result:setBaseHunger(animal:getHungChange() / 5);
--        result:setHungChange(animal:getHungChange() / 5);
		player:getInventory():AddItem("Base.DeerHead")
        result:setActualWeight((animal:getActualWeight() * 0.9) / 20)
        result:setWeight(result:getActualWeight());
        result:setCustomWeight(true)
		result:setCooked(animal:isCooked());
		result:setRotten(animal:isRotten());
		result:setBurnt(animal:isBurnt());

		local item = InventoryItemFactory.CreateItem(addType);		
        item:setBaseHunger(animal:getHungChange() / 6);
        item:setHungChange(animal:getHungChange() / 6);
        item:setActualWeight((animal:getActualWeight() * 0.9) / 75)
        item:setWeight(result:getActualWeight());
        item:setCustomWeight(true)
		item:setCooked(animal:isCooked());
		item:setRotten(animal:isRotten());
		item:setBurnt(animal:isBurnt());
--		player:getInventory():AddItems(item, 5);
        if isServer() then
            player:sendObjectChange('addItems', { item = item, 5 })
        else
            player:getInventory():AddItems(item, 5)
        end

		local item3 = InventoryItemFactory.CreateItem(addType2);		
        if isServer() then
            player:sendObjectChange('addItems', { item3 = item3, 6 })
        else
            player:getInventory():AddItems(item3, 6)
        end
    end
end

function CutMTChicken_OnCreate(items, result, player)
	local addType = "Base.Chickenchest"
	local addType2 = "Base.ChickenWing"
    local animal = nil;
    for i=0,items:size() - 1 do
        if instanceof(items:get(i), "Food") then
            animal = items:get(i);
            break;
        end
    end
    if animal then
--        local hunger = math.max(animal:getBaseHunger(), animal:getHungChange())
        result:setBaseHunger(animal:getHungChange() / 2);
        result:setHungChange(animal:getHungChange() / 2);
        result:setActualWeight((animal:getActualWeight() * 0.9) / 10)
        result:setWeight(result:getActualWeight());
        result:setCustomWeight(true)
		result:setCooked(animal:isCooked());
		result:setRotten(animal:isRotten());
		result:setBurnt(animal:isBurnt());

		local item = InventoryItemFactory.CreateItem(addType);		
        item:setBaseHunger(animal:getHungChange() / 2);
        item:setHungChange(animal:getHungChange() / 2);
        item:setActualWeight((animal:getActualWeight() * 0.9) / 10)
        item:setWeight(result:getActualWeight());
        item:setCustomWeight(true)
		item:setCooked(animal:isCooked());
		item:setRotten(animal:isRotten());
		item:setBurnt(animal:isBurnt());
--		player:getInventory():AddItems(item, 5);
        if isServer() then
            player:sendObjectChange('addItems', { item = item, 2 })
        else
            player:getInventory():AddItems(item, 2)
        end

		local item2 = InventoryItemFactory.CreateItem(addType2);
        item2:setBaseHunger(animal:getHungChange() / 4);
        item2:setHungChange(animal:getHungChange() / 4);
        item2:setActualWeight((animal:getActualWeight() * 0.9) / 15)
        item2:setWeight(result:getActualWeight());
        item2:setCustomWeight(true)
		item2:setCooked(animal:isCooked());
		item2:setRotten(animal:isRotten());
		item2:setBurnt(animal:isBurnt());
--		player:getInventory():AddItems(item2, 2);
        if isServer() then
            player:sendObjectChange('addItems', { item2 = item2, 2})
        else
            player:getInventory():AddItems(item2, 2)
        end
    end
end

function CutAnimal_OnCreate(items, result, player)
    local anim = nil;
    for i=0,items:size() - 1 do
        if instanceof(items:get(i), "Food") then
            anim = items:get(i);
            break;
        end
    end
    if anim then
		if anim:getType() == "DeadBird" then
			player:getInventory():AddItems("Base.Feather", ZombRand(1,3))
		end	
        result:setBaseHunger(anim:getBaseHunger() + (anim:getBaseHunger() * 50 / 100));
        result:setHungChange(anim:getBaseHunger() + (anim:getBaseHunger() * 50 / 100));
    end
end

function Cutcowribs_OnCreate(items, result, player)
    local ribs = nil;
    for i=0,items:size() - 1 do
        if instanceof(items:get(i), "Food") then
            ribs = items:get(i);
            break;
        end
    end
    if ribs then
        local hunger = math.max(ribs:getBaseHunger(), ribs:getHungChange())
        result:setBaseHunger(hunger / 4);
        result:setHungChange(hunger / 4);
        result:setActualWeight((ribs:getActualWeight() * 0.9) / 4)
        result:setWeight(result:getActualWeight());
        result:setCustomWeight(true)
        result:setCarbohydrates(ribs:getCarbohydrates() / 4);
        result:setLipids(ribs:getLipids() / 4);
        result:setProteins(ribs:getProteins() / 4);
        result:setCalories(ribs:getCalories() / 4);
        result:setCooked(ribs:isCooked());
		if result:isCooked() == true then
			result:setUnhappyChange(-5);
		end
    end
end

function OnTakesomethread_OnCreate(items,result,player)
    for i=0,items:size() - 1 do
        if items:get(i):getType() == "Skirt" then
			if ZombRand(2) == 0 then
				--nothing
			else 
				player:getInventory():AddItems("Base.ThreadPieces", ZombRand(1,4));
			end
        end
    end
end

function OnTakesometwine_OnCreate(items,result,player)
    for i=0,items:size() - 1 do
        if items:get(i):getType() == "Trousers" or items:get(i):getType() == "Blouse" then
			if ZombRand(2) == 0 then
				--nothing
			else 
				player:getInventory():AddItems("Base.String", ZombRand(1,4));
			end
        end
    end
end

function EKScarvxp1(recipe, ingredients, result, player)
    player:getXp():AddXP(Perks.PlantScavenging, 1);
end

function EKScarvxp3(recipe, ingredients, result, player)
    player:getXp():AddXP(Perks.PlantScavenging, 3);
end

function MakeSlingshot_OnCreate(items, result, player)
    if result then
		local Data = result:getModData();
		if not Data.SlingshotDurability then
			Data.SlingshotDurability = 100;
		end
	end
end