-- Made by Snake

ZAWBaseGameCharacterDetails = {}

ZAWBaseGameCharacterDetails.DoTraits = function()

	local Constexp = TraitFactory.addTrait("constructexpert", getText("UI_trait_constructexpert"), 0, getText("UI_trait_constructexpertdesc"), true);
	Constexp:getFreeRecipes():add("Make Masonry trowel");
	Constexp:getFreeRecipes():add("Make clay brick");
	Constexp:getFreeRecipes():add("Make Bucket of Concrete");
	Constexp:getFreeRecipes():add("Make ceramic");
	Constexp:getFreeRecipes():add("Make concrete brick");

	local Repexp = TraitFactory.addTrait("repairmanexpert", getText("UI_trait_repairmanexpert"), 0, getText("UI_trait_repairmanexpertdesc"), true);
	Repexp:getFreeRecipes():add("Make black metal frame");
	Repexp:getFreeRecipes():add("Make black railings");
	Repexp:getFreeRecipes():add("Advanced metal frames");
end

ZAWBaseGameCharacterDetails.DoProfessions = function()

    local constructionworker = ProfessionFactory.getProfession("constructionworker");
    constructionworker:addFreeTrait("constructexpert");

    local metalworker = ProfessionFactory.getProfession("metalworker");
    metalworker:addFreeTrait("repairmanexpert");

	local profList = ProfessionFactory.getProfessions()
	for i=1,profList:size() do
		local prof = profList:get(i-1)
		BaseGameCharacterDetails.SetProfessionDescription(prof)
	end
end

ZAWBaseGameCharacterDetails.checkstate  = function()
	local player = getSpecificPlayer(0);
	if player:getDescriptor():getProfession() == "constructionworker" then
		--Rasgos
		if not player:HasTrait("constructexpert") then
			player:getTraits():add("constructexpert");
		end
		--Recetas de constructor
		ZAWBaseGameCharacterDetails.AddconstructexpertRecipes(player);
	elseif player:getDescriptor():getProfession() == "metalworker" then
		--Rasgos
		if not player:HasTrait("repairmanexpert") then
			player:getTraits():add("repairmanexpert");
		end
		--Recetas de constructor
		ZAWBaseGameCharacterDetails.AddrepairmanexpertRecipes(player);
	end
end

function ZAWBaseGameCharacterDetails.AddconstructexpertRecipes(player)
	local plrecipe = player:getKnownRecipes();
	if not plrecipe:contains("Make Masonry trowel") then
		plrecipe:add("Make Masonry trowel");
	end
	if not plrecipe:contains("Make clay brick") then
		plrecipe:add("Make clay brick");
	end
	if not plrecipe:contains("Make Bucket of Concrete") then
		plrecipe:add("Make Bucket of Concrete");
	end
	if not plrecipe:contains("Make ceramic") then
		plrecipe:add("Make ceramic");
	end
	if not plrecipe:contains("Make concrete brick") then
		plrecipe:add("Make concrete brick");
	end
end

function ZAWBaseGameCharacterDetails.AddrepairmanexpertRecipes(player)
	local plrecipe = player:getKnownRecipes();
	if not plrecipe:contains("Make black metal frame") then
		plrecipe:add("Make black metal frame");
	end
	if not plrecipe:contains("Make black railings") then
		plrecipe:add("Make black railings");
	end
	if not plrecipe:contains("Advanced metal frames") then
		plrecipe:add("Advanced metal frames");
	end
end

Events.OnGameBoot.Add(ZAWBaseGameCharacterDetails.DoTraits);
Events.OnGameBoot.Add(ZAWBaseGameCharacterDetails.DoProfessions);
Events.OnGameStart.Add(ZAWBaseGameCharacterDetails.checkstate);